package com.gx.obe.server.common.enumeration;

import com.gx.obe.server.common.utils.ObjectUtils;
import com.gx.obe.server.common.utils.StringUtils;

public class TenderProjectEnum {
	
    public static final String REVIEW_PRICE = "01";// 完成价格评审
    public static final String REVIEW_PRICE_NO = "00";// 未价格评审

    /**
	 * 购方式00:公开招标, 01:邀请招标, 02:竞争性谈判, 03:询价, 04:单一来源, 05:比选
	 */
	public static final String GKZB = "00";//公开招标
	public static final String YQZB = "01";//邀请招标
	public static final String JZXTP = "02";//竞争性谈判
	public static final String XJ = "03";//询价
	public static final String DYLY = "04";//单一来源
//	public static final String BX = "05";
	public static final String OTHER = "05";//比选
	public static final String CONSULTATION = "06";//竞争性磋商
	public static final String PURCHASE = "07";//直接采购
	public static final String GKJB = "08";//公开竞标
	public static final String YQJB = "09";//邀请询比价
	public static final String GKXBJ = "10";//公开询比价
	public static final String YQXBJ = "11";//邀请询比价
    public static final String getTenderMethodCN(String str) {
    	String tenderMethodCN = "";
    	if(null == str || "".equals(str)){
    		tenderMethodCN = "公开招标";
    	}else if(str.equals(GKZB)){
    		tenderMethodCN = "公开招标";
    	}else if(str.equals(YQZB)){
    		tenderMethodCN = "邀请招标";
    	}else if(str.equals(JZXTP)){
    		tenderMethodCN = "竞争性谈判";
    	}else if(str.equals(XJ)){
    		tenderMethodCN = "询价";
    	}else if(str.equals(DYLY)){
    		tenderMethodCN = "单一来源";
    	}else if(str.equals(CONSULTATION)){
    		tenderMethodCN = "竞争性磋商";
    	}else if(str.equals(PURCHASE)){
    		tenderMethodCN = "直接采购";
    	}else if(str.equals(GKJB)){
    		tenderMethodCN = "公开竞标";
    	}else if(str.equals(GKXBJ)){
    		tenderMethodCN = "公开询比价";
    	}else if(str.equals(YQXBJ)){
    		tenderMethodCN = "邀请询比价";
    	}else if(str.equals(PURCHASE)){
    		tenderMethodCN = "直接采购";
    	}else {
    		tenderMethodCN = "其他";
    	}
    	return tenderMethodCN;
    }
    
    /**
     * 入围方式[00:推荐式; 01:首备选式;02:入围式]
     */
    public static final String ENTRY_TYPE_RECOMMON = "00";
    public static final String ENTRY_TYPE_FIRST_CHOICE = "01";
    public static final String ENTRY_TYPE_ENTRY = "02";
    
    public static final String getEntryTypeCn(String entryType){
    	String entryTypeCn = "";
    	if(null == entryType || entryType.equals(ENTRY_TYPE_RECOMMON)){
    		entryTypeCn = "推荐式";
    	}else if(entryType.equals(ENTRY_TYPE_FIRST_CHOICE)){
    		entryTypeCn = "首备选式";
    	}else if(entryType.equals(ENTRY_TYPE_ENTRY)){
        	entryTypeCn = "入围式";
        }
    	return entryTypeCn;
    }
    
    /**
     * 入围方式[00:综合评审;01:分组评审]
     */
    public static final String EVALWAY_COMPREHENSIVE = "00";
    public static final String EVALWAY_GROUP = "01";
    public static final String getEvalWayCn(String evalWay){
    	String evalWayCn = "综合评审";
    	if(null != evalWay && evalWay.equals(EVALWAY_GROUP)){
    		evalWayCn = "分组评审";
    	}
    	return evalWayCn;
    }
    /**
     * 阶段类型[00表示资格预审阶段 01表示招标文件阶段 默认01]
     */
    public static final String PHASE_TYPE_PRE = "00";
    public static final String PHASE_TYPE_DEFAULT = "01";
    
    /**
     * 开标类型[00一次性开标 ；01分两步开标]
     */
    public static final String BID_OPENING_ONE_STAGE = "00";
    public static final String BID_OPENING_TWO_STAGE = "01";
    /**
     * 开标分类：00:全部; 01:商务标、技术标（非经济标）；02:经济标
     */
    public static final String STAGE_ALL = "00";
    public static final String STAGE_BUS_TEC = "01";
    public static final String STAGE_PRICE = "02";

    /**
	 * 唱标状态 01:唱标; 02:强制唱标
	 */
    public static final String SIGN_DEFAULT = "01";
    public static final String SIGN_FORCE = "02";
    
    /**
     * [01:大宗;02:非大宗]
     * */
    public static final String TYPE_BIG="01";
    public static final String TYPE_NOTBIG="02";
    
    public static final String getTenderTypeCN(String str){
    	String tenderTypeCN = "非大宗";
    	if(null == str || "".equals(str) || str.equals(TYPE_NOTBIG)){
    		tenderTypeCN = "非大宗";
    	}else if(str.equals(TYPE_BIG)){
    		tenderTypeCN = "大宗";
    	}
    	return tenderTypeCN;
    }
    
    /**
     * 有效状态[01：有效；02：已废标]
     */
    public static final String EFFECTIVE_YES="01";
    public static final String EFFECTIVE_NO="02";
    
    public static final String getEffectiveCN(String str){
    	String status = "有效";
    	if(ObjectUtils.equals(EFFECTIVE_NO, str)){
    		status = "已废标";
    	}
    	return status;
    }
   
    /**
	 * 项目类型(00:其他;01:政府采购;02:土地交易;03:产权交易;04:建筑工程;05:比选)
	 */
	public static final String TENDER_YTPE_ZFCG = "01";
	public static final String TENDER_YTPE_QYCG = "02";
	public static final String TENDER_YTPE_CKQ = "03";
	public static final String TENDER_YTPE_JZGC = "04";
	public static final String TENDER_YTPE_TDJY = "05";
	public static final String TENDER_YTPE_CQJY = "06";
	public static final String TENDER_YTPE_YL = "07";
	public static final String TENDER_YTPE_QT = "00";
	public static final String TENDER_YTPE_GCJS = "11";
	public static final String TENDER_YTPE_YYWH = "12";
	public static final String TENDER_YTPE_TZJY = "13";
    public static final String getProjectTypeCN(String str) {
    	String projectTypeCN = "-";
    	if(StringUtils.isNotEmpty(str)){
    		if(StringUtils.equals(TENDER_YTPE_QYCG, str)){
        		projectTypeCN = "企业采购";
        	}else if(StringUtils.equals(TENDER_YTPE_ZFCG, str)){
        		projectTypeCN = "政府采购";
        	}else if(StringUtils.equals(TENDER_YTPE_TDJY, str)){
        		projectTypeCN = "土地使用权";
        	}else if(StringUtils.equals(TENDER_YTPE_CQJY, str)){
        		projectTypeCN = "产权交易";
        	}else if(StringUtils.equals(TENDER_YTPE_JZGC, str)){
        		projectTypeCN = "建筑工程";
        	}else if(StringUtils.equals(TENDER_YTPE_YL, str)){
        		projectTypeCN = "医疗";
        	}else if(StringUtils.equals(TENDER_YTPE_CKQ, str)){
        		projectTypeCN = "采矿权";
        	}else if(StringUtils.equals(TENDER_YTPE_GCJS, str)){
        		projectTypeCN = "工程建设";
        	}else if(StringUtils.equals(TENDER_YTPE_YYWH, str)){
        		projectTypeCN = "运营维护";
        	}else if(StringUtils.equals(TENDER_YTPE_TZJY, str)){
        		projectTypeCN = "投资经营";
        	}else {
        		projectTypeCN = "其他";
        	}
    	}
    	return projectTypeCN;
    }
    
    /**
     * 启动开标01：启动；02：未启动
     * */
    public static String START_OPENBID_Y = "01";
    public static String START_OPENBID_N = "02";
    
    /**
	 * 项目类型【01：本地项目；02：远程项目】
	 * 平台中的属性 itemType   项目立项类型     00:平台全流程项目 03:平台半流程项目@马到成功 
	 */
    public static final String LOCAL  = "01";
    public static final String REMOTE  = "02";//WHOLE_PROCESS
    public static final String HALF_PROCESS  = "03";
   
    /**
     * 评分汇总方式[00：实际打分汇总；01：去除最高分和最低分；02：按分项去除最高分最低分]
     */
    public static final String REMOVE_NORMAL = "00";
    public static final String REMOVE_MAX_MIN = "01";
    public static final String REMOVE_ITEM_MAX_MIN = "02";
    public static String getScoreCollectTypeCN(String str){
    	String scoreCollectTypeCN = "平均值";
    	if(StringUtils.isNotEmpty(str)){
    		if(str.equals(REMOVE_MAX_MIN)){
    			scoreCollectTypeCN = "去除最高、最低分后的平均值";
    		}else if(str.equals(REMOVE_ITEM_MAX_MIN)){
    			scoreCollectTypeCN = "按分项去除最高、最低分后的平均值";
    		}
    	}
    	return scoreCollectTypeCN;
    }
    
    /**
	 * 评审方式(00: 综合评审法; 01: 最低报价法；02：抽取系数法;03:合理次低价法;04:二阶段评标法;05:性价比法)
	 */
	public static final String GENERAL_METHOD = "00";
	public static final String MIN_METHOD = "01";
	public static final String EXTRACT_COEFFICIENT  = "02";
	public static final String SUB_LOW_PRICE  = "03";
	public static final String TWO_STAGE = "04";
	public static final String METHOD_COST_PERFORMANCE  = "05";
    public static final String getEvalMethodTypeCN(String str) {
    	String evalMethodTypeCN = "综合评标法";
    	if(StringUtils.isNotEmpty(str)){
    		if(str.equals(MIN_METHOD)){
    			evalMethodTypeCN = "最低报价法";
    		}else if(str.equals(EXTRACT_COEFFICIENT)){
    			evalMethodTypeCN = "抽取系数法";
    		}else if(str.equals(SUB_LOW_PRICE)){
    			evalMethodTypeCN = "合理次低价法";
    		}else if(str.equals(TWO_STAGE)){
    			evalMethodTypeCN = "二阶段评标法";
    		}else if(str.equals(METHOD_COST_PERFORMANCE)){
    			evalMethodTypeCN = "性价比法";
    		}
    	}
    	return evalMethodTypeCN;
    }
    
    /**
     * @Description: 根据项目类型，资格预审项目叫“开启”，招标项目为“开标”
     * @author guoyr
     * @param phaseType
     * @return
     */
    public static String getOpenBidEnum(String phaseType){
    	if(null != phaseType && phaseType.equals(PHASE_TYPE_PRE)){
    		return "开启";
    	}else {
    		return "开标";
    	}
    }

    /**
     * 排名优先级设置
     */
    public static final String EVALUATION_PRICE = "evaluation_price";// 最终报价
    public static final String EVAL_TOTAL_SCORE = "eval_total_score";// 汇总得分
    public static final String PRICE_SCORE = "price_score";// 价格得分
    public static final String COST_PERFORMANCE = "cost_performance";// 性价比
    
    /**
     * 系数K或R的类型
     */
	public static final String MODULUS_FIXED = "MODULUS_FIXED";// 固定系数
	public static final String MODULUS_WAIT = "MODULUS_WAIT";// 待定系数
	public static final String MODULUS_SEP = ",";// 待定系数
	
	/**
	 * 开标方式
	 */
	public static final String BIDOPENING_LOCAL = "00";//本地开标
	public static final String BIDOPENING_REMOTE = "01";// 远程开标
	public static final String BIDOPENING_ASSIST = "02";// 辅助开标
	public static final String BIDOPENING_REMOTE_FOCUS = "03";// 远程集中开标
	
	/**
	 * 评审结果参数
	 */
	public static final String EVALU_winBidType = "winBidType";
	public static final String EVALU_childrenFirm = "childrenFirm";
	public static final String EVALU_recommendReason = "recommendReason";
	public static final String EVALU_vetoBidDetail = "vetoBidDetail";
	public static final String EVALU_winnerReviewDetail = "winnerReviewDetail";
	public static final String EVALU_winnerDetail = "winnerDetail";
	public static final String EVALU_bidPriceModifyMemo = "bidPriceModifyMemo";
	public static final String EVALU_supplierProxyContent = "supplierProxyContent";
	public static final String EVALU_other = "other";
	
	//中标类型【00：最低价中标；01：次低价中标；02：最高价中标；03：次高价中标；04：中间价中标】
	public static final String TYPE_FIRST_LOW = "00";
	public static final String TYPE_SECOND_LOW = "01";
	public static final String TYPE_FIRST_HIGH = "02";
	public static final String TYPE_SECOND_HIGH = "03";
	public static final String TYPE_MIDDLE = "04";
	
	
	public static final String WINNER_NAME = "winnerName";
	public static final String WINNER_PROPERTY = "winnerProperty";
	public static final String WINNER_FOUND_TIME = "winnerFoundTime";
	public static final String WINNER_REGISTER_CAPITAL = "winnerRegisterCapital";
	public static final String WINNER_ACHIEVEMENT = "winnerAchievement";
}
