package com.gx.obe.server.common.log;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Map;
import java.util.Objects;

import javax.servlet.http.HttpServletRequest;

import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import com.gx.obe.server.common.utils.HttpHelper;
import com.gx.obe.server.common.utils.IpUtil;
import com.gx.obe.server.common.utils.NowTimeUtils;
import com.gx.obe.server.common.utils.StringUtils;
import com.gx.obe.server.common.utils.URLUtil;
import com.gx.obe.server.management.log.entity.SysLog;

import lombok.experimental.UtilityClass;
import net.sf.json.JSONObject;

@UtilityClass
public class LogUtils {
	
	public SysLog getSysLog() {
		HttpServletRequest request = ((ServletRequestAttributes) Objects.requireNonNull(RequestContextHolder.getRequestAttributes())).getRequest();
		SysLog sysLog = new SysLog();
		String username = (String) request.getHeader("createUser");
		if(StringUtils.isEmpty(username)) {
			username =  (String) request.getHeader("userName");			
		}
		sysLog.setCreateUser(username);
		sysLog.setCreateTime(NowTimeUtils.getNowDate());
		sysLog.setRemoteAddr(IpUtil.getIpAddr(request));
		sysLog.setRequestUri(URLUtil.getPath(request.getRequestURI())); 
		sysLog.setMethod(request.getMethod());
 		Map<String, String[]>  map = request.getParameterMap();
		if(null != map && map.size() > 0) {
			JSONObject jsonObject = JSONObject.fromObject(map);
			sysLog.setParams(jsonObject.toString());
		}else {
			String wholeStr = "";
			try {
				wholeStr = HttpHelper.getBodyString(request);
			} catch (IOException e) {
				e.printStackTrace();
			}
			sysLog.setParams(wholeStr);
		}
		return sysLog;
	}
	
	
	

}
