package com.gx.obe.server.common.utils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.NumberFormat;

public class NumberFormatUtils {
	private static NumberFormat df = NumberFormat.getInstance();
	private static DecimalFormat fmt = new DecimalFormat("##,###,###,###,##0.######");
	
	public static String format(double value, int round){
		df.setRoundingMode(RoundingMode.HALF_UP);
		df.setMaximumFractionDigits(round);
		return df.format(value);
	}
	
	public static String format(BigDecimal value, int round){
		if(null == value){
			return "";
		}
		df.setRoundingMode(RoundingMode.HALF_UP);
		df.setMaximumFractionDigits(round);
		return df.format(value);
	}
	public static String format(BigDecimal value){
		if(null != value){
			return fmt.format(value);
		}
		return "";
	}
	public static String format(Double value){
		if(null != value){
			return fmt.format(value);
		}
		return "";
	}
	
	
	public static void main(String[] arges){
		System.out.println(NumberFormatUtils.format(new BigDecimal(0.12344343434340000), 10));
		System.out.println(BigDecimalUtils.round(new BigDecimal(0.12340000), 10));
		System.out.println(BigDecimalUtils.div(new BigDecimal(0.12340000) , new BigDecimal(1), 10));
		
	}
}


