package com.gx.obe.server.im;

import java.io.File;
import java.util.List;

import com.gx.obe.server.management.im.entity.Message;

public interface IChatWindow {

	// public boolean isGroup();
	// public String getChatId();
	// public Group getGroup();

	public void sendToServer(String content);
	
	public String getGroupId();

	public void open();

	public void close();

	public String getOtherEmployeeId();

	public String getMyId();

	public void loadMessage(List<Message> messageList);
	 public void sendFile(final File file);
	public void receiveFile(SendFileParam params);

	/**
	 * @Description: 关闭接收文件区
	 * @author guoyr
	 */
	public void removeReceiveFile(String id);

	/**
	 * @Description: 视频加载或关闭
	 * @author guoyr
	 * @param beginReceive
	 */
	public void showVideo(final String ip, final int videoPort,
			final int auditPort);

	/**
	 * @Description: 开始接收文个把
	 * @author guoyr
	 * @param beginReceive
	 */
	public void setBeginReceive(SendFileParam params, boolean beginReceive);

	/**
	 * @Description: 显示发送文件消息
	 * @author guoyr
	 * @param msg
	 * @param isOk
	 */
	public void appendSendFileMessage(String msg, boolean isOk);

	/**
	 * @Description: 关闭文件区
	 * @author guoyr
	 */
	public void removeSendFile(String id);

	/**
	 * @Description: 取消所有接收的文件
	 * @author guoyr
	 */
	public void rejectAllReceiveFile();

	/**
	 * @Description: 取消所有接收或发送的文件
	 * @author guoyr
	 */
	public void removeAllFile();

	/**
	 * @Description: 打开视频
	 * @author guoyr
	 */
	public void openVideoComposite(final String requestIp);

	/**
	 * @Description: 关闭视频
	 * @author guoyr
	 */
	public void closeVideoComposite();

	public void addThreadId(long tid);

	/**
	 * @Description: 刷新聊天成员
	 * @author guoyr
	 */
	public void refreshGroupItem();

	/**
	 * @Description: 闪屏
	 * @author guoyr
	 */
	public void shanPing();
}
