package com.gx.obe.server.management.boq.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.boq.entity.ObeExtraTable;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeExtraTableMapper extends BaseMapper<ObeExtraTable> {

    /**
     * @param ObeExtraTableList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeExtraTableList") List<ObeExtraTable> ObeExtraTableList);

    /**
     * @param ObeExtraTableList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeExtraTableList") List<ObeExtraTable> ObeExtraTableList);

    /**
     * @param ObeExtraTable
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeExtraTable") ObeExtraTable ObeExtraTable, @Param("attributes") String[] attributes);

    /**
     * @param ObeExtraTableList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeExtraTableList") List<ObeExtraTable> ObeExtraTableList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param tenderId
     * @param supplierId
     * @return
     * @Description: 获得供应商全部其他项目清单
     * @author mazc
     */
    List<ObeExtraTable> getAllExtraTableQDList(@Param("tenderId") String tenderId, @Param("supplierId") String supplierId);

    /**
     * @param tenderId
     * @param projectCode
     * @return
     * @Description: : 获得招标项目的其他项目的清单列表
     * @author mazc
     */
    List<ObeExtraTable> getTenderProjectExtraTableQdList(@Param("tenderId") String tenderId, @Param("projectCode") String projectCode);

    /**
     * @param projectId
     * @return List<ExtraTable>
     * @Description: 根据项目Id， 获得其他项目信息。
     * @author guoyr
     */
    List<ObeExtraTable> getExtraTableListByProjectId(@Param("projectId") String projectId);

}