package com.gx.obe.server.management.boq.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.boq.entity.ObeMaterialSummary;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeMaterialSummaryMapper extends BaseMapper<ObeMaterialSummary> {

    /**
     * @param ObeMaterialSummaryList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeMaterialSummaryList") List<ObeMaterialSummary> ObeMaterialSummaryList);

    /**
     * @param ObeMaterialSummaryList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeMaterialSummaryList") List<ObeMaterialSummary> ObeMaterialSummaryList);

    /**
     * @param ObeMaterialSummary
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeMaterialSummary") ObeMaterialSummary ObeMaterialSummary, @Param("attributes") String[] attributes);

    /**
     * @param ObeMaterialSummaryList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeMaterialSummaryList") List<ObeMaterialSummary> ObeMaterialSummaryList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param projectId
     * @return List<MaterialSummary>
     * @Description: 根据工程Id，获得工料机汇总。
     * @author guoyr
     */
    List<ObeMaterialSummary> getMaterialSummaryAndChildList(@Param("projectId") String projectId);

    /**
     * @param projectId
     * @param kind      材料类型(00：其他；01：人工；02：材料；03：机械；04：主材；05：设备)
     * @return List<MaterialSummary>
     * @Description: 根据工程Id，获得指定类型的工料机汇总。
     * @author guoyr
     */
    List<ObeMaterialSummary> getMaterialSummaryList(@Param("projectId") String projectId, @Param("kind") String kind);

}