package com.gx.obe.server.management.boq.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.boq.entity.ObeRatesTable;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeRatesTableMapper extends BaseMapper<ObeRatesTable> {

    /**
     * @param ObeRatesTableList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeRatesTableList") List<ObeRatesTable> ObeRatesTableList);

    /**
     * @param ObeRatesTableList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeRatesTableList") List<ObeRatesTable> ObeRatesTableList);

    /**
     * @param ObeRatesTable
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeRatesTable") ObeRatesTable ObeRatesTable, @Param("attributes") String[] attributes);

    /**
     * @param ObeRatesTableList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeRatesTableList") List<ObeRatesTable> ObeRatesTableList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param tenderId
     * @param supplierId
     * @return
     * @Description: 获得供应商的费率列表
     */
    List<ObeRatesTable> getRatesTableList(@Param("tenderId") String tenderId, @Param("supplierId") String supplierId, @Param("projectId") String projectId, @Param("rateType") String rateType);

}