package com.gx.obe.server.management.boq.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.boq.entity.ObeSupplyMaterialDetail;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeSupplyMaterialDetailMapper extends BaseMapper<ObeSupplyMaterialDetail> {

    /**
     * @param ObeSupplyMaterialDetailList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeSupplyMaterialDetailList") List<ObeSupplyMaterialDetail> ObeSupplyMaterialDetailList);

    /**
     * @param ObeSupplyMaterialDetailList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeSupplyMaterialDetailList") List<ObeSupplyMaterialDetail> ObeSupplyMaterialDetailList);

    /**
     * @param ObeSupplyMaterialDetail
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeSupplyMaterialDetail") ObeSupplyMaterialDetail ObeSupplyMaterialDetail, @Param("attributes") String[] attributes);

    /**
     * @param ObeSupplyMaterialDetailList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeSupplyMaterialDetailList") List<ObeSupplyMaterialDetail> ObeSupplyMaterialDetailList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param projectId
     * @return
     * @Description: 根据工程项目id获取招标人供应材料设备明细列表
     * @author chenxw
     */
    List<ObeSupplyMaterialDetail> getSupplyMaterialDetailListByProjectId(@Param("projectId") String projectId);

}