package com.gx.obe.server.management.boq.service;

import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

import com.gx.obe.server.management.boq.entity.ObeBillTable;

/**
 * @author mazc
 * @Description:
 */
public interface ObeBillTableService extends IService<ObeBillTable> {

    /**
     * @param ObeBillTableList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeBillTable> ObeBillTableList);

    /**
     * @param ObeBillTableList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeBillTable> ObeBillTableList);

    /**
     * @param ObeBillTable
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeBillTable ObeBillTable, String[] attributes);

    /**
     * @param ObeBillTableList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeBillTable> ObeBillTableList, String[] attributes);

    /**
     * @param ObeBillTableList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeBillTable> ObeBillTableList, String[] attributes);

    /**
     * @param tenderId
     * @param supplierId
     * @return
     * @Description: 获得供应商全部分布分项的清单列表
     */
    List<ObeBillTable> getAllBillTableQDList(String tenderId, String supplierId);

    /**
     * @param tenderId
     * @param projectCode
     * @return
     * @Description: 获得招标项目的分布分项的清单列表
     * @author guoyr
     */
    List<ObeBillTable> getTenderProjectBillTableQdList(String tenderId, String projectCode);

    /**
     * @param projectId
     * @return
     * @Description: 获得分布分项的清单列表
     * @author guoyr
     */
    List<ObeBillTable> getBillTableQdList(String projectId);

    /**
     * @param projectId 单位工程编号
     * @return List<BillTable>
     * @Description: 根据工程项目编号"，获得分部分项信息(分布工程、清单、定额、工料机)
     * @author guoyr
     */
    List<ObeBillTable> getBillTableList(String projectId);

    /**
     * @param constructionIds
     * @return
     * @Description: 获得供应商全部分布分项的清单列表
     * @author mazc
     */
    List<ObeBillTable> getBillTableBTConstructionIdsList(List<String> constructionIds);

    /**
     * @param projectId
     * @return
     * @Description: 获得分布分项的清单和定额列表
     * @author guoyr
     */
    List<ObeBillTable> getBillTableQdAndDeList(String projectId);

}



