package com.gx.obe.server.management.boq.service;

import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

import com.gx.obe.server.management.boq.entity.ObeExtraTable;

/**
 * @author mazc
 * @Description:
 */
public interface ObeExtraTableService extends IService<ObeExtraTable> {

    /**
     * @param ObeExtraTableList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeExtraTable> ObeExtraTableList);

    /**
     * @param ObeExtraTableList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeExtraTable> ObeExtraTableList);

    /**
     * @param ObeExtraTable
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeExtraTable ObeExtraTable, String[] attributes);

    /**
     * @param ObeExtraTableList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeExtraTable> ObeExtraTableList, String[] attributes);

    /**
     * @param ObeExtraTableList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeExtraTable> ObeExtraTableList, String[] attributes);

    /**
     * @param tenderId
     * @param supplierId
     * @return
     * @Description: 获得供应商全部其他项目清单
     * @author mazc
     */
    List<ObeExtraTable> getAllExtraTableQDList(String tenderId, String supplierId);

    /**
     * @param tenderId
     * @param projectCode
     * @return
     * @Description: : 获得招标项目的其他项目的清单列表
     * @author mazc
     */
    List<ObeExtraTable> getTenderProjectExtraTableQdList(String tenderId, String projectCode);

    /**
     * @param projectId
     * @return List<ExtraTable>
     * @Description: 根据项目Id， 获得其他项目信息。
     * @author guoyr
     */
    List<ObeExtraTable> getExtraTableListByProjectId(String projectId);

}



