package com.gx.obe.server.management.boq.service;

import com.baomidou.mybatisplus.extension.service.IService;
import java.util.List;
import com.gx.obe.server.management.boq.entity.ObeMaterialSummary;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface ObeMaterialSummaryService extends IService<ObeMaterialSummary> {

 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeMaterialSummaryList 
	 */
 	Integer updateByBatch(List<ObeMaterialSummary> ObeMaterialSummaryList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeMaterialSummaryList 
	 */
	Integer insertByBatch(List<ObeMaterialSummary> ObeMaterialSummaryList);
	
	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param ObeMaterialSummary
	 * @param attributes
     */
    boolean updateAssignProperty(ObeMaterialSummary ObeMaterialSummary, String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param ObeMaterialSummaryList
	 * @param attributes
     */
    Integer batchUpdateProperty(List<ObeMaterialSummary> ObeMaterialSummaryList, String[] attributes);
	
	/** 
	 * @Description: 批量添加或跟新
	 * @author chenxw
	 * @param ObeMaterialSummaryList
	 * @param attributes
	 * @return 
	 */
    Integer batchSaveOrUpdate(List<ObeMaterialSummary> ObeMaterialSummaryList, String[] attributes);

	/**
	 * @param projectId
	 * @param kind      材料类型(00：其他；01：人工；02：材料；03：机械；04：主材；05：设备)
	 * @return List<MaterialSummary>
	 * @Description: 根据工程Id，获得指定类型的工料机汇总。
	 * @author guoyr
	 */
	List<ObeMaterialSummary> getMaterialSummaryList(String projectId, String kind);

	/**
	 * @param projectId
	 * @param kind      材料类型(00：其他；01：人工；02：材料；03：机械；04：主材；05：设备)
	 * @return List<MaterialSummary>
	 * @Description: 根据工程Id，获得指定类型的工料机汇总。
	 * @author guoyr
	 */
	ObeMaterialSummary getMaterialSummary(String projectId, String kind);

	/**
	 * @param projectId
	 * @return List<MaterialSummary>
	 * @Description: 根据工程Id，获得工料机汇总。
	 * @author guoyr
	 */
	List<ObeMaterialSummary> getMaterialSummaryAndChildList(String projectId);

}



