package com.gx.obe.server.management.boq.service;

import com.baomidou.mybatisplus.extension.service.IService;
import java.util.List;
import com.gx.obe.server.management.boq.entity.ObeProvisionalSums;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface ObeProvisionalSumsService extends IService<ObeProvisionalSums> {

 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeProvisionalSumsList 
	 */
 	Integer updateByBatch(List<ObeProvisionalSums> ObeProvisionalSumsList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeProvisionalSumsList 
	 */
	Integer insertByBatch(List<ObeProvisionalSums> ObeProvisionalSumsList);
	
	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param ObeProvisionalSums
	 * @param attributes
     */
    boolean updateAssignProperty(ObeProvisionalSums ObeProvisionalSums, String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param ObeProvisionalSumsList
	 * @param attributes
     */
    Integer batchUpdateProperty(List<ObeProvisionalSums> ObeProvisionalSumsList, String[] attributes);
	
	/** 
	 * @Description: 批量添加或跟新
	 * @author chenxw
	 * @param ObeProvisionalSumsList
	 * @param attributes
	 * @return 
	 */
    Integer batchSaveOrUpdate(List<ObeProvisionalSums> ObeProvisionalSumsList, String[] attributes);

	/**
	 * @Description:  根据工程Id，获得暂列金额
	 * @author guoyr
	 * @param projectId
	 * @return ProvisionalSums
	 */
	List<ObeProvisionalSums> getProvisionalSumsListByProjectId(String projectId);

}



