package com.gx.obe.server.management.check.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.common.vo.RequestBodyEntity;
import com.gx.obe.server.management.check.entity.CheckResult;
import com.gx.obe.server.management.check.service.CheckResultService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/checkResult")
public class CheckResultController extends BaseController<CheckResultService,CheckResult>{
	
	@Autowired
	public CheckResultService CheckResultServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeCheckResultList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<CheckResult> ObeCheckResultList) {
		return CheckResultServices.insertByBatch(ObeCheckResultList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeCheckResultList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<CheckResult> ObeCheckResultList) {
		return CheckResultServices.updateByBatch(ObeCheckResultList);
	}

	/**
	 * @Description: 保存工量清单的检查结果
	 * @author mazc
	 * @param requestBody
	 * @return 
	 */
	@PostMapping("/saveBoqCheckResult")
	public int saveBoqCheckResult(@RequestBody RequestBodyEntity<CheckResult> requestBody) {
		String tenderId= (String) requestBody.getParam("tenderId");
		String userId= (String) requestBody.getParam("userId");
		String checkItemId= (String) requestBody.getParam("checkItemId");
		List<CheckResult> checkResultList=requestBody.getEntityList();
		return CheckResultServices.saveBoqCheckResult(tenderId, userId, checkItemId, checkResultList);
	}
	
	
	/**
	 * @Description: 根据条件查询数量
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param checkItemId
	 * @return 
	 */
	@GetMapping("/getQueryCount")
	public int getQueryCount(String tenderId,String userId,String checkItemId) {
		return CheckResultServices.getQueryCount(tenderId, userId, checkItemId);
	}
	
	@GetMapping("/getCheckResultByCondition")
	public CheckResult getCheckResultByCondition(String tenderId,String userId,String supplierId ,String checkItemId,String stepId) {
		return  CheckResultServices.getCheckResultByCondition(tenderId, userId, supplierId, checkItemId, stepId);
	}

	/**
	 * @Description: 获取清单检查结果
	 * @author mazc
	 * @param requestBodyEntity
	 * @return
	 */
	@PostMapping("/getCheckResultByDictionaryValueId")
	public List<CheckResult> getCheckResultByDictionaryValueId(@RequestBody RequestBodyEntity<String> requestBodyEntity) {
		String tenderId = (String) requestBodyEntity.getParam("tenderId");
		String checkItemId = (String) requestBodyEntity.getParam("checkItemId");
		List<String> supplierIds = requestBodyEntity.getEntityList();
		return CheckResultServices.getCheckResultByDictionaryValueId(tenderId, checkItemId, supplierIds);
	}

}