package com.gx.obe.server.management.check.entity;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import lombok.Data;

/**
 * @Description:
 * @author mazc
 */
@Data
@TableName("obe_check_result")
public class CheckResult extends Model<CheckResult> {
	private static final long serialVersionUID = 1L;

	/**
	 * 检查结果主键
	 */
	@TableId("CHECK_RESULT_ID")
	private String id;
	/**
	 * 项目外键
	 */
	@TableField("TENDER_ID")
	private String tenderId;
	/**
	 * 检查项目外键
	 */
	@TableField("CHECK_ITEM_ID")
	private String checkItemId;
	/**
	 * 评审成员外键
	 */
	@TableField("USER_ID")
	private String userId;
	/**
	 * 投标人外键
	 */
	@TableField("SUPPLIER_ID")
	private String supplierId;
	/**
	 * 评标步骤外键
	 */
	@TableField("STEP_ID")
	private String stepId;
	/**
	 * 检查具体内容
	 */
	@TableField("CHECK_CONTENT")
	private String checkContent;
	/**
	 * 检查结果
	 */
	@TableField("CHECK_RESULT")
	private String checkResult;
	/**
	 * 错误数量
	 */
	@TableField("ERROR_NUM")
	private Integer errorNum;
	/**
	 * 结果
	 */
	@TableField("ACCESSMENT")
	private String accessment;

	 

	public static final String CHECK_RESULT_ID = "CHECK_RESULT_ID";

	public static final String TENDER_ID = "TENDER_ID";

	public static final String CHECK_ITEM_ID = "CHECK_ITEM_ID";

	public static final String USER_ID = "USER_ID";

	public static final String SUPPLIER_ID = "SUPPLIER_ID";

	public static final String STEP_ID = "STEP_ID";

	public static final String CHECK_CONTENT = "CHECK_CONTENT";

	public static final String CHECK_RESULT = "CHECK_RESULT";

	public static final String ERROR_NUM = "ERROR_NUM";

	public static final String ACCESSMENT = "ACCESSMENT";

	@Override
	protected Serializable pkVal() {
		return this.id;
	}

	@Override
	public String toString() {// checkResultId
		return "CheckResult{" + ", id=" + id + ", tenderId=" + tenderId + ", checkItemId=" + checkItemId + ", userId="
				+ userId + ", supplierId=" + supplierId + ", stepId=" + stepId + ", checkContent=" + checkContent
				+ ", checkResult=" + checkResult + ", errorNum=" + errorNum + ", accessment=" + accessment + "}";
	}
}
