package com.gx.obe.server.management.dictionary.controller;
import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.dictionary.entity.TemplateFile;
import com.gx.obe.server.management.dictionary.service.TemplateFileService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/templateFile")
public class TemplateFileController extends BaseController<TemplateFileService,TemplateFile>{
	@Autowired
	public TemplateFileService templateFileServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param obeTemplateFileList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<TemplateFile> obeTemplateFileList) {
		return templateFileServices.insertByBatch(obeTemplateFileList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param obeTemplateFileList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<TemplateFile> obeTemplateFileList) {
		return templateFileServices.updateByBatch(obeTemplateFileList);
	}
	
	
	/**
	 * @Description: 根据模板库 组，查询当前组下的模板信息
	 * @author mazc
	 * @param groupId
	 * @return
	 */
	@GetMapping("/getTemplateLibraryFileListByGroupID")
	public List<TemplateFile> getTemplateLibraryFileListByGroupID(String groupId) {
		return templateFileServices.getTemplateLibraryFileListByGroupID(groupId);
	}
	
	/**
	 * @Description: 根据模板库组id，文件名称，查询模板信息
	 * @author mazc
	 * @param groupId
	 * @param templateLibraryFileName
	 * @return
	 */
	@GetMapping("/getTemplateLibraryFileByFileName")
	public List<TemplateFile> getTemplateLibraryFileByFileName(String groupId, String templateFileName) {
		return templateFileServices.getTemplateLibraryFileByFileName(groupId, templateFileName);
	}
	
	/**
	 * @Description: 根据模板库组id，删除当前组 下的所有模板
	 * @author mazc	
	 * @param groupId
	 * @return
	 */
	@GetMapping("/delTemplateLibraryFileByGroupId")
	public int delTemplateLibraryFileByGroupId(String groupId){
		return templateFileServices.delTemplateLibraryFileByGroupId(groupId);
	}

	/**
	 * @Description: 根据模板id删除模板
	 * @author mazc
	 * @param id
	 * @return
	 */
	@GetMapping("/deleteTemplateLibraryFileByObjId")
	public int deleteTemplateLibraryFileByObjId(String id){
		return templateFileServices.deleteTemplateLibraryFileByObjId(id);
	}
	
	@PostMapping("/saveOrUpdateNoEmptyReturn")
	public TemplateFile saveOrUpdateNoEmptyReturn(@RequestBody TemplateFile templateFile){
		return templateFileServices.saveOrUpdateNoEmptyReturn(templateFile);
	}
}