package com.gx.obe.server.management.dictionary.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.dictionary.entity.TransactionServerEntity;
import com.gx.obe.server.management.dictionary.service.TransactionServerService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/transactionServer")
public class TransactionServerController extends BaseController<TransactionServerService,TransactionServerEntity>{
	@Autowired
	private TransactionServerService transactionServerService;

	/**
	 * @Description: 交换两个执行交易系统的排序
	 * @author mazc
	 * @param source
	 * @param target 
	 */
	@GetMapping("/changeTransactionServerSortNo")
	public boolean changeTransactionServerSortNo(String sourceSortNo, String sourceid, String targetSortNo, String targetId){
		return transactionServerService.changeTransactionServerSortNo(sourceSortNo, sourceid, targetSortNo, targetId);
	}
	
	@GetMapping("/getMaxTransactionServerSortNo")
	public int getMaxTransactionServerSortNo() {
		return transactionServerService.getMaxTransactionServerSortNo();
	}
	
	/**
	 * @Description: 获得当前平台的服务信息
	 * @author mazc
	 * @param serName
	 * @param serverAddress
	 * @return 
	 */
	@GetMapping("/getCurPlatformTransactionServer")
	public TransactionServerEntity getCurPlatformTransactionServer(String serName, String serverAddress){
		return transactionServerService.getCurPlatformTransactionServer(serName, serverAddress);
	}
	
	
	@GetMapping("/getTransactionServerEntityAllOrderBySortNo")
	public  List<TransactionServerEntity> getTransactionServerEntityAllOrderBySortNo(){
		return transactionServerService.getTransactionServerEntityAllOrderBySortNo();
	}
	
	
	
	
	/**
	 * @Description: 获得指定状态的服务
	 * @author wangxiang
	 * @param realStatus
	 * @return 
	 */
	@GetMapping("/getStatusServerOrderBySortNo")
	public List<TransactionServerEntity> getStatusServerOrderBySortNo(String realStatus) {
		return transactionServerService.getStatusServerOrderBySortNo(realStatus);
	}
	
	@PostMapping("/updateAssignProperty")
	public boolean updateAssignProperty(@RequestBody TransactionServerEntity transactionServerEntity) {
		return transactionServerService.updateAssignProperty(transactionServerEntity);
	}
	
	@PostMapping("/saveOrUpdateReturn")
	public TransactionServerEntity saveOrUpdateReturn(@RequestBody TransactionServerEntity transactionServerEntity){
		return transactionServerService.saveOrUpdateReturn(transactionServerEntity);
	}
	
	@PostMapping("/getIdList")
	public List<Object> getIdList(String serverName , String id){
		return transactionServerService.getIdList(serverName, id);
	}
	
}

