package com.gx.obe.server.management.dictionary.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.dictionary.entity.Struct;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import java.util.List;
/** 
 * @Description: 
 * @author mazc 
 */
 @Mapper
public interface StructMapper extends BaseMapper<Struct> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeStructList 
	 */
	Integer updateBatchList (@Param("ObeStructList") List<Struct> ObeStructList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeStructList 
	 */
	Integer insertByBatch (@Param("ObeStructList")List<Struct> ObeStructList);
	
	
	/**
	 * @Description: 根据供应商id和指标id获取结构化数据列表
	 * @author mazc
	 * @param tenderId
	 * @param supplierId
	 * @param factorId
	 * @return 
	 */
	List<Struct> getStructBySupplierIdAndFactorIdList(@Param("tenderId")String tenderId,@Param("supplierId") String supplierId,@Param("factorId") String factorId);


}