package com.gx.obe.server.management.dictionary.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.dictionary.entity.WorkMember;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import java.util.List;
/** 
 * @Description: 
 * @author mazc 
 */
 @Mapper
public interface WorkMemberMapper extends BaseMapper<WorkMember> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param WorkMemberList 
	 */
	Integer updateBatchList (@Param("WorkMemberList") List<WorkMember> WorkMemberList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param WorkMemberList 
	 */
	Integer insertByBatch (@Param("WorkMemberList")List<WorkMember> WorkMemberList);
	
	
	/**
	 * @Description: 返回指定类型的工作人员
	 * @author mazc
	 * @param tenderId
	 * @param workerType
	 * @return 
	 */
	List<WorkMember> getWorkerList(@Param("isParentProject")boolean isParentProject,@Param("tenderId")String tenderId, @Param("workerType")String workerType);

	 /**
	 * @Description:  返回指定项目的工作人员
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @return 
	 */
	WorkMember getWorker(@Param("tenderId")String tenderId,@Param("userId") String userId);
	
	 /**
	 * @Description: 删除工作人员
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param wokerType
	 * @return 
	 */
	Integer deleteWorker(@Param("tenderId")String tenderId, @Param("userId")String userId,@Param("wokerType") String wokerType) ;
	
	/**
	 * @Description: 删除所有工作人员
	 * @author mazc
	 * @param tenderId
	 * @param wokerType
	 * @return 
	 */
	Integer delAllWorkers(@Param("tenderId")String tenderId, @Param("wokerType")String wokerType);

	/**
	 * @Description: 根据项目ID用户id和类型获得工作人员
	 * @author wangxiang
	 * @param userId
	 * @param tenderId
	 * @param memberType
	 * @return 
	 */
	WorkMember getWorkerByUserIdAndTenderIdOrMemberType(@Param("userId")String userId,@Param("tenderId")String tenderId, @Param("wokerType")String wokerType);

	/**
	 * @Description: 删除所有工作人员
	 * @author wangxiang
	 * @param tenderId
	 * @param wokerType
	 * @param monitorType
	 * @return 
	 */
	Integer delAllWorkersByMonitorType(@Param("tenderId")String tenderId, @Param("wokerType")String wokerType,@Param("monitorType")String monitorType);
}