package com.gx.obe.server.management.dictionary.entity;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
/** 
 * @Description: 
 * @author mazc 
 */

@TableName("base_dictionary")
public class BaseDictionary extends Model<BaseDictionary> {
	private static final long serialVersionUID=1L;

    /**
     * 字典主键
     */
            @TableId("DICT_ID")
                private String id;
    /**
     * 字典名称
     */
    @TableField("DICT_NAME")
        private String dictName;
    /**
     * 字典编码
     */
    @TableField("DICT_CODE")
        private String dictCode;
    /**
     * 描述
     */
    @TableField("DESCRIPTION")
        private String description;
    /**
     * 创建时间
     */
    @TableField("CREATE_TIME")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
        private Date createTime;
    /**
     * 修改时间
     */
    @TableField("MODIFY_TIME")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
        private Date modifyTime;

	@TableField(exist = false)
	private List<BaseDictionaryValue> dictValueList = new ArrayList<BaseDictionaryValue>();


    public List<BaseDictionaryValue> getDictValueList() {
		return dictValueList;
	}

	public void setDictValueList(List<BaseDictionaryValue> dictValueList) {
		this.dictValueList = dictValueList;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getDictName(){
        return dictName;
        }

        public void setDictName(String dictName) {
        this.dictName = dictName;
        }

    public String getDictCode(){
        return dictCode;
        }

        public void setDictCode(String dictCode) {
        this.dictCode = dictCode;
        }

    public String getDescription(){
        return description;
        }

        public void setDescription(String description) {
        this.description = description;
        }

    public Date getCreateTime(){
        return createTime;
        }

        public void setCreateTime(Date createTime) {
        this.createTime = createTime;
        }

    public Date getModifyTime(){
        return modifyTime;
        }

        public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
        }

    public static final String DICT_ID ="DICT_ID";

    public static final String DICT_NAME ="DICT_NAME";

    public static final String DICT_CODE ="DICT_CODE";

    public static final String DESCRIPTION ="DESCRIPTION";

    public static final String CREATE_TIME ="CREATE_TIME";

    public static final String MODIFY_TIME ="MODIFY_TIME";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {
    return "BaseDictionary{" +
            ", id=" + id +
            ", dictName=" + dictName +
            ", dictCode=" + dictCode +
            ", description=" + description +
            ", createTime=" + createTime +
            ", modifyTime=" + modifyTime +
    "}";
    }
    }
