package com.gx.obe.server.management.evaluation.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.common.vo.RequestBodyEntity;
import com.gx.obe.server.management.evaluation.entity.EvaluationReport;
import com.gx.obe.server.management.evaluation.service.EvaluationReportService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/evaluationReport")
public class EvaluationReportController extends BaseController<EvaluationReportService,EvaluationReport>{
	@Autowired
	public EvaluationReportService evaluationReportServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeEvaluationReportList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<EvaluationReport> ObeEvaluationReportList) {
		return evaluationReportServices.insertByBatch(ObeEvaluationReportList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeEvaluationReportList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<EvaluationReport> ObeEvaluationReportList) {
		return evaluationReportServices.updateByBatch(ObeEvaluationReportList);
	}
	
	

	/**
	 * @Description: 删除专家的评标报表
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param stepId 
	 */
	@GetMapping("/deleteUserEvaluationReport")
	public boolean deleteUserEvaluationReport(String tenderId, String userId, String stepId){
		return evaluationReportServices.deleteUserEvaluationReport(tenderId, userId, stepId);
	}
	
	/**
	 * @Description: 获得专家的评标报表
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param stepId
	 * @return 
	 */
	@GetMapping("/getUserEvaluationReport")
	public EvaluationReport getUserEvaluationReport(String tenderId, String userId, String stepId){
		return evaluationReportServices.getUserEvaluationReport(tenderId, userId, stepId);
	}
	
	/** 
	 * @Description: 保存专家的评标记录
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param evaluationStepId
	 * @param reportByte
	 * @return 
	 */
	@PostMapping("/insertEvaluationReport")
	public boolean insertEvaluationReport(@RequestBody RequestBodyEntity<EvaluationReport> requestBodyEntity){
		if(null == requestBodyEntity) {
			return false;
		}
 		return evaluationReportServices.insertEvaluationReport((String)requestBodyEntity.getParam("tenderId"), (String)requestBodyEntity.getParam("userId"),
 				(String)requestBodyEntity.getParam("evaluationStepId"), requestBodyEntity.getEntity());
	 	
	}

	@GetMapping("/getEvaluationReportListByTenderId")
	public List<EvaluationReport> getEvaluationReportListByTenderId(String tenderId){
		return evaluationReportServices.getEvaluationReportListByTenderId(tenderId);
	}
	
	
}