package com.gx.obe.server.management.evaluation.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.evaluation.entity.EvaluationRoom;

 /**  
 * 
 * @author 
 * @Title: EvaluationRoom
 * @Package com.gx.obe.server.management.dictionary.entity  
 * @Description:   EvaluationRoomMapper 接口
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date:   2019-05-13   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
 @Mapper
public interface EvaluationRoomMapper extends BaseMapper<EvaluationRoom> {
	 
	 /**
	 * @Description: 获得当前评标区下的全部评标室集合
	 * @author mazc
	 * @param evaluationAreaId
	 * @return 
	 */
	List<EvaluationRoom> getEvaluatoinRoomListByEvaluationAreaId(@Param("evaluationAreaId")String evaluationAreaId);
	 
	 
	 /**
	 * @Description: 根据项目Id和评标区Id，获得已分配的评标室。
	 * @author mazc
	 * @param tenderId
	 * @param evaluationAreaId
	 * @return 
	 */
	List<EvaluationRoom> getProjectEvaluationRoomList(@Param("tenderId")String tenderId, @Param("evaluationAreaId")String evaluationAreaId);
	
	/**
	 * @Description: 删除当前评标室
	 * @author mazc
	 * @param roomId
	 * @return 
	 */
	Integer deleteEvaluationRoom(@Param("roomId")String roomId);

}