package com.gx.obe.server.management.evaluation.entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
/** 
 * @Description: 投标报价
 * @author mazc 
 */

@TableName("obe_bid_price_result")
public class BidPriceResult extends Model<BidPriceResult> {
	private static final long serialVersionUID=1L;

    /**
     * 主键
     */
	@TableId("BID_PRICE_RESULT_ID")
	private String id;
    /**
     * 项目id
     */
    @TableField("TENDER_ID")
    private String tenderId;
    /**
     * 投标报价id
     */
    @TableField("BID_PRICE_ID")
    private String bidPriceId;
    /**
     * 供应商id
     */
    @TableField("SUPPLIER_ID")
        private String supplierId;
    /**
     * 报价内容
     */
    @TableField("PRICE_CONTENT")
        private String priceContent;
    /**
     * 币种
     */
    @TableField("CURRENCY_CODE")
        private String currencyCode;
    /**
     * 币种名称
     */
    @TableField("CURRENCY_NAME")
        private String currencyName;
    /**
     * 报价单位
     */
    @TableField("PRICE_UNIT")
        private String priceUnit;

	/**
	 * 最终报价
	 */
	@TableField("FINAL_BID_PRICE")
	private BigDecimal finalBidPrice;

    @TableField("BID_PRICE")
     private BigDecimal bidPrice;
    
    @TableField("EVALUATION_PRICE")
    private BigDecimal evaluationPrice;
    
    @TableField("EVALUATION_PRICE_ORIGINAL")
    private BigDecimal evaluationPriceOriginal;
    /**
     * 报价修正记录
     */
    @TableField("EVALUATION_PRICE_CORRECT_RECORD")
        private byte[] evaluationPriceCorrectRecord;
    /**
     * 评标价修正原因
     */
    @TableField("MODIFY_REASON")
    private String modifyReason;
    
    @TableField("BID_PRICE_NAME")
    private String bidPriceName;

    @TableField(exist = false)
	private BidPrice bidPriceObj;
    
	
    @TableField(exist = false)
	private String joinTotal;
    
    @TableField(exist = false)
    private String bidPriceType;
    
    @TableField(exist = false)
    private String priceType;
    
    @TableField(exist = false)
    private String bidPriceCode;
    
    @TableField(exist = false)
    private int sortNo;
	
    /**
     * 历史报价时间
     */
    @TableField("CREATE_TIME")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
    
    
    @TableField(exist = false)
    private List<BidPriceItemResult> bidPriceItemResultList;
    
    

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

    
    public List<BidPriceItemResult> getBidPriceItemResultList() {
		return bidPriceItemResultList;
	}

	public void setBidPriceItemResultList(List<BidPriceItemResult> bidPriceItemResultList) {
		this.bidPriceItemResultList = bidPriceItemResultList;
	}

	public BidPrice getBidPriceObj() {
		return bidPriceObj;
	}

	public void setBidPriceObj(BidPrice bidPriceObj) {
		this.bidPriceObj = bidPriceObj;
	}

	public String getJoinTotal() {
		return joinTotal;
	}

	public void setJoinTotal(String joinTotal) {
		this.joinTotal = joinTotal;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getTenderId(){
		return tenderId;
	}
	
	public void setTenderId(String tenderId) {
		this.tenderId = tenderId;
	}
	
	public String getBidPriceId(){
		return bidPriceId;
	}
	
	public void setBidPriceId(String bidPriceId) {
		this.bidPriceId = bidPriceId;
	}
	
	public String getSupplierId(){
		return supplierId;
	}
	
	public void setSupplierId(String supplierId) {
		this.supplierId = supplierId;
	}
	
	public String getPriceContent(){
		return priceContent;
	}
	
	public void setPriceContent(String priceContent) {
		this.priceContent = priceContent;
	}
	
	public String getCurrencyCode(){
		return currencyCode;
	}
	
	public void setCurrencyCode(String currencyCode) {
		this.currencyCode = currencyCode;
	}
	
	public String getCurrencyName(){
		return currencyName;
	}
	
	public void setCurrencyName(String currencyName) {
		this.currencyName = currencyName;
	}
	
	public String getPriceUnit(){
		return priceUnit;
	}
	
	public void setPriceUnit(String priceUnit) {
		this.priceUnit = priceUnit;
	}
	
	public BigDecimal getBidPrice(){
		return bidPrice;
	}
	
	public void setBidPrice(BigDecimal bidPrice) {
		this.bidPrice = bidPrice;
	}
	
	public BigDecimal getFinalBidPrice() {
		return finalBidPrice;
	}

	public void setFinalBidPrice(BigDecimal finalBidPrice) {
		this.finalBidPrice = finalBidPrice;
	}

	public BigDecimal getEvaluationPrice(){
		return evaluationPrice;
	}
	
	public void setEvaluationPrice(BigDecimal evaluationPrice) {
		this.evaluationPrice = evaluationPrice;
	}
	
	public BigDecimal getEvaluationPriceOriginal(){
		return evaluationPriceOriginal;
	}
	
	public void setEvaluationPriceOriginal(BigDecimal evaluationPriceOriginal) {
		this.evaluationPriceOriginal = evaluationPriceOriginal;
	}
	
	public  byte[] getEvaluationPriceCorrectRecord(){
		return evaluationPriceCorrectRecord;
	}
	
	public void setEvaluationPriceCorrectRecord( byte[] evaluationPriceCorrectRecord) {
		this.evaluationPriceCorrectRecord = evaluationPriceCorrectRecord;
	}
	
	public String getModifyReason(){
		return modifyReason;
	}
	
	public void setModifyReason(String modifyReason) {
		this.modifyReason = modifyReason;
	}
	
	public String getBidPriceName(){
		return bidPriceName;
	}
	
	public void setBidPriceName(String bidPriceName) {
		this.bidPriceName = bidPriceName;
	}
	
	public String getBidPriceType() {
		return bidPriceType;
	}
	
	public void setBidPriceType(String bidPriceType) {
		this.bidPriceType = bidPriceType;
	}
	
	public String getPriceType() {
		return priceType;
	}
	
	public void setPriceType(String priceType) {
		this.priceType = priceType;
	}
	
	public String getBidPriceCode() {
		return bidPriceCode;
	}
	
	public void setBidPriceCode(String bidPriceCode) {
		this.bidPriceCode = bidPriceCode;
	}
	
	public int getSortNo() {
		return sortNo;
	}
	
	public void setSortNo(int sortNo) {
		this.sortNo = sortNo;
	}

	public static final String BID_PRICE_RESULT_ID ="BID_PRICE_RESULT_ID";

    public static final String TENDER_ID ="TENDER_ID";

    public static final String BID_PRICE_ID ="BID_PRICE_ID";

    public static final String SUPPLIER_ID ="SUPPLIER_ID";

    public static final String PRICE_CONTENT ="PRICE_CONTENT";

    public static final String CURRENCY_CODE ="CURRENCY_CODE";

    public static final String CURRENCY_NAME ="CURRENCY_NAME";

    public static final String CURRENCY ="CURRENCY";

    public static final String PRICE_UNIT ="PRICE_UNIT";

    public static final String ORIGINAL_BID_PRICE ="ORIGINAL_BID_PRICE";
    
    public static final String BID_PRICE ="BID_PRICE";

    public static final String EVALUATION_PRICE ="EVALUATION_PRICE";

    public static final String EVALUATION_PRICE_ORIGINAL ="EVALUATION_PRICE_ORIGINAL";

    public static final String EVALUATION_PRICE_CORRECT_RECORD ="EVALUATION_PRICE_CORRECT_RECORD";

    public static final String MODIFY_REASON ="MODIFY_REASON";

    public static final String BID_PRICE_NAME ="BID_PRICE_NAME";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {//bidPriceResultId 
    return "BidPriceResult{" +
            ", id=" + id +
            ", tenderId=" + tenderId +
            ", bidPriceId=" + bidPriceId +
            ", supplierId=" + supplierId +
            ", priceContent=" + priceContent +
            ", currencyCode=" + currencyCode +
            ", currencyName=" + currencyName +
            ", priceUnit=" + priceUnit +
            ", bidPrice=" + bidPrice +
            ", evaluationPrice=" + evaluationPrice +
            ", evaluationPriceOriginal=" + evaluationPriceOriginal +
            ", evaluationPriceCorrectRecord=" + evaluationPriceCorrectRecord +
            ", modifyReason=" + modifyReason +
            ", bidPriceName=" + bidPriceName +
    "}";
    }

}
