package com.gx.obe.server.management.evaluation.entity;

import java.io.Serializable;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
/** 
 * @Description: 
 * @author mazc 
 */

@TableName("obe_evaluation_factor_result")
public class EvaluationFactorResult extends Model<EvaluationFactorResult> {
	private static final long serialVersionUID=1L;

    /**
     * 评审节点结果主键
     */
            @TableId("FACTOR_RESULT_ID")
                private String id;
    /**
     * 步骤外键
     */
    @TableField("STEP_ID")
        private String stepId;
    /**
     * 项目外键
     */
    @TableField("TENDER_ID")
        private String tenderId;
    /**
     * 投标人外键
     */
    @TableField("SUPPLIER_ID")
        private String supplierId;
    /**
     * 评标用户外键
     */
    @TableField("USER_ID")
        private String userId;
    /**
     * 指标外键
     */
    @TableField("FACTOR_ID")
        private String factorId;
    /**
     * 指标名称
     */
    @TableField("FACTOR_NAME")
        private String factorName;
    /**
     * 系统得分
     */
    @TableField("SYSTEM_SCORE")
        private BigDecimal systemScore;
    /**
     * 评标得分
     */
    @TableField("EVALUATION_SCORE")
        private BigDecimal evaluationScore;
    /**
     * 评标实得分
     */
    @TableField("EVALUATION_FINAL_SCORE")
        private BigDecimal evaluationFinalScore;
    /**
     * 基准价
     */
    @TableField("BASE_PRICE")
        private BigDecimal basePrice;
    /**
     * 偏差率
     */
    @TableField("DEVIATION_RATE")
        private BigDecimal deviationRate;
    /**
     * 指标评审结果
     */
    @TableField("EVALUATION_RESULT")
        private String evaluationResult;
    /**
     * 评标意见
     */
    @TableField("EVALUATION_OPINION")
        private String evaluationOpinion;
    /**
     * 主材合价
     */
    @TableField("EVALUATION_PRICE")
        private BigDecimal evaluationPrice;


 

    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getStepId(){
        return stepId;
        }

        public void setStepId(String stepId) {
        this.stepId = stepId;
        }

    public String getTenderId(){
        return tenderId;
        }

        public void setTenderId(String tenderId) {
        this.tenderId = tenderId;
        }

    public String getSupplierId(){
        return supplierId;
        }

        public void setSupplierId(String supplierId) {
        this.supplierId = supplierId;
        }

    public String getUserId(){
        return userId;
        }

        public void setUserId(String userId) {
        this.userId = userId;
        }

    public String getFactorId(){
        return factorId;
        }

        public void setFactorId(String factorId) {
        this.factorId = factorId;
        }

    public String getFactorName(){
        return factorName;
        }

        public void setFactorName(String factorName) {
        this.factorName = factorName;
        }

    public BigDecimal getSystemScore(){
        return systemScore;
        }

        public void setSystemScore(BigDecimal systemScore) {
        this.systemScore = systemScore;
        }

    public BigDecimal getEvaluationScore(){
        return evaluationScore;
        }

        public void setEvaluationScore(BigDecimal evaluationScore) {
        this.evaluationScore = evaluationScore;
        }

    public BigDecimal getEvaluationFinalScore(){
        return evaluationFinalScore;
        }

        public void setEvaluationFinalScore(BigDecimal evaluationFinalScore) {
        this.evaluationFinalScore = evaluationFinalScore;
        }

    public BigDecimal getBasePrice(){
        return basePrice;
        }

        public void setBasePrice(BigDecimal basePrice) {
        this.basePrice = basePrice;
        }

    public BigDecimal getDeviationRate(){
        return deviationRate;
        }

        public void setDeviationRate(BigDecimal deviationRate) {
        this.deviationRate = deviationRate;
        }

    public String getEvaluationResult(){
        return evaluationResult;
        }

        public void setEvaluationResult(String evaluationResult) {
        this.evaluationResult = evaluationResult;
        }

    public String getEvaluationOpinion(){
        return evaluationOpinion;
        }

        public void setEvaluationOpinion(String evaluationOpinion) {
        this.evaluationOpinion = evaluationOpinion;
        }

    public BigDecimal getEvaluationPrice(){
        return evaluationPrice;
        }

        public void setEvaluationPrice(BigDecimal evaluationPrice) {
        this.evaluationPrice = evaluationPrice;
        }

    public static final String FACTOR_RESULT_ID ="FACTOR_RESULT_ID";

    public static final String STEP_ID ="STEP_ID";

    public static final String TENDER_ID ="TENDER_ID";

    public static final String SUPPLIER_ID ="SUPPLIER_ID";

    public static final String USER_ID ="USER_ID";

    public static final String FACTOR_ID ="FACTOR_ID";

    public static final String FACTOR_NAME ="FACTOR_NAME";

    public static final String SYSTEM_SCORE ="SYSTEM_SCORE";

    public static final String EVALUATION_SCORE ="EVALUATION_SCORE";

    public static final String EVALUATION_FINAL_SCORE ="EVALUATION_FINAL_SCORE";

    public static final String BASE_PRICE ="BASE_PRICE";

    public static final String DEVIATION_RATE ="DEVIATION_RATE";

    public static final String EVALUATION_RESULT ="EVALUATION_RESULT";

    public static final String EVALUATION_OPINION ="EVALUATION_OPINION";

    public static final String EVALUATION_PRICE ="EVALUATION_PRICE";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {//factorResultId
    return "EvaluationFactorResult{" +
            ", id=" + id +
            ", stepId=" + stepId +
            ", tenderId=" + tenderId +
            ", supplierId=" + supplierId +
            ", userId=" + userId +
            ", factorId=" + factorId +
            ", factorName=" + factorName +
            ", systemScore=" + systemScore +
            ", evaluationScore=" + evaluationScore +
            ", evaluationFinalScore=" + evaluationFinalScore +
            ", basePrice=" + basePrice +
            ", deviationRate=" + deviationRate +
            ", evaluationResult=" + evaluationResult +
            ", evaluationOpinion=" + evaluationOpinion +
            ", evaluationPrice=" + evaluationPrice +
    "}";
    }
    }
