package com.gx.obe.server.management.evaluation.entity;

import java.io.Serializable;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
/** 
 * @Description: 
 * @author mazc 
 */

@TableName("obe_supplier_evaluation_factor")
public class SupplierEvaluationFactor extends Model<SupplierEvaluationFactor> {
	private static final long serialVersionUID=1L;

    /**
     * 主键
     */
            @TableId("SUPPLIER_FACTOR_ID")
                private String id;
    /**
     * 项目外键
     */
    @TableField("TENDER_ID")
        private String tenderId;
    /**
     * 指标名称
     */
    @TableField("FACTOR_NAME")
        private String factorName;
    /**
     * 指标编号
     */
    @TableField("FACTOR_CODE")
        private String factorCode;
    /**
     * 指标类型
     */
    @TableField("FACTOR_TYPE")
        private String factorType;
    /**
     * 指标分值
     */
    @TableField("FACTOR_SCORE")
        private BigDecimal factorScore;
    /**
     * 指标最小分值
     */
    @TableField("FACTOR_MIN_SCORE")
        private BigDecimal factorMinScore;
    /**
     * 指标最大分值
     */
    @TableField("FACTOR_MAX_SCORE")
        private BigDecimal factorMaxScore;
    /**
     * 指标权重
     */
    @TableField("FACTOR_WEIGHT")
        private BigDecimal factorWeight;
    /**
     * 指标的最终权重
     */
    @TableField("FACTOR_FINAL_WEIGHT")
        private BigDecimal factorFinalWeight;
    /**
     * 评审类型
     */
    @TableField("AUDIT_TYPE")
        private String auditType;
    /**
     * 指标外键
     */
    @TableField("CONTAIN_ID")
        private String containId;
    /**
     * 客观项与否
     */
    @TableField("OBJECTIVE")
        private String objective;
    /**
     * 排序
     */
    @TableField("SORT_NO")
        private Integer sortNo;
    /**
     * 备注
     */
    @TableField("MEMO")
        private String memo;
    /**
     * 评分方式
     */
    @TableField("SCORE_TYPE")
        private String scoreType;
    /**
     * 评标内容
     */
    @TableField("EVAL_CONTENT")
        private String evalContent;
    /**
     * 指标父级外键
     */
    @TableField("PARENT_ID")
        private String parentId;
    /**
     * 客观范围打分项
     */
    @TableField("OBJECTIVE_ITEM")
        private byte[] objectiveItem;
    /**
     * 关联投标报价编号
     */
    @TableField("BID_PRICE_CODE")
        private String bidPriceCode;
    /**
     * 投标响应
     */
    @TableField("FACTOR_RESPONSE")
        private String factorResponse;
    /**
     * 评议意见
     */
    @TableField("OPINION")
        private String opinion;
    /**
     * 公式
     */
    @TableField("COMPUTER_PARAMS")
        private byte[] computerParams;
    /**
     * 供应商id
     */
    @TableField("SUPPLIER_ID")
        private String supplierId;
    /**
     * 评标类型[00:默认;01:商务标;02:技术标;03:综合信用]
     */
    @TableField("EVAL_BID_TYPE")
        private String evalBidType;
    /**
     * 智能打分类型
     */
    @TableField("SCORE_STATUS")
        private String scoreStatus;


 

    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getTenderId(){
        return tenderId;
        }

        public void setTenderId(String tenderId) {
        this.tenderId = tenderId;
        }

    public String getFactorName(){
        return factorName;
        }

        public void setFactorName(String factorName) {
        this.factorName = factorName;
        }

    public String getFactorCode(){
        return factorCode;
        }

        public void setFactorCode(String factorCode) {
        this.factorCode = factorCode;
        }

    public String getFactorType(){
        return factorType;
        }

        public void setFactorType(String factorType) {
        this.factorType = factorType;
        }

    public BigDecimal getFactorScore(){
        return factorScore;
        }

        public void setFactorScore(BigDecimal factorScore) {
        this.factorScore = factorScore;
        }

    public BigDecimal getFactorMinScore(){
        return factorMinScore;
        }

        public void setFactorMinScore(BigDecimal factorMinScore) {
        this.factorMinScore = factorMinScore;
        }

    public BigDecimal getFactorMaxScore(){
        return factorMaxScore;
        }

        public void setFactorMaxScore(BigDecimal factorMaxScore) {
        this.factorMaxScore = factorMaxScore;
        }

    public BigDecimal getFactorWeight(){
        return factorWeight;
        }

        public void setFactorWeight(BigDecimal factorWeight) {
        this.factorWeight = factorWeight;
        }

    public BigDecimal getFactorFinalWeight(){
        return factorFinalWeight;
        }

        public void setFactorFinalWeight(BigDecimal factorFinalWeight) {
        this.factorFinalWeight = factorFinalWeight;
        }

    public String getAuditType(){
        return auditType;
        }

        public void setAuditType(String auditType) {
        this.auditType = auditType;
        }

    public String getContainId(){
        return containId;
        }

        public void setContainId(String containId) {
        this.containId = containId;
        }

    public String getObjective(){
        return objective;
        }

        public void setObjective(String objective) {
        this.objective = objective;
        }

    public Integer getSortNo(){
        return sortNo;
        }

        public void setSortNo(Integer sortNo) {
        this.sortNo = sortNo;
        }

    public String getMemo(){
        return memo;
        }

        public void setMemo(String memo) {
        this.memo = memo;
        }

    public String getScoreType(){
        return scoreType;
        }

        public void setScoreType(String scoreType) {
        this.scoreType = scoreType;
        }

    public String getEvalContent(){
        return evalContent;
        }

        public void setEvalContent(String evalContent) {
        this.evalContent = evalContent;
        }

    public String getParentId(){
        return parentId;
        }

        public void setParentId(String parentId) {
        this.parentId = parentId;
        }

    public byte[] getObjectiveItem(){
        return objectiveItem;
        }

        public void setObjectiveItem(byte[] objectiveItem) {
        this.objectiveItem = objectiveItem;
        }

    public String getBidPriceCode(){
        return bidPriceCode;
        }

        public void setBidPriceCode(String bidPriceCode) {
        this.bidPriceCode = bidPriceCode;
        }

    public String getFactorResponse(){
        return factorResponse;
        }

        public void setFactorResponse(String factorResponse) {
        this.factorResponse = factorResponse;
        }

    public String getOpinion(){
        return opinion;
        }

        public void setOpinion(String opinion) {
        this.opinion = opinion;
        }

    public  byte[] getComputerParams(){
        return computerParams;
        }

        public void setComputerParams( byte[] computerParams) {
        this.computerParams = computerParams;
        }

    public String getSupplierId(){
        return supplierId;
        }

        public void setSupplierId(String supplierId) {
        this.supplierId = supplierId;
        }

    public String getEvalBidType(){
        return evalBidType;
        }

        public void setEvalBidType(String evalBidType) {
        this.evalBidType = evalBidType;
        }

    public String getScoreStatus(){
        return scoreStatus;
        }

        public void setScoreStatus(String scoreStatus) {
        this.scoreStatus = scoreStatus;
        }

    public static final String SUPPLIER_FACTOR_ID ="SUPPLIER_FACTOR_ID";

    public static final String TENDER_ID ="TENDER_ID";

    public static final String FACTOR_NAME ="FACTOR_NAME";

    public static final String FACTOR_CODE ="FACTOR_CODE";

    public static final String FACTOR_TYPE ="FACTOR_TYPE";

    public static final String FACTOR_SCORE ="FACTOR_SCORE";

    public static final String FACTOR_MIN_SCORE ="FACTOR_MIN_SCORE";

    public static final String FACTOR_MAX_SCORE ="FACTOR_MAX_SCORE";

    public static final String FACTOR_WEIGHT ="FACTOR_WEIGHT";

    public static final String FACTOR_FINAL_WEIGHT ="FACTOR_FINAL_WEIGHT";

    public static final String AUDIT_TYPE ="AUDIT_TYPE";

    public static final String CONTAIN_ID ="CONTAIN_ID";

    public static final String OBJECTIVE ="OBJECTIVE";

    public static final String SORT_NO ="SORT_NO";

    public static final String MEMO ="MEMO";

    public static final String SCORE_TYPE ="SCORE_TYPE";

    public static final String EVAL_CONTENT ="EVAL_CONTENT";

    public static final String PARENT_ID ="PARENT_ID";

    public static final String OBJECTIVE_ITEM ="OBJECTIVE_ITEM";

    public static final String BID_PRICE_CODE ="BID_PRICE_CODE";

    public static final String FACTOR_RESPONSE ="FACTOR_RESPONSE";

    public static final String OPINION ="OPINION";

    public static final String COMPUTER_PARAMS ="COMPUTER_PARAMS";

    public static final String SUPPLIER_ID ="SUPPLIER_ID";

    public static final String EVAL_BID_TYPE ="EVAL_BID_TYPE";

    public static final String SCORE_STATUS ="SCORE_STATUS";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {
    return "SupplierEvaluationFactor{" +
            ", id=" + id +
            ", tenderId=" + tenderId +
            ", factorName=" + factorName +
            ", factorCode=" + factorCode +
            ", factorType=" + factorType +
            ", factorScore=" + factorScore +
            ", factorMinScore=" + factorMinScore +
            ", factorMaxScore=" + factorMaxScore +
            ", factorWeight=" + factorWeight +
            ", factorFinalWeight=" + factorFinalWeight +
            ", auditType=" + auditType +
            ", containId=" + containId +
            ", objective=" + objective +
            ", sortNo=" + sortNo +
            ", memo=" + memo +
            ", scoreType=" + scoreType +
            ", evalContent=" + evalContent +
            ", parentId=" + parentId +
            ", objectiveItem=" + objectiveItem +
            ", bidPriceCode=" + bidPriceCode +
            ", factorResponse=" + factorResponse +
            ", opinion=" + opinion +
            ", computerParams=" + computerParams +
            ", supplierId=" + supplierId +
            ", evalBidType=" + evalBidType +
            ", scoreStatus=" + scoreStatus +
    "}";
    }
    }
