package com.gx.obe.server.management.evaluation.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.evaluation.entity.BidPriceItemResult;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface BidPriceItemResultService extends IService<BidPriceItemResult> {
 
	
	/**
	 * @Description: 获得分项明细结果
	 * @author mazc
	 * @param supplierId
	 * @param bidPriceId
	 * @return 
	 */
	List<BidPriceItemResult> getBidPriceItemResultList(String supplierId, String bidPriceId);
	
	
	/**
	 * @Description: 条件查询
	 * @author mazc
	 * @param tenderId
	 * @param bidPriceId
	 * @param supplierId
	 * @return 
	 */
	List<BidPriceItemResult> conditionalQueryList(String tenderId,String bidPriceId,String supplierId);
	
	
	/**
	 * @Description: 更新条目内容
	 * @author mazc
	 * @param tenderId
	 * @param bidPriceId
	 * @param bidPriceItemId
	 * @param supplierId
	 * @param itemUnit
	 * @param itemContent
	 * @param itemValue
	 * @return 
	 */
	int updateItemContent(String tenderId,String bidPriceId,String bidPriceItemId,String supplierId,String itemUnit,String itemContent,String itemValue);
	
	
	/**
	 * @Description: 批量更新或插入
	 * @author mazc
	 * @param supplierList
	 * @param attributes
	 * @return 
	 */
	Integer batchSaveOrUpdate(List<BidPriceItemResult> supplierList, String[] attributes);
}

