package com.gx.obe.server.management.evaluation.service.impl;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.common.entity.ReflecUtils;
import com.gx.obe.server.common.enumeration.CommonEnum;
import com.gx.obe.server.common.enumeration.DictEnum;
import com.gx.obe.server.common.enumeration.EvaluationFactorEnum;
import com.gx.obe.server.common.enumeration.EvaluationStepEnum;
import com.gx.obe.server.common.enumeration.TenderProjectEnum;
import com.gx.obe.server.common.utils.IDUtils;
import com.gx.obe.server.common.utils.NowTimeUtils;
import com.gx.obe.server.common.utils.ObjectUtils;
import com.gx.obe.server.common.utils.StringUtils;
import com.gx.obe.server.management.check.entity.CheckResult;
import com.gx.obe.server.management.check.service.CheckResultService;
import com.gx.obe.server.management.dictionary.entity.DictLink;
import com.gx.obe.server.management.dictionary.service.DictLinkService;
import com.gx.obe.server.management.evaluation.dao.BidPriceResultMapper;
import com.gx.obe.server.management.evaluation.dao.EvaluationFactorResultMapper;
import com.gx.obe.server.management.evaluation.dao.EvaluationStepFactorMapper;
import com.gx.obe.server.management.evaluation.dao.EvaluationStepMapper;
import com.gx.obe.server.management.evaluation.entity.BidPriceHisResult;
import com.gx.obe.server.management.evaluation.entity.BidPriceResult;
import com.gx.obe.server.management.evaluation.entity.EvaluationFactor;
import com.gx.obe.server.management.evaluation.entity.EvaluationFactorResult;
import com.gx.obe.server.management.evaluation.entity.EvaluationGroup;
import com.gx.obe.server.management.evaluation.entity.EvaluationStep;
import com.gx.obe.server.management.evaluation.entity.EvaluationStepFactor;
import com.gx.obe.server.management.evaluation.service.BidPriceHisResultService;
import com.gx.obe.server.management.evaluation.service.BidPriceResultService;
import com.gx.obe.server.management.evaluation.service.EvaluationFactorResultService;
import com.gx.obe.server.management.evaluation.service.EvaluationFactorService;
import com.gx.obe.server.management.evaluation.service.EvaluationGroupService;
import com.gx.obe.server.management.evaluation.service.EvaluationStepFactorService;
import com.gx.obe.server.management.evaluation.service.EvaluationStepService;
import com.gx.obe.server.management.expert.entity.EvaluationStepExpert;
import com.gx.obe.server.management.expert.entity.ExpertEntity;
import com.gx.obe.server.management.expert.entity.ExpertEvaluationResult;
import com.gx.obe.server.management.expert.entity.ExpertEvaluationStep;
import com.gx.obe.server.management.expert.service.EvaluationStepExpertService;
import com.gx.obe.server.management.expert.service.ExpertEvaluationResultService;
import com.gx.obe.server.management.expert.service.ExpertEvaluationStepService;
import com.gx.obe.server.management.expert.service.ExpertService;
import com.gx.obe.server.management.negotiation.service.NegotiationResultService;
import com.gx.obe.server.management.negotiation.service.NegotiationService;
import com.gx.obe.server.management.other.entity.InquireEnvelop;
import com.gx.obe.server.management.other.service.InquireEnvelopService;
import com.gx.obe.server.management.project.entity.ProjectRule;
import com.gx.obe.server.management.project.entity.TenderProject;
import com.gx.obe.server.management.project.service.ProjectRuleService;
import com.gx.obe.server.management.project.service.TenderProjectService;
import com.gx.obe.server.management.supplier.entity.Supplier;
import com.gx.obe.server.management.supplier.entity.SupplierEvaluationStep;
import com.gx.obe.server.management.supplier.service.SupplierEvaluationResultService;
import com.gx.obe.server.management.supplier.service.SupplierEvaluationStepService;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
@Transactional
public class EvaluationStepServiceImpl extends ServiceImpl<EvaluationStepMapper, EvaluationStep> implements EvaluationStepService {

	@Autowired
	private EvaluationStepMapper evaluationStepMapper;
	
	@Autowired
	private EvaluationStepService evaluationStepService;
	
	@Autowired
	private EvaluationStepFactorService evaluationStepFactorService;

	@Autowired
	private ExpertEvaluationStepService expertEvaluationStepService;
	
	@Autowired
	private SupplierEvaluationStepService  supplierEvaluationStepService;
	
	@Autowired
	private ExpertEvaluationResultService expertEvaluationResultService;
	
	@Autowired
	private EvaluationStepExpertService evaluationStepExpertService;
	
	@Autowired
	private EvaluationFactorResultService evaluationFactorResultService ;
	
	@Autowired
	private NegotiationService negotiationService;
	
	@Autowired
	private NegotiationResultService negotiationResultService;
	
	@Autowired
	private CheckResultService CheckResultService;
	
	@Autowired
	private ExpertService expertService;
	
	@Autowired
	private ProjectRuleService projectRuleService;
	
	@Autowired
	private EvaluationFactorService evaluationFactorService;
	
	@Autowired
	private DictLinkService dictLinkService;

	@Autowired
    private TenderProjectService tenderProjectService;
	
	@Autowired
	private SupplierEvaluationResultService supplierEvaluationResultService;

	private BidPriceResultService bidPriceResultService;

	private BidPriceHisResultService bidPriceHisResultService;

	private BidPriceResultMapper bidPriceResultMapper;

	private EvaluationFactorResultMapper evaluationFactorResultMapper;

	@Autowired
	private CheckResultService checkResultService;
	
	@Autowired
	private EvaluationGroupService evaluationGroupService;
	
	@Autowired
	private InquireEnvelopService inquireEnvelopService;
	
	
	/** 
	 * @Description: 通过指标获得该指标所在的评标步骤
	 * @author mazc
	 * @param tenderId
	 * @param factorId
	 * @return 
	 */
	@Override
	public EvaluationStep selectEvaluationStepByFactor(String tenderId, String factorId) {
		return evaluationStepMapper.selectEvaluationStepByFactor(tenderId, factorId);
	}

	/** 
	 * @Description: 获得评审要素下可评审的评标步骤
	 * @author mazc
	 * @param tenderId
	 * @param evalGroup
	 * @return 
	 */
	@Override
	public List<String> getEvalGroupEvalStepList(String tenderId, String evalGroup) {
		return evaluationStepMapper.findEvalGroupEvalStepList(tenderId, evalGroup);
	}

	/** 
	 * @Description:  获得指定评标步骤以前未评审的节点
	 * @author mazc
	 * @param tenderId
	 * @param sortNo
	 * @return 
	 */
	@Override
	public EvaluationStep getPreNoStarEvaluationStep(String tenderId, int sortNo) {
		return evaluationStepMapper.findPreNoStarEvaluationStep(tenderId, sortNo);
	}
	
	/** 
	 * @Description: 通过项目id删除评标步骤
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	@Override
	public int deleteStepByTenderId(String tenderId) {
		QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
		queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId);
		return evaluationStepMapper.delete(queryWrapper);
	}
	
	/**
	 * @Description: 批量保存评标步骤的指标
	 * @author mazc
	 * @param stepId
	 * @param tenderId
	 * @param factorIdsList 
	 */
	private void batchSaveEvaluationStepFactor(String stepId, String tenderId, List<Object> factorIdsList){
		List<EvaluationStepFactor> evaluationStepFactorList = new ArrayList<EvaluationStepFactor>();
		for(Object factorId : factorIdsList){
			EvaluationStepFactor nodeFactor = new EvaluationStepFactor();
			nodeFactor.setId(IDUtils.getId());
			nodeFactor.setStepId(stepId);
			nodeFactor.setFactorId((String)factorId);
			nodeFactor.setTenderId(tenderId);
			evaluationStepFactorList.add(nodeFactor);
		}
		evaluationStepFactorService.insertByBatch(evaluationStepFactorList);
	}

	@Override
	public Integer updateByBatch(List<EvaluationStep> ObeEvaluationStepList) {
		return evaluationStepMapper.updateBatchList(ObeEvaluationStepList);
	}

	@Override
	public Integer insertByBatch(List<EvaluationStep> ObeEvaluationStepList) {
		return evaluationStepMapper.insertByBatch(ObeEvaluationStepList);
	}

	/**
	 * @Description: 根据id更新指定字段
	 * @author mazc
	 * @param evaluationStep
	 * @param strs
	 * @return
	 */
	@Override
	public boolean updateAssignProperty(EvaluationStep evaluationStep, String[] attributes) {
		return evaluationStepMapper.updateAssignProperty(evaluationStep, attributes) > 0;
	}

    /** 
     * @Description: 查询评标步骤列表
     * @author chenxw
     * @param tenderId
     * @return 
     */
    @Override
    public List<EvaluationStep> getEvaluationStepList(String tenderId) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .orderByAsc(EvaluationStep::getSortNo);
        return list(queryWrapper);
    }

    /** 
     * @Description: 获得指定序号的评标步骤
     * @author chenxw
     * @param tenderId
     * @param sortNo
     * @return 
     */
    @Override
    public EvaluationStep getEvaluationStepBySortNo(String tenderId, int sortNo) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .eq(EvaluationStep::getSortNo, sortNo);
        return getOne(queryWrapper);
    }

    /** 
     * @Description: 查询指定评审类型的评标步骤列表
     * @author chenxw
     * @param tenderId
     * @param stepType
     * @return 
     */
    @Override
    public List<EvaluationStep> getEvaluationStepListByType(String tenderId, String stepType) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .eq(EvaluationStep::getStepType, stepType)
                             .orderByAsc(EvaluationStep::getSortNo);
        return list(queryWrapper);
    }

    /** 
     * @Description: 获得评标步骤的最大序号
     * @author chenxw
     * @param tenderId
     * @return 
     */
    @Override
    public int getMaxEvaluationStepSortNo(String tenderId) {
    	Integer sortNo = evaluationStepMapper.getMaxEvaluationStepSortNo(tenderId);
    	if(null ==sortNo ) {
    		sortNo = 0;
    	}
        return sortNo.intValue();
    }

    /** 
     * @Description: 交换评审结点的顺序
     * @author chenxw
     * @param sourceId
     * @param targetId
     * @return 
     */
    @Override
    public boolean changeEvaluationStepSortNo(String sourceId, String targetId) {
        return evaluationStepMapper.changeEvaluationStepSortNo(sourceId, targetId) > 0;
    }

    /** 
     * @Description: 删除评标步骤
     * @author chenxw
     * @param evaluationStep
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean deleteEvaluationStep(EvaluationStep evaluationStep) {
        // 删除当前评标步骤
    	evaluationStepMapper.deleteById(evaluationStep.getId());
    	if(evaluationStep.getStepType().equals(EvaluationStepEnum.COMPLIANCE) || evaluationStep.getStepType().equals(EvaluationStepEnum.DETAIL)){
			// 删除当前评审节的评审指标
			evaluationStepFactorService.deleteAllEvaluationStepFactor(evaluationStep.getId());

			// 删除当前评标步骤的所有评标结果
			QueryWrapper<EvaluationFactorResult> wrapper = new QueryWrapper<EvaluationFactorResult>();
			wrapper.lambda().eq(EvaluationFactorResult::getStepId , evaluationStep.getId());
			evaluationFactorResultService.remove(wrapper);
			
			// 删除当前项目下所有指定的评标专家
			QueryWrapper<EvaluationStepExpert> queryWrapper = new QueryWrapper<EvaluationStepExpert>();
			queryWrapper.lambda().eq(EvaluationStepExpert::getStepId , evaluationStep.getId());
			evaluationStepExpertService.remove(queryWrapper);
			
		} else if (evaluationStep.getStepType().equals(EvaluationStepEnum.PRE_EVALUATION)) {
			// 删除当前项目下所有指定的评标专家
			QueryWrapper<EvaluationGroup> wrapperGroup = new QueryWrapper<EvaluationGroup>();
			wrapperGroup.lambda().eq(EvaluationGroup::getStepId , evaluationStep.getId());
			evaluationGroupService.remove(wrapperGroup);
		}
    	
		// 删除为评审成员分配的评标步骤
		QueryWrapper<ExpertEvaluationStep> wrapperExpertStep = new QueryWrapper<ExpertEvaluationStep>();
		wrapperExpertStep.lambda().eq(ExpertEvaluationStep::getStepId , evaluationStep.getId());
		expertEvaluationStepService.remove(wrapperExpertStep);

		// 删除为投标人分配的评标步骤
		QueryWrapper<SupplierEvaluationStep> wrapperSupplierStep = new QueryWrapper<SupplierEvaluationStep>();
		wrapperSupplierStep.lambda().eq(SupplierEvaluationStep::getStepId , evaluationStep.getId());
		supplierEvaluationStepService.remove(wrapperSupplierStep);

		// 删除当前评标步骤专家为投标人的评标结果
		QueryWrapper<ExpertEvaluationResult> wrapperExpertResult = new QueryWrapper<ExpertEvaluationResult>();
		wrapperExpertResult.lambda().eq(ExpertEvaluationResult::getStepId , evaluationStep.getId());
		expertEvaluationResultService.remove(wrapperExpertResult);
		
		// 删除询标函
		QueryWrapper<InquireEnvelop> wrapper1= new QueryWrapper<InquireEnvelop>();
		wrapper1.lambda().eq(InquireEnvelop::getStepId, evaluationStep.getId());
		inquireEnvelopService.remove(wrapper1);
		
		if (evaluationStep.getStepType().equals(EvaluationStepEnum.CLEAN_TENDER) || evaluationStep.getStepType().equals(EvaluationStepEnum.FEATURE_CHECK)) {

			// 先删检查结果
			QueryWrapper<CheckResult> wrapper2= new QueryWrapper<CheckResult>();
			wrapper2.lambda().eq(CheckResult::getStepId, evaluationStep.getId());
			checkResultService.remove(wrapper2);

			// 删除与数据字典的关联表
			QueryWrapper<DictLink> wrapper3= new QueryWrapper<DictLink>();
			wrapper3.lambda().eq(DictLink::getStepId, evaluationStep.getId());
			dictLinkService.remove(wrapper3);
		}
    	
    	
        // 为了保证评标步骤顺序的正确性，全部重新进行排序
        List<EvaluationStep> resultList = getEvaluationStepList(evaluationStep.getTenderId());
        if (null != resultList && resultList.size() > 0) {
            int sortNo = 1;
            for (EvaluationStep node : resultList) {
                node.setSortNo(sortNo++);
                // 指定只修改排序
                updateAssignProperty(node, new String[] { "sortNo" });
            }
        }
        return true;
    }

    /** 
     * @Description: 保存签到评标步骤
     * @author chenxw
     * @param evaluationStep
     * @return 
     */
    @Override
    public EvaluationStep saveSignEvaluationStep(EvaluationStep evaluationStep) {
        evaluationStep.setSortNo(1);
        if (StringUtils.isEmpty(evaluationStep.getId())) {
            evaluationStep.setId(IDUtils.getId());
            evaluationStepMapper.insert(evaluationStep);
        } else {
            evaluationStepMapper.updateById(evaluationStep);
        }
        return evaluationStep;
    }

    /** 
     * @Description: 保存特征码检查评标步骤
     * @author chenxw
     * @param evaluationStep
     * @param stepExpertUserList
     * @param featureItemObjIdList
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public EvaluationStep saveFeatureEvaluationStep(EvaluationStep evaluationStep, List<String> stepExpertUserList, List<String> featureItemObjIdList) {
        if(StringUtils.isEmpty(evaluationStep.getId())){
            evaluationStep.setId(IDUtils.getId());
            evaluationStepMapper.insert(evaluationStep);
        }else {
            updateIgnoreProperty(evaluationStep, new String[]{"stepStatus"});
        }
        
        evaluationStepExpertService.setCustomeExpert(evaluationStep, stepExpertUserList);
        dictLinkService.deleteFeatureCheckItem(evaluationStep.getTenderId());
        List<DictLink> dictLinkList = new ArrayList<DictLink>();
        for(String dictId : featureItemObjIdList){
            DictLink dictLink = new DictLink();
            dictLink.setId(IDUtils.getId());
            dictLink.setDictId(dictId);
            dictLink.setLinkCode(DictEnum.FEATURE);
            dictLink.setStepId(evaluationStep.getId());
            dictLink.setTenderId(evaluationStep.getTenderId());
            dictLinkList.add(dictLink);
        }
        dictLinkService.insertByBatch(dictLinkList);
        return evaluationStep;
    }

    /**
     * @Description: 忽略列修改
     * @author chenxw
     * @param evaluationStep
     * @param strings 
     */
    private int updateIgnoreProperty(EvaluationStep evaluationStep, String[] strings) {
        ReflecUtils.ignore(evaluationStep, strings);
        return evaluationStepMapper.updateById(evaluationStep);
    }

    /** 
     * @Description: 保存清标检查评标步骤
     * @author chenxw
     * @param evaluationStep
     * @param stepExpertUserList
     * @param cleanTenderItemObjIdList
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public EvaluationStep saveCleanTenderEvaluationStep(EvaluationStep evaluationStep, List<String> stepExpertUserList, List<String> cleanTenderItemObjIdList) {
        if(StringUtils.isEmpty(evaluationStep.getId())){
            evaluationStep.setId(IDUtils.getId());
            evaluationStepMapper.insert(evaluationStep);
        }else {
            evaluationStepMapper.updateById(evaluationStep);
        }
        evaluationStepExpertService.setCustomeExpert(evaluationStep, stepExpertUserList);
        dictLinkService.deleteFeatureCheckItem(evaluationStep.getTenderId());
        List<DictLink> dictLinkList = new ArrayList<DictLink>();
        for(String dictId : cleanTenderItemObjIdList){
            DictLink dictLink = new DictLink();
            dictLink.setId(IDUtils.getId());
            dictLink.setDictId(dictId);
            dictLink.setLinkCode(DictEnum.CLEAN_TENDER);
            dictLink.setStepId(evaluationStep.getId());
            dictLink.setTenderId(evaluationStep.getTenderId());
            dictLinkList.add(dictLink);
        }
        dictLinkService.insertByBatch(dictLinkList);
        return evaluationStep;
    }

    /** 
     * @Description: 保存评标步骤和评审指标
     * @author chenxw
     * @param evaluationStep
     * @param evaluationFactorList
     * @param factorWeightList
     * @param stepExpertUserList
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public EvaluationStep saveEvaluationStepAndFactors(EvaluationStep evaluationStep, List<EvaluationFactor> evaluationFactorList, List<String> factorWeightList, List<String> stepExpertUserList) {
        if(StringUtils.isEmpty(evaluationStep.getId())){
            evaluationStep.setId(IDUtils.getId());
            evaluationStepMapper.insert(evaluationStep);
        }else {
            updateIgnoreProperty(evaluationStep, new String[]{"stepStatus"});
            // 删除当前评标步骤所有的评审指标
            evaluationStepFactorService.deleteAllEvaluationStepFactor(evaluationStep.getId());
        }
        evaluationStepExpertService.setCustomeExpert(evaluationStep, stepExpertUserList);
        // 保存评标步骤的所有评审指标
        List<EvaluationStepFactor> evaluationStepFactorList = new ArrayList<EvaluationStepFactor>();
        for (EvaluationFactor factor : evaluationFactorList) {
            if (null != factor) {
                EvaluationStepFactor evaluationStepFactor = new EvaluationStepFactor();
                evaluationStepFactor.setId(IDUtils.getId());
                evaluationStepFactor.setStepId(evaluationStep.getId());
                evaluationStepFactor.setFactorId(factor.getId());
                evaluationStepFactor.setTenderId(factor.getTenderId());
                evaluationStepFactorList.add(evaluationStepFactor);
                if (null != factorWeightList && factorWeightList.contains(factor.getId())) {
                    evaluationStepFactor.setUseWeight(CommonEnum.YES);
                    
                }
                // 如果存在包含指标，且不是浮动指标
                if (null != factor.getContainFactor() && !ObjectUtils.equals(factor.getFactorType(), EvaluationFactorEnum.FACTOR_FLOAT)) {
                    EvaluationStepFactor factorEvaluationStepFactor = new EvaluationStepFactor();
                    factorEvaluationStepFactor.setId(IDUtils.getId());
                    factorEvaluationStepFactor.setStepId(evaluationStep.getId());
                    factorEvaluationStepFactor.setFactorId(factor.getContainFactor().getId());
                    factorEvaluationStepFactor.setTenderId(factor.getContainFactor().getTenderId());
                    evaluationStepFactorList.add(factorEvaluationStepFactor);
                }
            }
        }
        // 批量保存
        evaluationStepFactorService.insertByBatch(evaluationStepFactorList);
        return evaluationStep;
    }
    
    @Override
    @Transactional(rollbackFor = Exception.class)
    public EvaluationStep saveTianYanEvaluationStep(EvaluationStep evaluationStep,  List<String> stepExpertUserList) {
        if(StringUtils.isEmpty(evaluationStep.getId())){
            evaluationStep.setId(IDUtils.getId());
            evaluationStepMapper.insert(evaluationStep);
        }else {
            updateIgnoreProperty(evaluationStep, new String[]{"stepStatus","evaluationOpinion"});
        }
        evaluationStepExpertService.setCustomeExpert(evaluationStep, stepExpertUserList);
        return evaluationStep;
    }

    /** 
     * @Description: 保存评标步骤
     * @author chenxw
     * @param evaluationStep
     * @return 
     */
    @Override
    public EvaluationStep saveEvaluationStep(EvaluationStep evaluationStep) {
        if (StringUtils.isEmpty(evaluationStep.getId())) {
            evaluationStep.setId(IDUtils.getId());
            evaluationStepMapper.insert(evaluationStep);
        } else {
            if (evaluationStepMapper.updateById(evaluationStep) == 0) {
                evaluationStep = null;
            }
        }
        return evaluationStep;
    }

    /** 
     * @Description: 创建废标步骤
     * @author chenxw
     * @param tenderProjectEntity
     * @param evaluationStep
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public EvaluationStep saveWasteBidStep(TenderProject tenderProjectEntity, EvaluationStep evaluationStep) {
        boolean isNew = true;
        if(null != evaluationStep.getId()){
            isNew = false;
            expertEvaluationStepService.deleteExpertEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
            expertEvaluationResultService.deleteExpertEvaluationResult(evaluationStep.getTenderId(), evaluationStep.getId());
        }else {
            evaluationStep.setId(IDUtils.getId());
            Integer maxComplate =  evaluationStepMapper.getMAXStepCount(tenderProjectEntity.getId(), CommonEnum.COMPLETE);  
            maxComplate = (maxComplate == null) ? 0 : maxComplate ;
            if (maxComplate == 0) {
            	maxComplate++;
            }
            evaluationStep.setSortNo(maxComplate + 1);
           evaluationStepMapper.updateSortNo(tenderProjectEntity.getId(),maxComplate);
        }
        
        if(evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_WASTE_NEED_VOTE, Boolean.class)){
            tenderProjectEntity.setEffectiveType(TenderProjectEnum.EFFECTIVE_YES);
            evaluationStep.setStepStatus(CommonEnum.NOT_START);
        } else {
            tenderProjectEntity.setEffectiveType(TenderProjectEnum.EFFECTIVE_NO);
            evaluationStep.setStepStatus(CommonEnum.COMPLETE);
            // 废标时每个专家都要看到废标意见，因此为每个专家生成一个已完成的结果
            List<ExpertEntity> expertList = expertService.getExpertList(tenderProjectEntity.getId(), null);
            if(null != expertList && expertList.size() > 0){
                List<ExpertEvaluationStep> expertEvaluationStepList = new ArrayList<ExpertEvaluationStep>();
                for(ExpertEntity expert : expertList){
                    Date nowDate = NowTimeUtils.getNowDate();
                    ExpertEvaluationStep expertEvaluationStep = new ExpertEvaluationStep();
                    expertEvaluationStep.setId(IDUtils.getId());
                    expertEvaluationStep.setStartTime(nowDate);
                    expertEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
                    expertEvaluationStep.setTenderId(tenderProjectEntity.getId());
                    expertEvaluationStep.setStepId(evaluationStep.getId());
                    expertEvaluationStep.setUserId(expert.getUserId());
                    expertEvaluationStep.setEndTime(nowDate);
                    expertEvaluationStepList.add(expertEvaluationStep);
                }
                expertEvaluationStepService.insertByBatch(expertEvaluationStepList);
            }
        }
        if(isNew){
            evaluationStepMapper.insert(evaluationStep);
        }else {
            evaluationStepMapper.updateById(evaluationStep);
        }
        tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[] {"effectiveType", "effectiveMemo"});
        
        return evaluationStep;
    }

    /** 
     * @Description: 验证评标步骤的名称是否已经存在
     * @author chenxw
     * @param tenderId
     * @param stepId
     * @param stepName
     * @return 
     */
    @Override
    public boolean valEvaluationStepNameExist(String tenderId, String stepId, String stepName) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .eq(EvaluationStep::getStepName, stepName);
        if (StringUtils.isNotEmpty(stepId)) {
            queryWrapper.lambda().ne(EvaluationStep::getId, stepId);
        }
        return count(queryWrapper) > 0;
    }

    /** 
     * @Description: 设置默认评标步骤
     * @author chenxw
     * @param tenderId
     * @param siginStepName
     * @param complianceStepName
     * @param detailStepName
     * @param priceStepName
     * @param recommonedStepName
     * @param SHOW_SUMMARY_COMPLIANCE
     * @param SHOW_SUMMARY_SCORE
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createDefaultEvaluationSteps(String tenderId, String siginStepName, String complianceStepName, String detailStepName, String priceStepName, String recommonedStepName, String SHOW_SUMMARY_COMPLIANCE, String SHOW_SUMMARY_SCORE) {
        int count = 0;
        // 先清除所有的评标步骤
        deleteAllEvaluationSteps(tenderId);
        
        ProjectRule projectRule = projectRuleService.findProjectRuleByTenderId(tenderId);
        if (null == projectRule) projectRule = new ProjectRule();
        
        // 先清除所有为评标步骤自定义的评标专家
        evaluationStepExpertService.deleteStepByTenderId(tenderId);
        
        List<EvaluationStep> nodeList = new ArrayList<EvaluationStep>();
        int sortNo = 1;
        // 添加签到节点
        nodeList.add(EvaluationStep.initEvaluationStep(IDUtils.getId(), siginStepName, tenderId, EvaluationStepEnum.SIGIN, sortNo++, SHOW_SUMMARY_COMPLIANCE, SHOW_SUMMARY_SCORE));
        
        // 如果存在符合性评审指标才添加添加符合性评审节点
        List<Object> factorIdsList = evaluationFactorService.getFactorIdList(tenderId, EvaluationFactorEnum.AUDIT_COMPLIANCE);
        if (null != factorIdsList && factorIdsList.size() > 0) {
            String complianceStepId = IDUtils.getId();
            nodeList.add(EvaluationStep.initEvaluationStep(complianceStepId, complianceStepName, tenderId, EvaluationStepEnum.COMPLIANCE, sortNo++, SHOW_SUMMARY_COMPLIANCE, SHOW_SUMMARY_SCORE));
            
            // 批量保存符合性评审节点的评审指标
            batchSaveEvaluationStepFactor(complianceStepId, tenderId, factorIdsList);
        }
        
        // 如果不是最低报价法则，才能生成打分评审和价格评审
        if (!ObjectUtils.equals(projectRule.getEvalMethodType(), TenderProjectEnum.MIN_METHOD)) {
            
            // 如果存在打分评审指标才添加添加符合性评审节点
            List<Object> detailFactorIdsList = evaluationFactorService.getFactorIdList(tenderId, EvaluationFactorEnum.AUDIT_SCORE);
            if (null != detailFactorIdsList && detailFactorIdsList.size() > 0) {
                String detailStepId = IDUtils.getId();
                nodeList.add(EvaluationStep.initEvaluationStep(detailStepId, detailStepName, tenderId, EvaluationStepEnum.DETAIL, sortNo++, SHOW_SUMMARY_COMPLIANCE, SHOW_SUMMARY_SCORE));
                
                // 批量保存打分评审节点的评审指标
                batchSaveEvaluationStepFactor(detailStepId, tenderId, detailFactorIdsList);
            }
            
            // 如果不是二阶段评标法才能生成价格评审
//            if (!ObjectUtils.equals(projectRule.getEvalMethodType(), TenderProjectEnum.TWO_STAGE)) {
                
                // 如果有价格指标才添加价格节点
                EvaluationFactor priceEvaluationFactor = evaluationFactorService.getPriceEvaluationFactor(tenderId);
                if (null != priceEvaluationFactor) {
                    nodeList.add(EvaluationStep.initEvaluationStep(IDUtils.getId(), priceStepName, tenderId, EvaluationStepEnum.PRICE, sortNo++, SHOW_SUMMARY_COMPLIANCE, SHOW_SUMMARY_SCORE));
                }
//            }
        }
        
        // 添加推荐节点
        nodeList.add(EvaluationStep.initEvaluationStep(IDUtils.getId(), recommonedStepName, tenderId, EvaluationStepEnum.RECOMMONED, sortNo++, SHOW_SUMMARY_COMPLIANCE, SHOW_SUMMARY_SCORE));
        count = evaluationStepMapper.insertByBatch(nodeList);
        return count > 0;
    }

    /** 
     * @Description: 设置默认评标步骤
     * @author chenxw
     * @param tenderId
     * @param nodeList
     * @param evaluationStepFactorList
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createDefaultEvaluationSteps(String tenderId, List<EvaluationStep> nodeList, List<EvaluationStepFactor> evaluationStepFactorList) {
        // 先清除所有为评标步骤自定义的评标专家
        evaluationStepExpertService.deleteStepByTenderId(tenderId);
        
        //删除清标数据
        QueryWrapper<EvaluationGroup> wrapperGroup = new QueryWrapper<EvaluationGroup>();
		wrapperGroup.lambda().eq(EvaluationGroup::getTenderId , tenderId);
		evaluationGroupService.remove(wrapperGroup);
        
        // 先清除所有的评标步骤
        deleteAllEvaluationSteps(tenderId);
        for(EvaluationStep step : nodeList ) {
        	if(null == step.getId()){
        		step.setId(IDUtils.getId());
        	}
        }
        int count = evaluationStepMapper.insertByBatch(nodeList);
        if (null != evaluationStepFactorList && evaluationStepFactorList.size() > 0) {
            evaluationStepFactorService.insertByBatch(evaluationStepFactorList);
        }
        return count > 0;
    }

    /** 
     * @Description: 清空项目的评标步骤
     * @author chenxw
     * @param tenderId
     * @return 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean deleteAllEvaluationSteps(String tenderId) {
        evaluationStepFactorService.deleteStepFactorByTenderId(tenderId);
        deleteStepByTenderId(tenderId);
        expertEvaluationStepService.deleteStepByTenderId(tenderId);
        supplierEvaluationStepService.deleteStepByTenderId(tenderId);
        expertEvaluationResultService.deleteStepByTenderId(tenderId);
        evaluationStepExpertService.deleteStepByTenderId(tenderId);
        evaluationFactorResultService.deleteStepByTenderId(tenderId);
        negotiationService.deleteStepByTenderId(tenderId);
        negotiationResultService.deleteStepByTenderId(tenderId);
        CheckResultService.deleteStepByTenderId(tenderId);
        expertService.updateSignType(null, tenderId);
        return true;
    }

    /** 
     * @Description: 
     * @author chenxw
     * @param evaluationStep
     * @param expertEvaluationStep 
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void reBackEvaluationStep(EvaluationStep evaluationStep, String userId) {
        boolean isFilter = ObjectUtils.equals(evaluationStep.getFilterType(), EvaluationStepEnum.FILTER_YES);
        evaluationStepMapper.reBackEvaluationStep(
                    evaluationStep.getTenderId(),
                    evaluationStep.getSortNo(),
                    isFilter,
                    CommonEnum.RE_OPERATOR,
                    EvaluationStepEnum.RECOMMONED,
                    CommonEnum.COMPLETE,
                    CommonEnum.IN_PROGRESS,
                    EvaluationStepEnum.PRICE
                );
        UpdateWrapper<TenderProject> updateWrapper = new UpdateWrapper<TenderProject>();
        updateWrapper.lambda().set(TenderProject::getComplateStatus, CommonEnum.RE_OPERATOR).set(TenderProject::getUploadEvaluationResultStatus, CommonEnum.NO)
                              .eq(TenderProject::getId, evaluationStep.getTenderId());
        tenderProjectService.update(updateWrapper);
        expertEvaluationStepService.reBackExpertEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId(), evaluationStep.getSortNo(), isFilter, userId);
        supplierEvaluationStepService.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
        supplierEvaluationResultService.clearSupplierEvaluationResult(evaluationStep);
    }

    /** 
     * @Description: 获得最后一个评标步骤
     * @author chenxw
     * @param tenderId
     * @return 
     */
    @Override
    public EvaluationStep getLastEvaluationStep(String tenderId) {
        return evaluationStepMapper.getLastEvaluationStep(tenderId);
    }

    /** 
     * @Description: 获得存在评审不通过投标人的评标步骤
     * @author chenxw
     * @param tenderId
     * @return 
     */
    @Override
    public List<EvaluationStep> getDisAccessmentNode(String tenderId) {
        return evaluationStepMapper.getDisAccessmentNode(tenderId, EvaluationStepEnum.UNQUALIFIED, EvaluationStepEnum.FILTER_YES);
    }

    /** 
     * @Description: 通过指标获得该指标所在的评标步骤
     * @author chenxw
     * @param tenderId
     * @param factorId
     * @return 
     */
    @Override
    public EvaluationStep getEvaluationStepByFactor(String tenderId, String factorId) {
        return evaluationStepMapper.getEvaluationStepByFactor(tenderId, factorId);
    }

    /** 
     * @Description: 验证评标步骤是否正在评标步骤中被退回
     * @author chenxw
     * @param evaluationStep
     * @return 
     */
    @Override
    public boolean isEvaluationStepRebackedInProgress(EvaluationStep evaluationStep) {
        // 如果当前已经是退回节点，则不做处理
        if (ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
            return false;
        }
        // 如果当前评标步骤不是退回节点，则在提交时验证一下，现在评标步骤是否被改为退回了
        EvaluationStep queryEvaluationStep = evaluationStepMapper.selectById(evaluationStep);
        // 如果当前节点状态为已退回，则认为在评标步骤中被退回（需要对正在评审的专家进行处理）
        return CommonEnum.RE_OPERATOR.equals(queryEvaluationStep.getStepStatus());
    }

    /** 
     * @Description: 获得评标步骤的权重
     * @author chenxw
     * @param evaluationStep
     * @return 
     */
    @Override
    public BigDecimal getEvaluationStepWeight(EvaluationStep evaluationStep) {
        QueryWrapper<EvaluationStepFactor> queryWrapper = new QueryWrapper<EvaluationStepFactor>();
        queryWrapper.lambda().eq(EvaluationStepFactor::getTenderId, evaluationStep.getTenderId())
                             .eq(EvaluationStepFactor::getStepId, evaluationStep.getId());
        BigDecimal weight = null;
        if (evaluationStepFactorService.count(queryWrapper) > 0) {
            weight = evaluationFactorService.getWeightByStepId(evaluationStep.getTenderId(), evaluationStep.getId());
        } else {
            if (evaluationStep.getStepType().equals(EvaluationStepEnum.PRICE)) {
                weight = evaluationFactorService.getWeightByAuditType(evaluationStep.getTenderId(), EvaluationFactorEnum.AUDIT_PRICE);
            } else {
                weight = evaluationFactorService.getWeightByAuditType(evaluationStep.getTenderId(), EvaluationFactorEnum.AUDIT_SCORE);
            }
        }
        return weight;
    }

    /** 
     * @Description: 获得评标步骤的分值
     * @author chenxw
     * @param evaluationStep
     * @param weightScore
     * @return 
     */
    @Override
    public BigDecimal getEvaluationStepScore(EvaluationStep evaluationStep, boolean weightScore) {
        QueryWrapper<EvaluationStepFactor> queryWrapper = new QueryWrapper<EvaluationStepFactor>();
        queryWrapper.lambda().eq(EvaluationStepFactor::getTenderId, evaluationStep.getTenderId())
                             .eq(EvaluationStepFactor::getStepId, evaluationStep.getId());
        BigDecimal score = null;
        if (evaluationStepFactorService.count(queryWrapper) > 0) {
            score = evaluationFactorService.getScoreByStepId(evaluationStep.getTenderId(), evaluationStep.getId(), weightScore);
        } else {
            if (evaluationStep.getStepType().equals(EvaluationStepEnum.PRICE)) {
                score = evaluationFactorService.getScoreByAuditType(evaluationStep.getTenderId(), EvaluationFactorEnum.AUDIT_PRICE, weightScore);
            } else {
                score = evaluationFactorService.getScoreByAuditType(evaluationStep.getTenderId(), EvaluationFactorEnum.AUDIT_SCORE, weightScore);
            }
        }
        return score;
    }

    /** 
     * @Description: 根据项目id,专家用户id(userId)查找当前专家所拥有的评标步骤
     * @author chenxw
     * @param tenderId
     * @param userId
     * @return 
     */
    @Override
    public List<EvaluationStep> getEvaluationStepByUserId(String tenderId, String userId) {
        return evaluationStepMapper.getEvaluationStepByUserId(tenderId, userId);
    }

    /** 
     * @Description: 根据项目评审点id查询当前评审点所属评标步骤
     * @author chenxw
     * @param tenderId
     * @param factorId
     * @return 
     */
    @Override
    public EvaluationStep getEvaluationStepByFactorId(String tenderId, String factorId) {
        return evaluationStepMapper.getEvaluationStepByFactorId(tenderId, factorId);
    }

    /** 
     * @Description: 获得已完成步骤最大编号
     * @author chenxw
     * @param tenderId
     * @param stepStatus
     * @return 
     */
    @Override
    public int getMAXStepCount(String tenderId, String stepStatus) {
        return evaluationStepMapper.getMAXStepCount(tenderId, stepStatus);
    }

    /** 
     * @Description: 更新添加步骤后后面步骤+1
     * @author chenxw
     * @param tenderId
     * @param maxComplateIndex 
     */
    @Override
    public void updateSortNo(String tenderId, int maxComplateIndex) {
        evaluationStepMapper.updateSortNo(tenderId, maxComplateIndex);
    }

    /** 
     * @Description: 获取未完成的评审步骤列表
     * @author chenxw
     * @param tenderId
     * @param stepSortNo
     * @return 
     */
    @Override
    public List<EvaluationStep> getNotComplateStepList(String tenderId, int stepSortNo) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .lt(EvaluationStep::getSortNo, stepSortNo)
                             .ne(EvaluationStep::getStepStatus, CommonEnum.COMPLETE)
                             .orderByAsc(EvaluationStep::getSortNo);
        return list(queryWrapper);
    }

    /** 
     * @Description: 获取存在废标的未完成评审步骤列表
     * @author chenxw
     * @param tenderId
     * @param stepSortNo
     * @return 
     */
    @Override
    public List<EvaluationStep> getNotComplateFilterStepList(String tenderId, int stepSortNo) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .lt(EvaluationStep::getSortNo, stepSortNo)
                             .ne(EvaluationStep::getStepStatus, CommonEnum.COMPLETE)
                             .eq(EvaluationStep::getFilterType, EvaluationStepEnum.FILTER_YES)
                             .orderByAsc(EvaluationStep::getSortNo);
        return list(queryWrapper);
    }

    /** 
     * @Description: 当前步骤是否在评审中
     * @author chenxw
     * @param tenderId
     * @param stepId
     * @return 
     */
    @Override
    public boolean isInEvaluationStep(String tenderId, String stepId) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId)
                             .eq(EvaluationStep::getId, stepId)
                             .in(EvaluationStep::getStepStatus, new Object[] { CommonEnum.IN_PROGRESS, CommonEnum.COMPLETE });
        return count(queryWrapper) > 0;
    }

    @Override
    public void deleteExpertLeaderEvaluationStepResult(String tenderId) {
     // TODO Auto-generated method stub
    }
    
    /** 
     * @Description: 是否完成商务技术评审 
     * @author chenxw
     * @param tenderId
     * @return 
     */
    @Override
    public boolean isComplateBusAndTecEvaluation(String tenderId) {
        return evaluationStepMapper.getComplateBusAndTecEvaluationCount(tenderId, EvaluationFactorEnum.EVAL_BID_BUS, EvaluationFactorEnum.EVAL_BID_TEC, EvaluationFactorEnum.EVAL_BID_DETAIL, CommonEnum.COMPLETE) == 0;
    }

    @Override
    public EvaluationStep saveReEvaluationStep(TenderProject tenderProject, EvaluationStep evaluationStep, List<Supplier> supplierList) {
    	if (StringUtils.isEmpty(evaluationStep.getId())) {
    		if(!evaluationStepService.saveOrUpdate(evaluationStep)) {
    			return null;
    		}
			List<BidPriceResult> bidPriceResultList = new ArrayList<BidPriceResult>();
			List<BidPriceHisResult> bidPriceResultHisList = new ArrayList<BidPriceHisResult>();
			for (Supplier supplier : supplierList) {
				List<BidPriceResult> supplierBidPriceResultList = bidPriceResultMapper.getSupplierBidPriceResultList(tenderProject.getId(), supplier.getId());
				BidPriceHisResult bidPriceHisResult = new BidPriceHisResult();
				bidPriceHisResult.setId(IDUtils.getId());
				bidPriceHisResult.setTenderId(tenderProject.getId());
				bidPriceHisResult.setSupplierId(supplier.getId());
				tenderProject.getProjectRule().setPriceUnit(bidPriceHisResult.getPriceUnit());
				bidPriceHisResult.setBidPriceRound(1);
				if (null != supplierBidPriceResultList.get(0)) {
					bidPriceHisResult.setCurrencyCode(supplierBidPriceResultList.get(0).getCurrencyCode());
					bidPriceHisResult.setBidPrice(supplierBidPriceResultList.get(0).getBidPrice());
					bidPriceHisResult.setEvaluationPrice(supplierBidPriceResultList.get(0).getEvaluationPrice());
					supplierBidPriceResultList.get(0).setBidPrice(null);
					bidPriceResultList.add(supplierBidPriceResultList.get(0));
				}
				bidPriceHisResult.setRoundName("初始报价");
				bidPriceResultHisList.add(bidPriceHisResult);
				
			}
			bidPriceResultService.batchUpdateProperty(bidPriceResultList, new String[]{"bidPrice"});
			bidPriceHisResultService.insertByBatch(bidPriceResultHisList);
		} else {
			if (evaluationStepService.saveOrUpdate(evaluationStep)) {
				if (evaluationStep.isUpdate()) deleteEvaluationResult(evaluationStep);
			} else {
				evaluationStep = null;
			}
		}
        return null;
    }
    
    /**
	 * @Description: 删除评审步骤结果
	 * @author chenxw
	 * @param evaluationStep 
	 */
	private void deleteEvaluationResult(EvaluationStep evaluationStep) {
		if(null != evaluationStep.getId()){
			if (evaluationStep.getStepType().equals(EvaluationStepEnum.PRICE)) {
				evaluationFactorResultMapper.deleteEvaluationFactorResult(evaluationStep.getTenderId(), evaluationStep.getId(),null);
			} else if (evaluationStep.getStepType().equals(EvaluationStepEnum.CLEAN_TENDER)) {
				checkResultService.deleteCheckResult(evaluationStep.getTenderId(), evaluationStep.getId());
			}
			expertEvaluationStepService.deleteExpertEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
			expertEvaluationResultService.deleteExpertEvaluationResult(evaluationStep.getTenderId(), evaluationStep.getId());
			supplierEvaluationStepService.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
		}
	}
	
	/**
     * @Description: 是否含有评标步骤
     * @author chenxw
     * @param tenderId
     * @return 
     */
    public boolean isHasEvaluationStep(String tenderId) {
        QueryWrapper<EvaluationStep> queryWrapper = new QueryWrapper<EvaluationStep>();
        queryWrapper.lambda().eq(EvaluationStep::getTenderId, tenderId);
        return count(queryWrapper) > 0;
    }
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param evaluationStepList
     * @param attributes
     * @return 
     */
    public int batchUpdateProperty(List<EvaluationStep> evaluationStepList, String[] attributes) {
        return evaluationStepMapper.batchUpdateProperty(evaluationStepList, attributes);
    }
	
}
