package com.gx.obe.server.management.expert.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.management.expert.dao.DefaultFactorResultMapper;
import com.gx.obe.server.management.expert.entity.DefaultFactorResult;
import com.gx.obe.server.management.expert.service.DefaultFactorResultService;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
@Transactional
public class DefaultFactorResultServiceImpl extends ServiceImpl<DefaultFactorResultMapper, DefaultFactorResult> implements DefaultFactorResultService {

	@Autowired
	private DefaultFactorResultMapper defaultFactorResultMapper;
	
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeDefaultFactorResultList 
	 */
	 @Override
	 @Transactional(rollbackFor = Exception.class)
	public Integer updateByBatch (List<DefaultFactorResult> ObeDefaultFactorResultList){
		return defaultFactorResultMapper.updateBatchList(ObeDefaultFactorResultList);
	}
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeDefaultFactorResultList 
	 */
	 @Override
	 @Transactional(rollbackFor = Exception.class)
	public Integer insertByBatch (List<DefaultFactorResult> ObeDefaultFactorResultList){
		return defaultFactorResultMapper.insertByBatch(ObeDefaultFactorResultList);
	}

	@Override
	public List<DefaultFactorResult> findDefaultFactorResultByTenderIdAndStepId(String tenderId, String stepId) {
		 QueryWrapper<DefaultFactorResult> queryWrapper = new QueryWrapper<DefaultFactorResult>();
		 queryWrapper.lambda().eq(DefaultFactorResult::getTenderId, tenderId).eq(DefaultFactorResult::getStepId, stepId);
		return defaultFactorResultMapper.selectList(queryWrapper);
	}
	

}
