package com.gx.obe.server.management.expert.service.impl;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.common.enumeration.CommonEnum;
import com.gx.obe.server.common.enumeration.EvaluationStepEnum;
import com.gx.obe.server.common.enumeration.ExpertEnum;
import com.gx.obe.server.common.enumeration.TenderProjectEnum;
import com.gx.obe.server.common.json.JsonUtil;
import com.gx.obe.server.common.type.EvaluationFactorType;
import com.gx.obe.server.common.utils.BigDecimalUtils;
import com.gx.obe.server.common.utils.CollectionUtils;
import com.gx.obe.server.common.utils.IDUtils;
import com.gx.obe.server.common.utils.ListSortUtils;
import com.gx.obe.server.common.utils.ObjectUtils;
import com.gx.obe.server.common.utils.SortUtils;
import com.gx.obe.server.common.utils.StringUtils;
import com.gx.obe.server.management.check.dao.CheckResultMapper;
import com.gx.obe.server.management.check.entity.CheckResult;
import com.gx.obe.server.management.check.service.CheckResultService;
import com.gx.obe.server.management.dictionary.dao.WorkMemberMapper;
import com.gx.obe.server.management.dictionary.entity.WorkMember;
import com.gx.obe.server.management.editprice.dao.EditPriceItemResultMapper;
import com.gx.obe.server.management.editprice.entity.EditPriceItem;
import com.gx.obe.server.management.editprice.entity.EditPriceItemResult;
import com.gx.obe.server.management.editprice.service.EditPriceItemResultService;
import com.gx.obe.server.management.editprice.service.EditPriceItemService;
import com.gx.obe.server.management.evaluation.dao.BidPriceResultMapper;
import com.gx.obe.server.management.evaluation.dao.EvaluationFactorMapper;
import com.gx.obe.server.management.evaluation.dao.EvaluationFactorResultMapper;
import com.gx.obe.server.management.evaluation.dao.EvaluationStepMapper;
import com.gx.obe.server.management.evaluation.entity.BidPriceResult;
import com.gx.obe.server.management.evaluation.entity.EvaluationFactor;
import com.gx.obe.server.management.evaluation.entity.EvaluationFactorResult;
import com.gx.obe.server.management.evaluation.entity.EvaluationStep;
import com.gx.obe.server.management.evaluation.service.BidPriceResultService;
import com.gx.obe.server.management.evaluation.service.EvaluationFactorResultService;
import com.gx.obe.server.management.evaluation.service.EvaluationStepService;
import com.gx.obe.server.management.expert.dao.ExpertEvaluationResultMapper;
import com.gx.obe.server.management.expert.dao.ExpertEvaluationStepMapper;
import com.gx.obe.server.management.expert.dao.ExpertMapper;
import com.gx.obe.server.management.expert.entity.ExpertEntity;
import com.gx.obe.server.management.expert.entity.ExpertEvaluationResult;
import com.gx.obe.server.management.expert.entity.ExpertEvaluationStep;
import com.gx.obe.server.management.expert.service.ExpertEvaluationResultService;
import com.gx.obe.server.management.expert.service.ExpertEvaluationStepService;
import com.gx.obe.server.management.expert.service.ExpertService;
import com.gx.obe.server.management.price.dao.ReBidPriceRoundMapper;
import com.gx.obe.server.management.price.entity.ReBidPriceRound;
import com.gx.obe.server.management.price.service.ReBidPriceRoundService;
import com.gx.obe.server.management.project.dao.TenderProjectMapper;
import com.gx.obe.server.management.project.entity.ProjectRule;
import com.gx.obe.server.management.project.entity.TenderProject;
import com.gx.obe.server.management.supplier.dao.SupplierEvaluationResultMapper;
import com.gx.obe.server.management.supplier.dao.SupplierEvaluationStepMapper;
import com.gx.obe.server.management.supplier.dao.SupplierOpeningResultMapper;
import com.gx.obe.server.management.supplier.entity.Supplier;
import com.gx.obe.server.management.supplier.entity.SupplierEvaluationResult;
import com.gx.obe.server.management.supplier.entity.SupplierEvaluationStep;
import com.gx.obe.server.management.supplier.entity.SupplierOpeningResult;
import com.gx.obe.server.management.supplier.service.SupplierEvaluationResultService;
import com.gx.obe.server.management.supplier.service.SupplierEvaluationStepService;
import com.gx.obe.server.management.supplier.service.SupplierOpeningResultService;
import com.gx.obe.server.management.user.dao.AuthUserMapper;
import com.gx.obe.server.management.user.entity.AuthUserEntity;
import com.gx.obe.server.management.vo.Audit;
import com.gx.obe.server.management.vo.FixedFactorItemVo;
import com.gx.obe.server.management.vo.FixedFactorSupplierVo;
import com.gx.obe.server.management.vo.SaveEvaluationResultVo;
import com.gx.obe.server.management.vo.SubmitEvaluationResultVo;
import org.springframework.util.Assert;

/**
 * @Description:
 * @author mazc
 */
@Service
@Transactional
public class ExpertEvaluationStepServiceImpl extends ServiceImpl<ExpertEvaluationStepMapper, ExpertEvaluationStep> implements ExpertEvaluationStepService {

    @Autowired
    private ExpertEvaluationStepMapper expertEvaluationStepMapper;
    
    @Autowired
    private EvaluationFactorResultMapper evaluationFactorResultMapper;
    
    @Autowired
    private EvaluationFactorResultService evaluationFactorResultService;
    
    @Autowired
    private ExpertEvaluationResultMapper expertEvaluationResultMapper;
    
    @Autowired
    private ExpertEvaluationResultService expertEvaluationResultService;
    
    @Autowired
    private EvaluationStepService evaluationStepService;
    
    @Autowired
    private TenderProjectMapper tenderProjectMapper;
    
    @Autowired
    private EvaluationStepMapper evaluationStepMapper;
    
    @Autowired
    private ExpertMapper expertMapper;
    
    @Autowired
    private ExpertService expertService;
    
    @Autowired
    private EditPriceItemService editPriceItemService;

    @Autowired
    private EditPriceItemResultMapper editPriceItemResultMapper;
    
    @Autowired
    private EditPriceItemResultService sditPriceItemResultService;
    
    @Autowired
    private SupplierEvaluationResultService supplierEvaluationResultService;
    
    @Autowired
    private EvaluationFactorMapper evaluationFactorMapper;
    
    @Autowired
    private BidPriceResultMapper bidPriceResultMapper;
    
    @Autowired
    private BidPriceResultService bidPriceResultService;
    
    @Autowired
    private SupplierOpeningResultMapper supplierOpeningResultMapper;
    
    @Autowired
    private SupplierOpeningResultService supplierOpeningResultService;
    
    @Autowired
    private SupplierEvaluationStepMapper supplierEvaluationStepMapper;
    
    @Autowired
    private CheckResultMapper checkResultMapper;
    @Autowired
    private CheckResultService checkResultService;
    
    @Autowired
    private  AuthUserMapper authUserMapper;
    
    @Autowired
    private SupplierEvaluationResultMapper supplierEvaluationResultMapper;
    
    @Autowired
    private SupplierEvaluationStepService supplierEvaluationStepService;

    @Autowired
	private WorkMemberMapper workerMapper;

    @Autowired
	private EditPriceItemResultService editPriceItemResultService;
    
    
    @Autowired
   	private  ReBidPriceRoundMapper reBidPriceRoundMapper;
    
    @Autowired
   	private ReBidPriceRoundService reBidPriceRoundService;

    /**
     * @Description: 批量更新
     * @author mazc
     * @param ObeExpertEvaluationStepList
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Integer updateByBatch(List<ExpertEvaluationStep> ObeExpertEvaluationStepList) {
        return expertEvaluationStepMapper.updateBatchList(ObeExpertEvaluationStepList);
    }
    
    /**
     * @Description: 批量插入
     * @author mazc
     * @param ObeExpertEvaluationStepList
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Integer insertByBatch(List<ExpertEvaluationStep> ObeExpertEvaluationStepList) {
        return expertEvaluationStepMapper.insertByBatch(ObeExpertEvaluationStepList);
    }
    
    /**
     * @Description: 删除评审成员分配的评标步骤
     * @author mazc
     * @param tenderId 项目id
     * @return
     */
    @Override
    public int deleteStepByTenderId(String tenderId) {
        QueryWrapper<ExpertEvaluationStep> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ExpertEvaluationStep::getTenderId, tenderId);
        return expertEvaluationStepMapper.delete(queryWrapper);
    }
    
    /**
     * @Description: 检查是否存在专家的评审进度
     * @author mazc
     * @param tenderId
     * @param stepId
     * @param userId
     * @return
     */
    private boolean isExistExpertEvaluationStep(String tenderId, String stepId, String userId) {
        return expertEvaluationStepMapper.isExistExpertEvaluationStep(tenderId, stepId, userId) > 0;
    }
    
    /**
     * @Description: 修改专家对当前评标步骤的评审进度
     * @author mazc
     * @param status
     * @param tenderId
     * @param evaluationStep
     * @param userId
     * @return
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExpertEvaluationStep updateExpertEvaluationStatus(String status, String tenderId, EvaluationStep evaluationStep, String userId) {
        ExpertEvaluationStep expertEvaluationStep = null;
        boolean existExpertEvaluationStep = isExistExpertEvaluationStep(tenderId, evaluationStep.getId(), userId);
        Date nowDate = new Date();
        if (!existExpertEvaluationStep) {
            expertEvaluationStep = new ExpertEvaluationStep();
            expertEvaluationStep.setId(IDUtils.getId());
            expertEvaluationStep.setStartTime(nowDate);
            expertEvaluationStep.setStepStatus(status);
            expertEvaluationStep.setTenderId(tenderId);
            expertEvaluationStep.setStepId(evaluationStep.getId());
            expertEvaluationStep.setUserId(userId);
            expertEvaluationStep.setEndTime(nowDate);
            expertEvaluationStepMapper.insert(expertEvaluationStep);
        } else {
            updateExpertEvaluationStepStatus(status, nowDate, tenderId, evaluationStep.getId(), userId);
        }
        if (status.equals(CommonEnum.IN_PROGRESS) && (null == evaluationStep.getStepStatus() || !evaluationStep.getStepStatus().equals(CommonEnum.IN_PROGRESS))) {
            evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
            evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "id", "stepStatus" });
        }
        return expertEvaluationStep;
    }
    
    @Override
    public boolean updateExpertEvaluationStepStatus(String status, Date endTime, String tenderId, String stepId, String userId) {
        return expertEvaluationStepMapper.updateExpertEvaluationStepStatus(status, endTime, tenderId, stepId, userId) > 0;
    }
    
    /**
     * @Description: 保存评标结果
     * @author mazc
     * @param saveEvaluationResultVo
     * @return
     */
    
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean saveEvaluationResult(SaveEvaluationResultVo saveEvaluationResultVo) {
        Integer count = 0;
        String tenderId = saveEvaluationResultVo.getTenderId();
        String userId = saveEvaluationResultVo.getUserId();
        Map<String, ExpertEvaluationResult> expertEvaluationResultMap = saveEvaluationResultVo.getExpertEvaluationResultMap();
        Map<String, Map<String, EvaluationFactorResult>> supplierEvaluationFactorResultMap = saveEvaluationResultVo.getSupplierEvaluationFactorResultMap();
        EvaluationStep evaluationStep = saveEvaluationResultVo.getEvaluationStep();
        count += evaluationFactorResultMapper.deleteEvaluationFactorResult(tenderId, evaluationStep.getId(), userId);
        count += expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        
        List<EvaluationFactorResult> evaluationFactorResultList = new ArrayList<>();
        List<ExpertEvaluationResult> expertEvaluationResultList = new ArrayList<>();
        
        for (Entry<String, ExpertEvaluationResult> expertEvaluationResultEntry : expertEvaluationResultMap.entrySet()) {
            ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultEntry.getValue();
            expertEvaluationResult.setId(IDUtils.getId());
            // 当前供应商的所有评审结果
            Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(expertEvaluationResultEntry.getKey());
            for (Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()) {
                EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
                if (StringUtils.isEmpty(evaluationFactorResult.getId())) {
                    evaluationFactorResult.setId(IDUtils.getId());
                }
                evaluationFactorResultList.add(evaluationFactorResult);
            }
            expertEvaluationResultList.add(expertEvaluationResult);
        }
        count += evaluationFactorResultService.insertByBatch(evaluationFactorResultList);
        count += expertEvaluationResultService.insertByBatch(expertEvaluationResultList);
        if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
            count += tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
            evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
            count += evaluationStepMapper.updateEvaluateStatus(CommonEnum.IN_PROGRESS, evaluationStep.getId());
        }
        return count > 0;
    }
    
    /**
     * @Description: 提交评标结果
     * @author mazc
     * @param submitEvaluationResultVo
     * @return
     */
    @Override
//    @Transactional(rollbackFor = Exception.class)
    public boolean submitEvaluationResult(SubmitEvaluationResultVo submitEvaluationResultVo) {
        String tenderId = submitEvaluationResultVo.getTenderId();
        ProjectRule projectRule = submitEvaluationResultVo.getProjectRule();
        String userId = submitEvaluationResultVo.getUserId();
        EvaluationStep evaluationStep = submitEvaluationResultVo.getEvaluationStep();
        List<Supplier> supplierList = submitEvaluationResultVo.getSupplierList();
        boolean isUpdate = expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId) > 0;
        if (isUpdate) {
            int expertCount = 1;
            // 是否最后一个评标专家提交
            boolean isLastExpertSubmit;
            // 如果是专家组长，则认为是最后一个专家提交
            if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EXPERT_LEADER)) {
                isLastExpertSubmit = true;
            } else if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.OPERATOR)) {
                isLastExpertSubmit = true;
            } else {
                // 获得当前评审完成的专家个数
                int evaluationComplateCount = expertEvaluationStepMapper.getExpertEvaluationComplateCount(tenderId, evaluationStep.getId());
                expertCount = expertMapper.findEvaluationStepExpertCount(tenderId, evaluationStep);
                // 如果评审完成的专家个数 > 当前节点评审的专家 则认为当前是最后一个专家提交结果
                isLastExpertSubmit = evaluationComplateCount >= expertCount;
            }
            // 是否筛选投标人
            boolean isFilterSupplier = ObjectUtils.equals(evaluationStep.getFilterType(), EvaluationStepEnum.FILTER_YES);
            if (isLastExpertSubmit) {
                UpdatEvaluationResult(evaluationStep, tenderId, expertCount, isFilterSupplier, supplierList, projectRule);
            }
        }
        return isUpdate;
    }
    
    /**
     * @Description: 如果所有评标专家都评完成，则修改项目的评审状态
     * @author mazc
     */
    private void UpdatEvaluationResult(EvaluationStep evaluationStep, String tenderId, int expertCount, boolean isFilterSupplier, List<Supplier> supplierList, ProjectRule projectRule) {
    	   List<AuthUserEntity> userList;
    	if(null != evaluationStep.getRoleType() && evaluationStep.getRoleType().equals(EvaluationStepEnum.OPERATOR)){
    		userList = authUserMapper.getEvaluationStepUserByManagerList(tenderId);
    	}else {
    		 userList = expertMapper.getEvaluationStepUserList(tenderId, evaluationStep);
    	}
    	
        if (null != userList && userList.size() > 0) {
            List<String> userIdList = new ArrayList<>();
            for (AuthUserEntity authUserEntity : userList) {
                userIdList.add(authUserEntity.getId());
            }
//            deleteDirtyEvaluationResult(evaluationStep.getTenderId(), evaluationStep, userIdList);
            if (null != userIdList && userIdList.size() > 0) {
                boolean deleteFactorResult = false;
                if (EvaluationStepEnum.COMPLIANCE.equals(evaluationStep.getStepType()) || EvaluationStepEnum.DETAIL.equals(evaluationStep.getStepType()) || EvaluationStepEnum.PRICE.equals(evaluationStep.getStepType()) || EvaluationStepEnum.CLEAN_TENDER.equals(evaluationStep.getStepType())) {
                    deleteFactorResult = true;
                }
                   expertEvaluationStepMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
                   expertEvaluationResultMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
                if (deleteFactorResult) {
                    evaluationFactorResultMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
                }
                if (EvaluationStepEnum.CLEAN_TENDER.equals(evaluationStep.getStepType())) {
                    checkResultMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
                }
            }
        }
        
        // 打分步骤
        boolean isScoreStep = evaluationStep.getStepType().equals(EvaluationStepEnum.DETAIL);
        boolean isFixedFactorStep = evaluationStep.getStepType().equals(EvaluationStepEnum.FIXED_FACTOR);
        boolean isPriceStep = evaluationStep.getStepType().equals(EvaluationStepEnum.PRICE);
        boolean isComplianceStep = evaluationStep.getStepType().equals(EvaluationStepEnum.COMPLIANCE);
        List<SupplierEvaluationResult> supplierEvalResultList = new ArrayList<>();
        List<String> updatePropertyList = new ArrayList<>();
        // 获得价格得分汇总
        List<Map<String, Object>> priceEvaluationResultList = null;
        boolean isEvaluationScoreByPass = false;
        BigDecimal warningRange = null;
        BigDecimal floatingEvaluationPricePercent = null;
        Integer unqualifiedDeviateClauseCount = 0;
        Map<String, BigDecimal> supplierDeviateClauseCountMap = null;
        List<FixedFactorItemVo> fixedFactorItemVoList = null;
        List<FixedFactorSupplierVo> fixedFactorSupplierVoList = null;
        if (isScoreStep) {
            boolean evalByGroup = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_EVAL_BY_GROUP, Boolean.class);
            if (evalByGroup) {
                evaluationStep.setSummaryType(EvaluationStepEnum.SUMMARY_BY_FACTOR_SUM);
            }
            
            // 打分步骤如果是通过性评审，则需要筛选投标人，并且是少数服从多数的原则
            if (null != evaluationStep.getSummaryType() && evaluationStep.getSummaryType().equals(EvaluationStepEnum.SUMMARY_SCORE_BY_QUALIFIED)) {
                isEvaluationScoreByPass = true;
            }
            
            warningRange = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_WARNING_RANGE, BigDecimal.class);
            if (null != warningRange && warningRange.compareTo(BigDecimal.ZERO) != 0) {
                // 转换为百分率
                warningRange = BigDecimalUtils.div(warningRange, new BigDecimal(100));
            } else {
                warningRange = null;
            }
            
        } else if (isFixedFactorStep) {
        	
			String PARAM_FIXED_FACTOR_LIST = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_FIXED_FACTOR_LIST);
			if(StringUtils.hasLength(PARAM_FIXED_FACTOR_LIST)) {
				fixedFactorItemVoList = JsonUtil.strToList(PARAM_FIXED_FACTOR_LIST, FixedFactorItemVo.class);
			}
        	isScoreStep = true;
            warningRange = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_WARNING_RANGE, BigDecimal.class);
            if (null != warningRange && warningRange.compareTo(BigDecimal.ZERO) != 0) {
                // 转换为百分率
                warningRange = BigDecimalUtils.div(warningRange, new BigDecimal(100));
            } else {
                warningRange = null;
            }
            
        } else if (isPriceStep) {
            isScoreStep = true;
            // 获得价格得分汇总
            priceEvaluationResultList = expertEvaluationResultMapper.findPriceEvaluationResultList(tenderId);
            if (null != priceEvaluationResultList && priceEvaluationResultList.size() > 0) {
                updatePropertyList.add("priceScore");
                updatePropertyList.add("priceFinalScore");
            }
        } else if (isComplianceStep) {
            unqualifiedDeviateClauseCount = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.UNQUALIFIED_DEVIATE_CLAUSE_COUNT, Integer.class, 1);
            if (unqualifiedDeviateClauseCount > 0) {
                floatingEvaluationPricePercent = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.FLOATING_EVALUATION_PRICE_PERCENT, BigDecimal.class);
                if (null != floatingEvaluationPricePercent && floatingEvaluationPricePercent.compareTo(BigDecimal.ZERO) != 0) {
                    
                    List<Map<String, Object>> supplierDeviateClauseCountList = evaluationFactorResultMapper.getSupplierDeviateClauseCountList(tenderId, evaluationStep.getId(), expertCount > 1 ? expertCount / 2 : 0);
                    if (null != supplierDeviateClauseCountList && supplierDeviateClauseCountList.size() > 0) {
                        supplierDeviateClauseCountMap = new HashMap<>();
                        for (Map<String, Object> supplierDeviateMap : supplierDeviateClauseCountList) {
                            Object supplierIdObj = supplierDeviateMap.get("SUPPLIER_ID");
                            Object deviateCountObj = supplierDeviateMap.get("DEVIATE_COUNT");
                            if (null != supplierIdObj && null != deviateCountObj) {
                                supplierDeviateClauseCountMap.put(supplierIdObj.toString(), new BigDecimal(deviateCountObj.toString()));
                            }
                        }
                    }
                } else {
                    floatingEvaluationPricePercent = null;
                }
            }
        }
        if (isFilterSupplier || isEvaluationScoreByPass) {
            updatePropertyList.add("accessment");
        }
        
        List<BidPriceResult> updateBidPriceResultList = null;
        List<SupplierOpeningResult> updateSupplierOpeningResultList = null;
        
        List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
        // 用于记录投标人在当前评标步骤的评分汇总
        List<Double> supplierEvaluationFinalScoreList = new ArrayList<>();
        
        Map<String, EditPriceItemResult> deviateCaluseItemResultMap = null;
        EditPriceItem deviateCaluseItem = null;
        if (null != supplierDeviateClauseCountMap) {
            deviateCaluseItem = editPriceItemService.getDeviateCaluseEditPriceItem(tenderId);
            
            deviateCaluseItemResultMap = new HashMap<>();
            List<EditPriceItemResult> deviateCaluseItemResultList = editPriceItemResultMapper.getItemResultListByItemId(tenderId, deviateCaluseItem.getId());
            if (CollectionUtils.isNotNull(deviateCaluseItemResultList)) for (EditPriceItemResult editPriceItemResult : deviateCaluseItemResultList)
                deviateCaluseItemResultMap.put(editPriceItemResult.getSupplierId(), editPriceItemResult);
        }
        
        for (Supplier supplier : supplierList) {
            SupplierEvaluationResult supplierEvaluationResult = null;
            if (null != supplier.getSupplierEvaluationResult() && null != supplier.getSupplierEvaluationResult().getId()) {
                supplierEvaluationResult = supplier.getSupplierEvaluationResult();
            }
            String supplierAccement = EvaluationStepEnum.QUALIFIED;
            // 如果需要筛选投标人
            if (isFilterSupplier || isEvaluationScoreByPass) {
                // 获得当前供应商评标专家结论为不通过的家数
                int accessmentNoCount = expertEvaluationResultMapper.getSupplierDisAccessmentCount(tenderId, evaluationStep.getId(), supplier.getId());
                if (accessmentNoCount > 0) {
                    // 如果是少数服从多数
                    if (ObjectUtils.equals(evaluationStep.getPassType(), EvaluationStepEnum.PASS_MORE)) {
                        if (accessmentNoCount > expertCount / 2) {
                            supplierAccement = EvaluationStepEnum.UNQUALIFIED;
                        }
                    } else {
                        supplierAccement = EvaluationStepEnum.UNQUALIFIED;
                    }
                }
                if (null == supplierEvaluationResult) {
                    supplierEvaluationResult = supplierEvaluationResultService.getOrCreateSupplierEvaluationResult(tenderId, supplier.getId());
                }
                // 供应商评审意见
                supplierEvaluationResult.setAccessment(supplierAccement);
            }
            
            SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
            supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
            supplierEvaluationStep.setId(IDUtils.getId());
            supplierEvaluationStep.setAccessment(supplierAccement);
            supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
            if (isScoreStep) {
                BigDecimal[] stepAvgResult = null;
                List<BigDecimal>  bidDecimals = null;
                if (isEvaluationScoreByPass) {
                    List<EvaluationFactor> evaluationFactorList = evaluationFactorMapper.getEvaluationStepFactorList(tenderId, evaluationStep.getId());
                    if (null != evaluationFactorList && evaluationFactorList.size() > 0) {
                        BigDecimal totalScore = BigDecimal.ZERO;
                        BigDecimal totalFinalScore = BigDecimal.ZERO;
                        for (EvaluationFactor evaluationFactor : evaluationFactorList) {
                            if (null != evaluationFactor.getScoreType() && evaluationFactor.getScoreType().equals(EvaluationFactorType.SCORE_TYPE_PASS)) {
                                if (null != evaluationFactor.getFactorScore() && evaluationFactor.getFactorScore().compareTo(BigDecimal.ZERO) > 0) {
                                    totalScore = BigDecimalUtils.add(totalFinalScore, evaluationFactor.getFactorScore());
                                    if (null != evaluationFactor.getFactorFinalWeight()) {
                                        totalFinalScore = BigDecimalUtils.add(totalFinalScore, BigDecimalUtils.div(BigDecimalUtils.mul(evaluationFactor.getFactorScore(), evaluationFactor.getFactorFinalWeight()), BigDecimal.valueOf(100)));
                                    } else {
                                        totalFinalScore = BigDecimalUtils.add(totalFinalScore, evaluationFactor.getFactorScore());
                                    }
                                }
                            }
                        }
                        stepAvgResult = new BigDecimal[] { totalScore, totalFinalScore };
                    }
                } else if (expertCount > 1 && EvaluationStepEnum.SUMMARY_IGNORE_OVER_WARNING_CORE.equals(evaluationStep.getSummaryType())) {
                    // 如果取掉超出最小偏差率
                	bidDecimals = expertEvaluationResultService.getSupplierStepAvgResult(tenderId, evaluationStep.getId(), supplier.getId(), false);
                    if (null != warningRange) {
                        int noIgnoreCount = 0;
                        BigDecimal supplierNoignoreEvaluationScoreSum = BigDecimal.ZERO;
                        BigDecimal supplierNoignoreEvaluationFinalScoreSum = BigDecimal.ZERO;
                        BigDecimal expertMinScore = null;
                        BigDecimal expertMinFinalScore = null;
                        List<ExpertEvaluationResult> expertEvaluationResultList = expertEvaluationResultMapper.getSupplierExpertEvaluationResultList(tenderId, evaluationStep.getId(), supplier.getId());
                        if (null == bidDecimals) {
                            stepAvgResult = new BigDecimal[] { BigDecimal.ZERO, BigDecimal.ZERO };
                        }else {
                            stepAvgResult = new BigDecimal[2];
                        	stepAvgResult[0] = bidDecimals.get(0);
                        	stepAvgResult[1] = bidDecimals.get(1);
                        }
                        BigDecimal stepAvgEvaluationScoreSum = stepAvgResult[0];
                        for (ExpertEvaluationResult expertEvaluationResult : expertEvaluationResultList) {
                            if (null != expertEvaluationResult.getEvaluationScore()) {
                                BigDecimal percentValue = BigDecimal.ZERO;
                                if (null != stepAvgEvaluationScoreSum && stepAvgEvaluationScoreSum.compareTo(BigDecimal.ZERO) != 0) {
                                    percentValue = BigDecimalUtils.div(BigDecimalUtils.sub(expertEvaluationResult.getEvaluationScore(), stepAvgEvaluationScoreSum), stepAvgEvaluationScoreSum).abs();// 偏差率绝对值
                                }
                                if (percentValue.compareTo(warningRange) < 0) {
                                    supplierNoignoreEvaluationScoreSum = BigDecimalUtils.add(supplierNoignoreEvaluationScoreSum, expertEvaluationResult.getEvaluationScore());
                                    supplierNoignoreEvaluationFinalScoreSum = BigDecimalUtils.add(supplierNoignoreEvaluationFinalScoreSum, expertEvaluationResult.getEvaluationFinalScore());
                                    noIgnoreCount++;
                                }
                                // 记录分项的最小值
                                if (null == expertMinScore || expertEvaluationResult.getEvaluationScore().compareTo(expertMinScore) < 0) {
                                    expertMinScore = expertEvaluationResult.getEvaluationScore();
                                    expertMinFinalScore = expertEvaluationResult.getEvaluationFinalScore();
                                }
                            }
                        }
                        if (noIgnoreCount > 0) {
                            stepAvgResult[0] = BigDecimalUtils.div(supplierNoignoreEvaluationScoreSum, new BigDecimal(noIgnoreCount), projectRule.getScoreRoundIntVal());
                            stepAvgResult[1] = BigDecimalUtils.div(supplierNoignoreEvaluationFinalScoreSum, new BigDecimal(noIgnoreCount), projectRule.getScoreRoundIntVal());
                        } else {
                        	boolean useMinScore = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_IGNORE_OVER_WARNING_USE_MIN, Boolean.class, false);
                        	if(useMinScore) {
                        		stepAvgResult[0] = null != expertMinScore ? expertMinScore : BigDecimal.ZERO;
                        		stepAvgResult[1] = null != expertMinFinalScore ? expertMinFinalScore : BigDecimal.ZERO;
                        	}
                        }
                    }
                } else if (null != evaluationStep.getSummaryType() && evaluationStep.getSummaryType().equals(EvaluationStepEnum.SUMMARY_REMOVE_FACTOR_MAX_MIN)) {
                	bidDecimals = expertEvaluationResultService.getSupplierStepAvgResultByFactor(tenderId, evaluationStep.getId(), supplier.getId(), expertCount > 2);
                    if(null != bidDecimals) {
                    	stepAvgResult = new BigDecimal[2];
                    	stepAvgResult[0] = bidDecimals.get(0);
                    	stepAvgResult[1] = bidDecimals.get(1);
                    }

                } else if (null != evaluationStep.getSummaryType() && evaluationStep.getSummaryType().equals(EvaluationStepEnum.SUMMARY_BY_FACTOR_SUM)) {
                	bidDecimals = expertEvaluationResultService.getSupplierStepAvgResultByFactor(tenderId, evaluationStep.getId(), supplier.getId(), false);
                    if(null != bidDecimals) {
                    	stepAvgResult = new BigDecimal[2];
                    	stepAvgResult[0] = bidDecimals.get(0);
                    	stepAvgResult[1] = bidDecimals.get(1);
                    }

                } else {
                    boolean removeMaxAndMin = null != evaluationStep.getSummaryType() && evaluationStep.getSummaryType().equals(EvaluationStepEnum.SUMMARY_REMOVE_MAX_MIN);
                    bidDecimals = expertEvaluationResultService.getSupplierStepAvgResult(tenderId, evaluationStep.getId(), supplier.getId(), expertCount > 2 && removeMaxAndMin);
                    if(null != bidDecimals) {
                    	stepAvgResult = new BigDecimal[2];
                    	stepAvgResult[0] = bidDecimals.get(0);
                    	stepAvgResult[1] = bidDecimals.get(1);
                    }
                }
                
                
                if (null != stepAvgResult) {
                    supplierEvaluationStep.setEvaluationScore(BigDecimalUtils.round(stepAvgResult[0], projectRule.getScoreRoundIntVal()));
                    supplierEvaluationStep.setEvaluationFinalScore(BigDecimalUtils.round(stepAvgResult[1], projectRule.getScoreRoundIntVal()));
                }
                
                if(isFixedFactorStep) {
                	if(null == fixedFactorSupplierVoList) {
                		fixedFactorSupplierVoList = new ArrayList<FixedFactorSupplierVo>();
                	}
                	FixedFactorSupplierVo fixedFactorSupplier = configFixedFactor(evaluationStep, fixedFactorItemVoList, supplier.getId(), supplierEvaluationStep.getEvaluationScore());
                	if(null != fixedFactorSupplier) {
                		fixedFactorSupplierVoList.add(fixedFactorSupplier);
                	}
                }
                if (null != supplierEvaluationStep.getEvaluationFinalScore()) {
                    supplierEvaluationFinalScoreList.add(supplierEvaluationStep.getEvaluationFinalScore().doubleValue());
                }
            } else if (isComplianceStep) {
                if (null != supplierDeviateClauseCountMap && null != supplierDeviateClauseCountMap.get(supplier.getId()) && EvaluationStepEnum.QUALIFIED.equals(supplierEvaluationResult.getAccessment())) {
                    // 偏离性条款个数
                    BigDecimal deviateCaluseCount = supplierDeviateClauseCountMap.get(supplier.getId());
                    if (deviateCaluseCount.compareTo(new BigDecimal(unqualifiedDeviateClauseCount)) < 0) {
                        BigDecimal floatingEvaluationPricePercentVlue = BigDecimalUtils.mul(deviateCaluseCount, floatingEvaluationPricePercent);
                        if (null != floatingEvaluationPricePercentVlue && floatingEvaluationPricePercentVlue.compareTo(BigDecimal.ZERO) != 0) {
                            StringBuilder modifyReason = new StringBuilder();
                            modifyReason.append("共").append(deviateCaluseCount).append("项条款存在偏离，");
                            if (floatingEvaluationPricePercentVlue.compareTo(BigDecimal.ZERO) > 0) {
                                modifyReason.append("评标价上浮").append(floatingEvaluationPricePercentVlue).append("%。");
                            } else {
                                modifyReason.append("评标价下浮").append(floatingEvaluationPricePercentVlue).append("%。");
                            }
                            List<BidPriceResult> bidPriceResultList = bidPriceResultMapper.getSupplierBidPriceResultList(tenderId, supplier.getId());
                            SupplierOpeningResult supplierOpeningResult = supplierOpeningResultMapper.getSupplierOpeningResult(tenderId, supplier.getId());
                            if (null == updateSupplierOpeningResultList) {
                                updateSupplierOpeningResultList = new ArrayList<>();
                            }
                            if (null != bidPriceResultList && bidPriceResultList.size() > 0) {
                                BidPriceResult firstBidPriceResult = bidPriceResultList.get(0);
//								BigDecimal evaluationPrice = null != firstBidPriceResult.getEvaluationPrice() ? firstBidPriceResult.getEvaluationPrice() : firstBidPriceResult.getBidPrice();
                                BigDecimal evaluationPrice = firstBidPriceResult.getBidPrice();
                                // 转换为百分率
                                BigDecimal floatingEvaluationPriceValue = BigDecimalUtils.mul(evaluationPrice, floatingEvaluationPricePercentVlue);
                                floatingEvaluationPriceValue = BigDecimalUtils.div(floatingEvaluationPriceValue, new BigDecimal(100));
                                
                                evaluationPrice = BigDecimalUtils.add(evaluationPrice, floatingEvaluationPriceValue);
                                firstBidPriceResult.setEvaluationPrice(evaluationPrice);
                                firstBidPriceResult.setModifyReason(modifyReason.toString());
                                
                                if (null != deviateCaluseItemResultMap || null == deviateCaluseItem) {
                                    EditPriceItemResult deviateCaluseItemResult = deviateCaluseItemResultMap.get(supplier.getId());
                                    if (null == deviateCaluseItemResult) {
                                        deviateCaluseItemResult = new EditPriceItemResult();
                                        deviateCaluseItemResult.setTenderId(tenderId);
                                        deviateCaluseItemResult.setSupplierId(supplier.getId());
                                        deviateCaluseItemResult.setEditPriceItemId(deviateCaluseItem.getId());
                                        deviateCaluseItemResultMap.put(supplier.getId(), deviateCaluseItemResult);
                                    }
                                    deviateCaluseItemResult.setEditPrice(floatingEvaluationPriceValue);
                                    deviateCaluseItemResult.setEditReason(modifyReason.toString());
                                }
                                
                                if (null == updateBidPriceResultList) {
                                    updateBidPriceResultList = new ArrayList<>();
                                }
                                
                                updateBidPriceResultList.add(firstBidPriceResult);
                                if (null != supplierOpeningResult) {
                                    supplierOpeningResult.setModifyReason(modifyReason.toString());
                                    updateSupplierOpeningResultList.add(supplierOpeningResult);
                                }
                            } else {
                                if (null != supplierOpeningResult) {
//									BigDecimal evaluationPrice = null != supplierOpeningResult.getEvaluationPrice() ? supplierOpeningResult.getEvaluationPrice() : supplierOpeningResult.getBidPrice();
                                    BigDecimal evaluationPrice = supplierOpeningResult.getBidPrice();
                                    // 转换为百分率
                                    BigDecimal floatingEvaluationPriceValue = BigDecimalUtils.mul(evaluationPrice, floatingEvaluationPricePercentVlue);
                                    floatingEvaluationPriceValue = BigDecimalUtils.div(floatingEvaluationPriceValue, new BigDecimal(100));
                                    evaluationPrice = BigDecimalUtils.add(evaluationPrice, floatingEvaluationPriceValue);
                                    supplierOpeningResult.setEvaluationPrice(evaluationPrice);
                                    supplierOpeningResult.setModifyReason(modifyReason.toString());
                                    updateSupplierOpeningResultList.add(supplierOpeningResult);
                                }
                            }
                        }
                    }
                }
            }
            supplierEvaluationStepList.add(supplierEvaluationStep);
            
            if (null != priceEvaluationResultList && priceEvaluationResultList.size() > 0) {
                if (null == supplierEvaluationResult) {
                    supplierEvaluationResult = supplierEvaluationResultService.getOrCreateSupplierEvaluationResult(tenderId, supplier.getId());
                }
                // 获得每家供应商的所有价格得分汇总
                for (Map<String, Object> priceResult : priceEvaluationResultList) {
                    if (supplier.getId().equals(priceResult.get("SUPPLIER_ID"))) {
                        supplierEvaluationResult.setPriceScore((BigDecimal) priceResult.get("EVALUATION_SCORE"));
                        supplierEvaluationResult.setPriceFinalScore((BigDecimal) priceResult.get("EVALUATION_FINAL_SCORE"));
                        break;
                    }
                }
            }
            if (null != supplierEvaluationResult) {
                supplierEvalResultList.add(supplierEvaluationResult);
            }
        }
        
        if (supplierEvaluationStepList.size() > 0) {
            if (isScoreStep) {
                double filterScore = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_FILTER_SCORE, Double.class, (double) 0);
                SortUtils sortUtil = new SortUtils(supplierEvaluationFinalScoreList);
                for (SupplierEvaluationStep supplierEvaluationStep : supplierEvaluationStepList) {
                    if (null != supplierEvaluationStep.getEvaluationFinalScore()) {
                        int sortNo = sortUtil.getSortNo(supplierEvaluationStep.getEvaluationFinalScore().doubleValue());
                        supplierEvaluationStep.setSortNo(sortNo);
                        // 如果不是手动入围 且设定了入围规则，且排名在入围规则之内，则通过，否则不通过
                        if (!isFilterSupplier) {
                            if (evaluationStep.getFinalistNumber() > 0) {
                                if (null != supplierEvaluationStep.getEvaluationFinalScore() && sortNo <= evaluationStep.getFinalistNumber()) {
                                    supplierEvaluationStep.setAccessment(EvaluationStepEnum.QUALIFIED);
                                } else {
                                    supplierEvaluationStep.setAccessment(EvaluationStepEnum.UNQUALIFIED);
                                }
                            } else if (filterScore > 0) {
                                if (null != supplierEvaluationStep.getEvaluationFinalScore() && supplierEvaluationStep.getEvaluationFinalScore().compareTo(new BigDecimal(filterScore)) < 0) {
                                    supplierEvaluationStep.setAccessment(EvaluationStepEnum.UNQUALIFIED);
                                } else {
                                    supplierEvaluationStep.setAccessment(EvaluationStepEnum.QUALIFIED);
                                }
                            }
                        }
                    }
                }
            }
            // 先删除投标人在该评标步骤全部的评审记录
            supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
            supplierEvaluationStepMapper.insertByBatch(supplierEvaluationStepList);
        }
        
        List<EditPriceItemResult> editPriceItemResultList = CollectionUtils.mapToArrayList(deviateCaluseItemResultMap);
        if(null != editPriceItemResultList && editPriceItemResultList.size() > 0) {
        	sditPriceItemResultService.batchSaveOrUpdate(editPriceItemResultList, new String[] { "id", "editPrice", "editReason" });
        }
        
        if (null != supplierEvalResultList && supplierEvalResultList.size() > 0) {
            // 批量保存投标人评标结果
            updatePropertyList.add("id");
            supplierEvaluationResultService.batchSaveOrUpdate(supplierEvalResultList, updatePropertyList.toArray(new String[0]));
        }
        
        if (null != updateSupplierOpeningResultList && updateSupplierOpeningResultList.size() > 0) {
            
            if (null != updateBidPriceResultList && updateBidPriceResultList.size() > 0) {
                
                bidPriceResultService.batchUpdateProperty(updateBidPriceResultList, new String[] { "id", "evaluationPrice", "modifyReason" });
                supplierOpeningResultService.batchUpdateProperty(updateSupplierOpeningResultList, new String[] { "id", "modifyReason" });
                supplierOpeningResultMapper.updateSupplierSumPrice(tenderId, null, true, true);
            } else {
                supplierOpeningResultService.batchUpdateProperty(updateSupplierOpeningResultList, new String[] { "id", "evaluationPrice", "modifyReason" });
            }
        }
        
        // 修改项目的评审状态为完成
        if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
            tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
        }
        evaluationStep.setStepStatus(CommonEnum.COMPLETE);
        if(isFixedFactorStep) {
        	String PARAM_FIXED_FACTOR_SUPPLIER_LIST = null;
        	if(null != fixedFactorSupplierVoList && fixedFactorSupplierVoList.size() > 0) {
        		PARAM_FIXED_FACTOR_SUPPLIER_LIST = JsonUtil.obejctListToStr(fixedFactorSupplierVoList);
        	}
        	evaluationStep.setEvaluationParam(EvaluationStepEnum.PARAM_FIXED_FACTOR_SUPPLIER_LIST, PARAM_FIXED_FACTOR_SUPPLIER_LIST);
        	
        	evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "id", "stepStatus", "params"});
        }else {
        	evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "id", "stepStatus" });
        }
    }
    
    private SupplierEvaluationStep initSupplierEvaluationStep(SupplierEvaluationStep supplierEvaluationStep, String tenderId, String stepId, String supplierId) {
        if (null == supplierEvaluationStep) {
            supplierEvaluationStep = new SupplierEvaluationStep();
        }
        if(null == supplierEvaluationStep.getId()) {
        	supplierEvaluationStep.setId(IDUtils.getId());
        }
        supplierEvaluationStep.setTenderId(tenderId);
        supplierEvaluationStep.setStepId(stepId);
        supplierEvaluationStep.setSupplierId(supplierId);
        return supplierEvaluationStep;
        
    }
    
   private FixedFactorSupplierVo configFixedFactor(EvaluationStep evaluationStep, List<FixedFactorItemVo> fixedFactorItemVoList, String supplierId, BigDecimal supplierAvgScore) {
	   if(null != fixedFactorItemVoList && null != supplierAvgScore) {
			for(FixedFactorItemVo vo : fixedFactorItemVoList) {
				int mathCount = 0;
				if(null != vo.getItemMinScore()) {
					if(vo.isIncludeMin()) {
						if(supplierAvgScore.compareTo(vo.getItemMinScore()) >= 0) {
							mathCount ++;
						}
					}else {
						if(supplierAvgScore.compareTo(vo.getItemMinScore()) > 0) {
							mathCount ++;
						}
					}
				}
				if(null != vo.getItemMaxScore()) {
					if(vo.isIncludeMax()) {
						if(supplierAvgScore.compareTo(vo.getItemMaxScore()) <= 0) {
							mathCount ++;
						}
					}else {
						if(supplierAvgScore.compareTo(vo.getItemMaxScore()) < 0) {
							mathCount ++;
						}
					}
				}
				if(mathCount == 2) {
					FixedFactorSupplierVo fixedFactorSupplierScore = new FixedFactorSupplierVo();
					fixedFactorSupplierScore.setName(vo.getName());
					fixedFactorSupplierScore.setSupplierId(supplierId);
					return fixedFactorSupplierScore;
				}
			}
		}
	   return null;
	   
   }
    /**
     * @Description: 删除评审结果记录
     * @author mazc
     * @param tenderId
     * @param evaluationStep
     * @param userIdList
     * @return
     */
    @Override
    public Integer deleteDirtyEvaluationResult(String tenderId, EvaluationStep evaluationStep, List<String> userIdList) {
        int iCount = 0;
        if (null != userIdList && userIdList.size() > 0) {
            boolean deleteFactorResult = false;
            if (EvaluationStepEnum.COMPLIANCE.equals(evaluationStep.getStepType()) || EvaluationStepEnum.DETAIL.equals(evaluationStep.getStepType()) || EvaluationStepEnum.PRICE.equals(evaluationStep.getStepType()) || EvaluationStepEnum.CLEAN_TENDER.equals(evaluationStep.getStepType())) {
                deleteFactorResult = true;
            }
            iCount += expertEvaluationStepMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
            iCount += expertEvaluationResultMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
            if (deleteFactorResult) {
                iCount += evaluationFactorResultMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
            }
            if (EvaluationStepEnum.CLEAN_TENDER.equals(evaluationStep.getStepType())) {
                iCount += checkResultMapper.deleteEvaluationResultAndUserId(tenderId, evaluationStep.getId(), userIdList);
            }
        }
        return iCount;
    }
    
    /**
   	 * @Description: 获得评审成员对指定项目的指定序号的评标步骤
   	 * @author wangxiang
   	 * @param tenderId
   	 * @param sort
   	 * @param userId
   	 * @return
   	 */
	@Override
	public ExpertEvaluationStep getExpertEvaluationStepBySort(String tenderId, int sort, String userId) {
		return expertEvaluationStepMapper.getExpertEvaluationStepBySort(tenderId,sort,userId);
	}

	/**
	 * @Description: 获得某一评标步骤评标专家评审完成的数量
	 * @author wangxiang
	 * @param tenderId
	 * @param stepId
	 * @return
	 */
	@Override
	public int getExpertEvaluationComplateCount(String tenderId, String stepId) {
		Integer count = expertEvaluationStepMapper.getExpertEvaluationComplateCount(tenderId,stepId);
		return null != count ? count : 0;
	}

	/**
	 * @Description: 评标专家签到
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @return
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
    public boolean submitExpertSignEvaluation(String tenderId, String userId, EvaluationStep evaluationStep, String signType, String signResult) {
        expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
        
        UpdateWrapper<ExpertEntity> expertWrapper = new UpdateWrapper<>();
        expertWrapper.set("SIGN_TYPE", signType)
                     .set("SIGN_RESULT", signResult)
                     .set("SIGN_TIME", new Date())
                     .lambda().eq(ExpertEntity::getTenderId, tenderId)
                              .eq(ExpertEntity::getUserId, userId);
        expertMapper.update(null, expertWrapper);
        expertMapper.deleteDirtyExpert(tenderId);
        
        // 如果没有完成签到操作，则需要验证是否已经全部签到
        if (null == evaluationStep.getStepStatus() || !evaluationStep.getStepStatus().equals(CommonEnum.COMPLETE)) {
            List<Object> objIdsList = expertMapper.getUnsignedExpertIdList(tenderId);
            // 如果所有评标专家都签到完成，则修改项目的评审状态
            if (null == objIdsList || objIdsList.size() == 0) {
                // 修改项目的评审状态为完成
                if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
                    tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
                }
                evaluationStep.setStepStatus(CommonEnum.COMPLETE);
                evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
            } else // 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
                if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
                    // 修改项目的评审状态为进行中
                    tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
                    evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
                    evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
                }
        }
        return true;
    }

	/**
	 * @Description: 提交推荐中标候选人结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierEvalResultList
	 * @return
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitRecommonedEvaluationResult(String tenderId, String userId, String evaluationOpinion, EvaluationStep evaluationStep, List<SupplierEvaluationResult> supplierEvalResultList) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		// 批量保存投标人评标结果
		if (null != supplierEvalResultList && supplierEvalResultList.size() > 0) {
			supplierEvaluationResultService.saveOrUpdateBatch(supplierEvalResultList);
		}
		// 修改供应商整体废标状态
		supplierEvaluationResultService.updateSupplierEvaluationAccessmentStatus(tenderId, evaluationStep.getSortNo());

		// 修改项目的评审状态为完成
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		
		UpdateWrapper<TenderProject> wrapper = new UpdateWrapper<>();
		wrapper.lambda().set(TenderProject::getEvaluationStatus, "评标结束")
						.set(TenderProject::getComplateStatus, CommonEnum.COMPLETE)
						.set(TenderProject::getEffectiveType, TenderProjectEnum.EFFECTIVE_YES)
						.set(TenderProject::getEvaluationOpinion, evaluationOpinion)
						.eq(TenderProject::getId, tenderId);
		
		tenderProjectMapper.update(null, wrapper);

		return true;
	}

	   /**
     * @Description: 保存特征码检查结果
     * @author wangxiang
     * @param checkResultList
     * @return
     */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean saveFeatureEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<CheckResult> checkResultList, List<ExpertEvaluationResult> expertEvaluationResultList) {
		QueryWrapper<CheckResult> wrapper = new QueryWrapper<>();
		wrapper.lambda().eq(CheckResult::getTenderId, tenderId)
						.eq(CheckResult::getStepId, evaluationStep.getId())
						.eq(CheckResult::getUserId, userId);
		checkResultService.remove(wrapper);
		if(null != checkResultList) {
			checkResultService.saveBatch(checkResultList);
		}
		
		expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
		expertEvaluationResultService.saveBatch(expertEvaluationResultList);
		// 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			// 修改项目的评审状态为进行中
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return true;
	}

	/**
	 * @Description:  提交特征码检查结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierList
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitFeatureEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		int expertCount = 1;
		// 是否最后一个评标专家提交
		boolean isLastSubmit;
		// 如果是专家组长，则认为是最后一人提交	
		if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EXPERT_LEADER)) {
			isLastSubmit = true;
		} else {
			// 获得当前评审完成的专家个数
			int evaluationComplateCount = expertEvaluationStepMapper.getExpertEvaluationComplateCount(tenderId, evaluationStep.getId());
			expertCount = expertMapper.findEvaluationStepExpertCount(tenderId, evaluationStep);
			// 如果评审完成的专家个数 > 当前节点评审的专家，则认为当前是最后一们专家提交结果
			isLastSubmit = evaluationComplateCount >= expertCount;
		}
		// 是否筛选投标人
		boolean isFilterSupplier = ObjectUtils.equals(evaluationStep.getFilterType(), EvaluationStepEnum.FILTER_YES);
		// 如果所有评标专家都评完成，则修改项目的评审状态
		if (isLastSubmit) {
			List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
			// 用于记录投标人在当前评标步骤的评分汇总
			for (Supplier supplier : supplierList) {
				String supplierAccement = EvaluationStepEnum.QUALIFIED;
				// 如果需要筛选投标人
				if (isFilterSupplier) {
					int accessmentNoCount = expertEvaluationResultMapper.getSupplierDisAccessmentCount(tenderId, evaluationStep.getId(), supplier.getId());
					if (accessmentNoCount > 0) {
						// 如果是少数服从多数
						if (ObjectUtils.equals(evaluationStep.getPassType(), EvaluationStepEnum.PASS_MORE)) {
							if (accessmentNoCount > expertCount / 2) {
								supplierAccement = EvaluationStepEnum.UNQUALIFIED;
							}
						} else {
							supplierAccement = EvaluationStepEnum.UNQUALIFIED;
						}
					}
				}
				// 投标人评标结果
				QueryWrapper<SupplierEvaluationResult> wrapper = new QueryWrapper<>();
				wrapper.lambda().eq(SupplierEvaluationResult::getTenderId, tenderId)
								.eq(SupplierEvaluationResult::getSupplierId, supplier.getId())
								.select(SupplierEvaluationResult::getId);
				
				SupplierEvaluationResult supplierEvaluationResult = supplierEvaluationResultMapper.selectOne(wrapper);
				if (null == supplierEvaluationResult) {
					supplierEvaluationResult = new SupplierEvaluationResult();
					supplierEvaluationResult.setId(IDUtils.getId());
					supplierEvaluationResult.setTenderId(tenderId);
					supplierEvaluationResult.setSupplierId(supplier.getId());
					supplierEvaluationResult.setAccessment(supplierAccement);
					supplierEvaluationResultMapper.insert(supplierEvaluationResult);
				} else if (!ObjectUtils.equals(supplierEvaluationResult.getAccessment(), supplierAccement)) {
					supplierEvaluationResult.setAccessment(supplierAccement);
					supplierEvaluationResultService.updateAssignProperty(supplierEvaluationResult, new String[] { "accessment" });
				}

				SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();// supplierEvaluationStepDao.getSupplierEvaluationStep(tenderId, supplier.getId(), evaluationStep.getId());
				supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
				supplierEvaluationStep.setAccessment(supplierAccement);
				supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
				supplierEvaluationStepList.add(supplierEvaluationStep);
			}
			if (supplierEvaluationStepList.size() > 0) {
				// 先删除投标人在该评标步骤全部的评审记录
				supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
				supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList);
			}
			// 修改项目的评审状态为完成
			if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
				tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
			}
			evaluationStep.setStepStatus(CommonEnum.COMPLETE);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return true;
	}


	/**
	 * @Description: 保存限价检查结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param expertEvaluationResultMap
	 * @return
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean saveLimitPriceEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, Map<String, ExpertEvaluationResult> expertEvaluationResultMap) {
		int count = 0;
		boolean flag = false;
		expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        List<ExpertEvaluationResult> expertEvaluationResultList = new ArrayList<>(expertEvaluationResultMap.values());
		expertEvaluationResultMapper.insertByBatch(expertEvaluationResultList);
		// 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			count += tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			flag =  evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return count == 0 || flag;
	}

	   /**
		 * @Description: 提交限价检查结果
		 * @author wangxiang
		 * @param tenderId
		 * @return 
		 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitLimitPriceEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
		List<ExpertEvaluationResult> expertEvaluationResultList = expertEvaluationResultMapper.getExpertEvaluationResultList(tenderId, evaluationStep.getId(), userId);
		for (final Supplier supplier : supplierList) {
			ExpertEvaluationResult evaluationResult = CollectionUtils.get(expertEvaluationResultList, t -> t.getSupplierId().equals(supplier.getId()));
			if (null == evaluationResult) {
				continue;
			}
			String supplierAccement = evaluationResult.getAccessment();
			String supplierOpinion = evaluationResult.getSupplierOpinion();
			// 投标人评标结果
			SupplierEvaluationResult supplierEvaluationResult = supplier.getSupplierEvaluationResult();
			if(null == supplierEvaluationResult || null == supplierEvaluationResult.getId()){
				supplierEvaluationResult = new SupplierEvaluationResult();
				supplierEvaluationResult.setId(supplierEvaluationResultMapper.getCreateSupplierEvaluationResultId(tenderId, supplier.getId()));
			}
			supplierEvaluationResult.setAccessment(supplierAccement);
//			supplierEvaluationResult.setEvaluationOpinion(supplierOpinion);
			supplierEvaluationResultService.updateAssignProperty(supplierEvaluationResult, new String[] { "accessment"});
			
			SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
			supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
			supplierEvaluationStep.setId(IDUtils.getId());
			supplierEvaluationStep.setAccessment(supplierAccement);
			supplierEvaluationStep.setSupplierOpinion(supplierOpinion);
			supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
			supplierEvaluationStepList.add(supplierEvaluationStep);
		}
		if (supplierEvaluationStepList.size() > 0) {
			// 先删除投标人在该评标步骤全部的评审记录
			supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
			supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList);
		}
		// 修改项目的评审状态为完成
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		return true;
	}

	 /**
		 * @Description: 重新授权专家的评标步骤
		 * @author wangxiang
		 * @param tenderId
		 * @param stepId
		 * @param nodeSortNo
		 * @param ifFilter
		 */
	@Override
	@Transactional(rollbackFor = Exception.class)
    public boolean reBackExpertEvaluationStep(String tenderId, String stepId, int nodeSortNo, boolean ifFilter, String userId) {
        //更新专家评标步骤
        UpdateWrapper<ExpertEvaluationStep> updateWraaper = new UpdateWrapper<>();
        updateWraaper.set("STEP_STATUS", CommonEnum.RE_OPERATOR)
                     .set("PRICE_CONFIRM_STATUS", null)
                     .lambda().eq(ExpertEvaluationStep::getTenderId, tenderId)
                              .eq(ExpertEvaluationStep::getStepId, stepId)
                              .and(
                                      t -> t.eq(ExpertEvaluationStep::getStepStatus, CommonEnum.IN_PROGRESS)
                                            .or()
                                            .eq(ExpertEvaluationStep::getStepStatus, CommonEnum.COMPLETE)
                              );
        if (StringUtils.isNotEmpty(userId)) {
            updateWraaper.lambda().eq(ExpertEvaluationStep::getUserId, userId);
        }
        
        expertEvaluationStepMapper.update(null, updateWraaper);
        
        //授权任何节点操作时都重新授权推荐评标步骤	
        expertEvaluationStepMapper.reStartRecommendStep(CommonEnum.RE_OPERATOR, tenderId, EvaluationStepEnum.RECOMMONED, EvaluationStepEnum.PRICE, CommonEnum.IN_PROGRESS, CommonEnum.COMPLETE, ifFilter, nodeSortNo);
        
        return true;
    }

	 /**
		 * @Description: 获得专家确认修正评标价结果列表
		 * @author guoyr
		 * @param tenderId
		 * @param stepId
		 * @return
		 */
	@Override
	public List<ExpertEvaluationStep> getEvalPriceConfirmList(String tenderId, String stepId) {
		return expertEvaluationStepMapper.getEvalPriceConfirmList(tenderId,stepId,ExpertEnum.AVOID);
	}

	/**
	 * @Description: 获得步骤下已经评审完毕的专家
	 * @author wangxiang
	 * @param tenderId
	 * @param stepId
	 * @return
	 */
	@Override
	public List<ExpertEntity> getExpertListByStepFinish(String tenderId, String stepId) {
		return expertEvaluationStepMapper.getExpertListByStepFinish(tenderId,stepId,CommonEnum.COMPLETE);
	}


	/**保存推荐排名结果
	 * @Description: 
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param expertEvaluationResultList
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean saveRecommendRankEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<ExpertEvaluationResult> expertEvaluationResultList) {
		int count = 0;
		expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
		if(null != expertEvaluationResultList && expertEvaluationResultList.size() > 0){
			expertEvaluationResultService.insertByBatch(expertEvaluationResultList);
		}
		// 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			count += tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return count >= 0;
	}

	/**
	 * @Description: 提交推荐排名结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierList
	 * @param count
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitRecommendRankEvaluationResultVo(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList, int count) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		// 是否最后一个评标专家提交
		boolean isLastSubmit;
		// 如果是专家组长，则认为是最后一人提交
		if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EXPERT_LEADER)) {
			isLastSubmit = true;
		} else {
			// 获得当前评审完成的专家个数
			int evaluationComplateCount = expertEvaluationStepMapper.getExpertEvaluationComplateCount(tenderId, evaluationStep.getId());
			// 如果评审完成的专家个数 > 当前节点评审的专家，则认为当前是最后一们专家提交结果
			isLastSubmit = evaluationComplateCount >= expertMapper.findEvaluationStepExpertCount(tenderId, evaluationStep);
		}
		if (isLastSubmit) {
			final Map<String, Map<Integer, Integer>> supplierRankVoteMap = new HashMap<>();
			for (Supplier supplier : supplierList) {
				List<ExpertEvaluationResult> expertEvaluationResultList = expertEvaluationResultMapper.getSupplierStepAllExpertEvaluationResultList(tenderId, evaluationStep.getId(), supplier.getId());
				Map<Integer, Integer> supplierExpertVoteMap = new HashMap<>();
				for (ExpertEvaluationResult expertEvaluationResult : expertEvaluationResultList) {
					int sortNo = expertEvaluationResult.getSortNo();
					if (sortNo == 0) {
						continue;
					}
					int value = supplierExpertVoteMap.getOrDefault(sortNo, 0);
					supplierExpertVoteMap.put(sortNo, ++value);
				}
				supplierRankVoteMap.put(supplier.getId(), supplierExpertVoteMap);
			}

			ListSortUtils<Supplier> listSortUtils = new ListSortUtils<>(supplierList, (behindSupplier, frontSupplier) -> {
                Map<Integer, Integer> frontRankMap = supplierRankVoteMap.get(frontSupplier.getId());
                Map<Integer, Integer> behindRankMap = supplierRankVoteMap.get(behindSupplier.getId());
                return compareMap(frontRankMap, behindRankMap, 1, count);
            });

			List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
			for (Supplier supplier : supplierList) {
				SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
				supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
				supplierEvaluationStep.setSortNo(listSortUtils.getSortNo(supplier));
				supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
				supplierEvaluationStepList.add(supplierEvaluationStep);
			}
			if (supplierEvaluationStepList.size() > 0) {
				// 先删除投标人在该评标步骤全部的评审记录
				supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
				supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList);
			}
		}
		// 修改项目的评审状态为完成
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });

		return true;
	}
	
	private int compareMap(Map<Integer, Integer> frontRankMap, Map<Integer, Integer> behindRankMap, int index, int recommendCount) {
		if (index > recommendCount) {
			return 0;
		}
		int frontCount = frontRankMap.getOrDefault(index, 0);
		int behindCount = behindRankMap.getOrDefault(index, 0);
		if (frontCount == behindCount) {
			return compareMap(frontRankMap, behindRankMap, ++index, recommendCount);
		}
		return frontCount - behindCount;
	}

	/**
	 * @Description: 保存否决投标结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param expertEvaluationResultMap
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean saveVetoBidEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, Map<String, ExpertEvaluationResult> expertEvaluationResultMap) {
		expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        List<ExpertEvaluationResult> expertEvaluationResultList = new ArrayList<>(expertEvaluationResultMap.values());
		for(ExpertEvaluationResult expertEvaluationResult : expertEvaluationResultList) {
			if(null == expertEvaluationResult.getId()) {
				expertEvaluationResult.setId(IDUtils.getId());
			}
		}
		expertEvaluationResultService.insertByBatch(expertEvaluationResultList);
		// 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return true;
	}

	/**
	 * @Description: 提交否决投标结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierList
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitVetoBidEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
		List<SupplierEvaluationResult> evaluationResultList = new ArrayList<>();

		for (Supplier supplier : supplierList) {

			String supplierAccement = EvaluationStepEnum.QUALIFIED;
			SupplierEvaluationResult supplierEvaluationResult = supplier.getSupplierEvaluationResult();
			if (null == supplierEvaluationResult || null == supplierEvaluationResult.getId()) {
				supplierEvaluationResult = new SupplierEvaluationResult();
				supplierEvaluationResult.setId(supplierEvaluationResultMapper.getCreateSupplierEvaluationResultId(tenderId, supplier.getId()));
			}

			// 获得当前供应商评标专家结论为不通过的家数
			int accessmentNoCount = expertEvaluationResultMapper.getSupplierDisAccessmentCount(tenderId, evaluationStep.getId(), supplier.getId());
			if (accessmentNoCount > 0) {
				supplierAccement = EvaluationStepEnum.UNQUALIFIED;
			}
			supplierEvaluationResult.setAccessment(supplierAccement);
			supplier.setSupplierEvaluationResult(supplierEvaluationResult);

			evaluationResultList.add(supplierEvaluationResult);

			SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
			supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
			supplierEvaluationStep.setAccessment(supplierAccement);
			supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
			supplierEvaluationStepList.add(supplierEvaluationStep);
		}
		if (evaluationResultList.size() > 0) {
			supplierEvaluationResultService.batchSaveOrUpdate(evaluationResultList, new String[] { "accessment" });
		}
		if (supplierEvaluationStepList.size() > 0) {
			// 先删除投标人在该评标步骤全部的评审记录
			supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
			supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList);
		}
		// 修改项目的评审状态为完成
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		return true;
	}

	/**
	 * @Description: 保存信用得分结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierList
	 * @param expertEvaluationResultMap
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitCreditEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList, Map<String, ExpertEvaluationResult> expertEvaluationResultMap) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();

		for (Supplier supplier : supplierList) {

			String supplierAccement = EvaluationStepEnum.QUALIFIED;
			SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
			supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
			supplierEvaluationStep.setAccessment(supplierAccement);
			supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplier.getId());
			if (null != expertEvaluationResult) {
				supplierEvaluationStep.setEvaluationScore(expertEvaluationResult.getEvaluationScore());
				supplierEvaluationStep.setEvaluationFinalScore(expertEvaluationResult.getEvaluationFinalScore());
				supplierEvaluationStep.setSortNo(expertEvaluationResult.getSortNo());
			}
			supplierEvaluationStepList.add(supplierEvaluationStep);
		}
		if (supplierEvaluationStepList.size() > 0) {
			// 先删除投标人在该评标步骤全部的评审记录
			supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
			supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList);
		}
		// 修改项目的评审状态为完成
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		return true;
	}

	/**
	 * @Description: 保存清单评审结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param expertEvaluationResultMap
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean saveBillEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, Map<String, ExpertEvaluationResult> expertEvaluationResultMap) {
		expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
		List<ExpertEvaluationResult> expertEvaluationResultList = new ArrayList<>(expertEvaluationResultMap.values());
		if(expertEvaluationResultList.size() > 0){
			expertEvaluationResultService.insertByBatch(expertEvaluationResultList);
		}
		// 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return true;
	}

	/**
	 * @Description: 提交多轮报价结果
	 * @author wangxiang
	 * @param status
	 * @param tenderId
	 * @param evaluationStep
	 * @param userId
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitMultiPriceResult(String status, String tenderId, EvaluationStep evaluationStep, String userId) {
		// 完成当前轮次评标
		ReBidPriceRound  reBidPriceRound= reBidPriceRoundMapper.getMaxRoundInfo(tenderId);
		reBidPriceRoundService.completeCurrentRound(reBidPriceRound);
		
		// 修改专家的多轮报价为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		// 修改项目的多轮报价为完成
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		return true;
	}

	/**
	 * @Description: 获得当前评标步骤之前未完成评审的个数
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param curStepIndex
	 * @return 
	 */
	@Override
	public Integer getNotComplateStepCount(String tenderId, String userId, int curStepIndex) {
		return expertEvaluationStepMapper.getNotComplateStepCount(tenderId,userId,curStepIndex,CommonEnum.COMPLETE);
	}

	/**
	 * @Description: 保存合量评审结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierList
	 * @param expertEvaluationResultMap
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean saveTotalPriceEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList, Map<String, ExpertEvaluationResult> expertEvaluationResultMap) {
		expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        List<ExpertEvaluationResult> expertEvaluationResultList = new ArrayList<>(expertEvaluationResultMap.values());
		expertEvaluationResultService.insertByBatch(expertEvaluationResultList);
		List<SupplierOpeningResult> openingResultList = new ArrayList<>();
		for (Supplier supplier : supplierList) {
			openingResultList.add(supplier.getSupplierOpeningResult());
		}
		if (openingResultList.size() != 0) {
			supplierOpeningResultService.batchSaveOrUpdate(openingResultList, new String[] { "bidPrice", "evaluationPrice" });
		}
		// 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		}
		return true;
	}

	/**
	 * @Description: 提交合量评审结果
	 * @author wangxiang
	 * @param tenderId
	 * @param userId
	 * @param evaluationStep
	 * @param supplierList
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public boolean submitTotalPriceEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<Supplier> supplierList) {
		// 修改专家的评审进度为完成
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
		List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
		List<ExpertEvaluationResult> expertEvaluationResultList = expertEvaluationResultMapper.getExpertEvaluationResultList(tenderId, evaluationStep.getId(), userId);
		for (final Supplier supplier : supplierList) {
			ExpertEvaluationResult evaluationResult = CollectionUtils.get(expertEvaluationResultList, t -> t.getSupplierId().equals(supplier.getId()));
			if (null == evaluationResult) {
				continue;
			}
			String supplierAccement = evaluationResult.getAccessment();
			String supplierOpinion = evaluationResult.getSupplierOpinion();
			// 投标人评标结果
			SupplierEvaluationResult supplierEvaluationResult = supplier.getSupplierEvaluationResult();
			if(null == supplierEvaluationResult || null == supplierEvaluationResult.getId()){
				supplierEvaluationResult = new SupplierEvaluationResult();
				supplierEvaluationResult.setId(supplierEvaluationResultMapper.getCreateSupplierEvaluationResultId(tenderId, supplier.getId()));
			}
			
			supplierEvaluationResult.setAccessment(supplierAccement);
//			supplierEvaluationResult.setEvaluationOpinion(supplierOpinion);
			
			supplierEvaluationResultService.updateAssignProperty(supplierEvaluationResult, new String[] {"accessment"});
			
			SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
			supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
			supplierEvaluationStep.setAccessment(supplierAccement);
			supplierEvaluationStep.setId(IDUtils.getId());
			supplierEvaluationStep.setSupplierOpinion(supplierOpinion);
			supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
			supplierEvaluationStepList.add(supplierEvaluationStep);
		}
		if (supplierEvaluationStepList.size() > 0) {
			// 先删除投标人在该评标步骤全部的评审记录
			supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
			supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList);
		}
		// 修改项目的评审状态为完成
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		return true;
	}

	/**
     * @Description: 根据步骤类型获取审核列表
     * @author chenxw
     * @param tenderId
     * @param stepType
     * @return 
     */
    @Override
    public List<Audit> getAuditListByStepType(String tenderId, String stepType) {
        List<ExpertEntity> expertList = expertService.getExpertList(tenderId, ExpertEnum.ALL);
        List<WorkMember> workerList = workerMapper.getWorkerList(false,tenderId, ExpertEnum.WORKER);
        List<EvaluationStep> evaluationStepList = evaluationStepService.getEvaluationStepListByType(tenderId, stepType);
        List<ExpertEvaluationStep> expertEvaluationStepList = expertEvaluationStepMapper.getExpertEvaluationStepByStepType(tenderId, stepType);
        
        Map<String, EvaluationStep> evaluationStepMap = new HashMap<>();
        if (CollectionUtils.isNotNull(evaluationStepList)) {
            for (EvaluationStep evaluationStep : evaluationStepList) {
                evaluationStepMap.put(evaluationStep.getId(), evaluationStep);
            }
        }
        
        Map<String, AuthUserEntity> userMap = new HashMap<>();
        if (CollectionUtils.isNotNull(expertList)) {
            for (ExpertEntity expert : expertList) {
                userMap.put(expert.getUserId(), expert.getUser());
            }
        }
        if (CollectionUtils.isNotNull(workerList)) {
            for (WorkMember worker : workerList) {
                userMap.put(worker.getUserId(), worker.getUser());
            }
        }
        
        List<Audit> arrayList = new ArrayList<>();
        if (CollectionUtils.isNotNull(expertEvaluationStepList)) {
            for (ExpertEvaluationStep expertEvaluationStep : expertEvaluationStepList) {
                Audit array = new Audit();
                array.setEvaluationStep(evaluationStepMap.get(expertEvaluationStep.getStepId()));
                array.setUser(userMap.get(expertEvaluationStep.getUserId()));
                array.setExpertEvaluationStep(expertEvaluationStep);
                arrayList.add(array);
            }
        }
        return arrayList;
    }
	
	/**
	 * @Description: 提交预评审结果
	 * @author wangxiang
	 * @param tenderId
	 * @param evaluationStep
	 * @return 
	 */
	@Override
    @Transactional(rollbackFor = Exception.class)
	public boolean submitPreEvaluationResult(String tenderId, EvaluationStep evaluationStep) {
		if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		}
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		return true;
	}

	/**
	 * @Description: 保存修正报价结果
	 * @author wangxiang
	 * @param tenderId
	 * @param evaluationStep
	 * @param editPriceItemResultList
	 * @param bidPriceResultList
	 * @return 
	 */
	@Override
    @Transactional(rollbackFor = Exception.class)
	public boolean submitTotalPriceEvaluationResult(String tenderId, EvaluationStep evaluationStep, List<EditPriceItemResult> editPriceItemResultList, List<BidPriceResult> bidPriceResultList) {
		String stepStatus = evaluationStep.getStepStatus();
		if(null != editPriceItemResultList) {
			editPriceItemResultService.batchSaveOrUpdate(editPriceItemResultList, new String[] { "editPrice", "editReason" });			
		}
		if(null != bidPriceResultList) {
			bidPriceResultService.batchUpdateProperty(bidPriceResultList, new String[] { "evaluationPrice" });			
		}
		supplierOpeningResultMapper.updateSupplierSumPrice(tenderId,null, false, true);
		if (!CommonEnum.IN_PROGRESS.equals(stepStatus) && !CommonEnum.RE_OPERATOR.equals(stepStatus)) {
			evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
			evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
			tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
		}
		return true;
	}

	/**
	 * @Description: 提交修正报价结果
	 * @author wangxiang
	 * @param tenderId
	 * @param evaluationStep
	 * @param userId
	 * @return 
	 */
	@Override
    @Transactional(rollbackFor = Exception.class)
	public boolean submitEditPriceResult(String tenderId, EvaluationStep evaluationStep, String userId) {
		evaluationStep.setStepStatus(CommonEnum.COMPLETE);
		evaluationStepService.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
		tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
		expertEvaluationStepMapper.updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, evaluationStep.getId(), userId);
	
		return true;
	}
	
	/** 
	 * @Description: 删除评审结果记录
	 * @author chenxw
	 * @param tenderId
	 * @param stepId
	 * @return 
	 */
	@Override
	public int deleteExpertEvaluationStep(String tenderId, String stepId) {
	    QueryWrapper<ExpertEvaluationStep> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ExpertEvaluationStep::getTenderId, tenderId)
                             .eq(ExpertEvaluationStep::getStepId, stepId);
        return expertEvaluationStepMapper.delete(queryWrapper);
	}

    /**
     * @Description: 指定字段修改
     * @author chenxw
     * @param expertEvaluationStep
     * @param attributes
     * @return
     */
    @Override
    public boolean updateAssignProperty(ExpertEvaluationStep expertEvaluationStep, String[] attributes) {
        return expertEvaluationStepMapper.updateAssignProperty(expertEvaluationStep, attributes) > 0;
    }
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param expertEvaluationStepList
     * @param attributes
     * @return
     */
    @Override
    public Integer batchUpdateProperty(List<ExpertEvaluationStep> expertEvaluationStepList, String[] attributes) {
        return expertEvaluationStepMapper.batchUpdateProperty(expertEvaluationStepList, attributes);
    }

    /**
     * @Description: 根据步骤类型删除专家评审步骤
     * @author chenxw
     * @param tenderId
     * @param stepType
     */
    @Override
    public Integer deleteExpertEvaluationStepByStepType(String tenderId, String stepType) {
        return expertEvaluationStepMapper.deleteExpertEvaluationStepByStepType(tenderId, stepType);
    }

    /**
     * @param tenderId
     * @param userId
     * @param evaluationStep
     * @param expertEvaluationResultList
     * @return
     * @Description: 保存清标检查结果
     * @author guoyr
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean saveCleanTenderEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<ExpertEvaluationResult> expertEvaluationResultList) {
        expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        expertEvaluationResultMapper.insertByBatch(expertEvaluationResultList);
        // 如果不是在进行中，且不是重新授权操作时，修改为评审进行中
        if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
            // 修改项目的评审状态为进行中
            tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "中");
            evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
            evaluationStepService.updateAssignProperty(evaluationStep, new String[]{"stepStatus"});
        }
        return true;
    }

    /**
     * @param tenderId
     * @param userId
     * @param evaluationStep
     * @param memberEvaluationStep
     * @param supplierList
     * @return
     * @Description: 提交清标检查结果
     * @author guoyr
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean submitCleanTenderEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, ExpertEvaluationStep memberEvaluationStep, List<Supplier> supplierList) {
        // 修改专家的评审进度为完成
        updateExpertEvaluationStatus(CommonEnum.COMPLETE, tenderId, evaluationStep, userId);
        int expertCount = 1;
        // 是否最后一个评标专家提交
        boolean isLastSubmit;
        // 如果是专家组长，则认为是最后一人提交
        if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EXPERT_LEADER)) {
            isLastSubmit = true;
        } else {
            // 获得当前评审完成的专家个数
            int evaluationComplateCount = expertEvaluationStepMapper.getExpertEvaluationComplateCount(tenderId, evaluationStep.getId());
            expertCount = expertMapper.findEvaluationStepExpertCount(tenderId, evaluationStep);
            // 如果评审完成的专家个数 > 当前节点评审的专家，则认为当前是最后一们专家提交结果
            isLastSubmit = evaluationComplateCount >= expertCount;
        }
        // 是否筛选投标人
        boolean isFilterSupplier = ObjectUtils.equals(evaluationStep.getFilterType(), EvaluationStepEnum.FILTER_YES);

        // 如果所有评标专家都评完成，则修改项目的评审状态
        if (isLastSubmit) {
            List<SupplierEvaluationStep> supplierEvaluationStepList = new ArrayList<>();
            // 用于记录投标人在当前评标步骤的评分汇总
            for (Supplier supplier : supplierList) {
                String supplierAccement = EvaluationStepEnum.QUALIFIED;
                // 如果需要筛选投标人
                if (isFilterSupplier) {
                    int accessmentNoCount = expertEvaluationResultMapper.getSupplierDisAccessmentCount(tenderId, evaluationStep.getId(), supplier.getId());
                    if (accessmentNoCount > 0) {
                        // 如果是少数服从多数
                        if (ObjectUtils.equals(evaluationStep.getPassType(), EvaluationStepEnum.PASS_MORE)) {
                            if (accessmentNoCount > expertCount / 2) {
                                supplierAccement = EvaluationStepEnum.UNQUALIFIED;
                            }
                        } else {
                            supplierAccement = EvaluationStepEnum.UNQUALIFIED;
                        }
                    }
                }
                SupplierEvaluationResult supplierEvaluationResult = new SupplierEvaluationResult();
                String supplierEvaluationResultId = supplierEvaluationResultMapper.getCreateSupplierEvaluationResultId(tenderId, supplier.getId());
                if (StringUtils.isEmpty(supplierEvaluationResultId)) {
                    supplierEvaluationResult.setId(IDUtils.getId());
                    supplierEvaluationResult.setTenderId(tenderId);
                    supplierEvaluationResult.setSupplierId(supplier.getId());
                    supplierEvaluationResult.setAccessment(supplierAccement);
                    supplierEvaluationResultMapper.insert(supplierEvaluationResult);
                } else {
                    supplierEvaluationResult.setId(supplierEvaluationResultId);
                }
                supplierEvaluationResult.setAccessment(supplierAccement);
                supplierEvaluationResultMapper.updateAssignProperty(supplierEvaluationResult, new String[]{"accessment"});

                SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();// supplierEvaluationStepDao.getSupplierEvaluationStep(tenderId, supplier.getId(), evaluationStep.getId());
                supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
                supplierEvaluationStep.setAccessment(supplierAccement);
                supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
                supplierEvaluationStepList.add(supplierEvaluationStep);
            }
            if (supplierEvaluationStepList.size() > 0) {
                // 先删除投标人在该评标步骤全部的评审记录
                supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
                supplierEvaluationStepService.batchSaveOrUpdate(supplierEvaluationStepList, new String[]{"accessment", "stepStatus"});
            }
            // 修改项目的评审状态为完成
            if (!ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)) {
                tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
            }
            evaluationStep.setStepStatus(CommonEnum.COMPLETE);
            evaluationStepService.updateAssignProperty(evaluationStep, new String[]{"stepStatus"});
        }
        return true;
    }

    /**
     * @Description: 保存商务否决评审结果
     * @author chenxw
     * @param tenderId
     * @param evaluationStep
     * @param userId
     * @param expertEvaluationResultList
     * @return
     */
    @Override
    public boolean saveBusinessVetoEvaluationResult(String tenderId, EvaluationStep evaluationStep, String userId, List<ExpertEvaluationResult> expertEvaluationResultList) {
        expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        boolean isSuccess = expertEvaluationResultMapper.insertByBatch(expertEvaluationResultList) != 0;
        return updateEvaluationStatus(tenderId, evaluationStep, isSuccess);
    }

    /**
     * @Description: 提交商务评审结果
     * @author chenxw
     * @param tenderId
     * @param evaluationStep
     * @param userId
     * @param supplierList
     * @return
     */
    @Override
    public boolean submitBusinessVetoEvaluationResult(String tenderId, EvaluationStep evaluationStep, String userId, List<Supplier> supplierList) {
        updateExpertEvaluationStatus(CommonEnum.COMPLETE, tenderId, evaluationStep, userId);

        int evaluationComplateCount = expertEvaluationStepMapper.getExpertEvaluationComplateCount(tenderId, evaluationStep.getId());
        int expertCount = expertMapper.findEvaluationStepExpertCount(tenderId, evaluationStep);
        boolean isLastExpertSubmit = evaluationComplateCount >= expertCount;

        if (isLastExpertSubmit) {
            List<SupplierEvaluationStep> supplierEvalStepList = new ArrayList<>();
            List<SupplierEvaluationResult> supplierEvalResultList = new ArrayList<>();
            for (Supplier supplier : supplierList) {
                String supplierAccement = EvaluationStepEnum.QUALIFIED;
                int accessmentNoCount = expertEvaluationResultMapper.getSupplierDisAccessmentCount(tenderId, evaluationStep.getId(), supplier.getId());
                if (accessmentNoCount > 0) {
                    if (EvaluationStepEnum.PASS_MORE.equals(evaluationStep.getPassType())) {
                        if (accessmentNoCount > expertCount / 2) {
                            supplierAccement = EvaluationStepEnum.UNQUALIFIED;
                        }
                    } else {
                        supplierAccement = EvaluationStepEnum.UNQUALIFIED;
                    }
                }

                addSupplierEvaluationStep(tenderId, evaluationStep, supplierEvalStepList, supplier, supplierAccement);

                SupplierEvaluationResult supplierEvaluationResult = supplier.getSupplierEvaluationResult();
                if (null == supplierEvaluationResult) {
                    supplierEvaluationResult = new SupplierEvaluationResult();
                    supplierEvaluationResult.setTenderId(tenderId);
                    supplierEvaluationResult.setSupplierId(supplier.getId());
                }
                supplierEvaluationResult.setAccessment(supplierAccement);
                supplierEvalResultList.add(supplierEvaluationResult);
            }
            if (!supplierEvalStepList.isEmpty()) {
                // 先删除投标人在该评标步骤全部的评审记录
                supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
                supplierEvaluationStepService.insertByBatch(supplierEvalStepList);
            }
            if (!supplierEvalResultList.isEmpty()) {
                supplierEvaluationResultService.batchSaveOrUpdate(supplierEvalResultList, new String[]{"accessment"});
            }
            evaluationStep.setStepStatus(CommonEnum.COMPLETE);
            evaluationStepMapper.updateAssignProperty(evaluationStep, new String[]{"stepStatus"});
            tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
        }
        return true;
    }

    /**
     * @Description: 添加供应商评审步骤
     * @author chenxw
     * @param tenderId
     * @param evaluationStep
     * @param supplierEvalStepList
     * @param supplier
     * @param supplierAccement
     */
    private void addSupplierEvaluationStep(String tenderId, EvaluationStep evaluationStep, List<SupplierEvaluationStep> supplierEvalStepList, Supplier supplier, String supplierAccement) {
        supplierEvalStepList.add(getSupplierEvaluationStep(tenderId, evaluationStep, supplier, supplierAccement));
    }

    private SupplierEvaluationStep getSupplierEvaluationStep(String tenderId, EvaluationStep evaluationStep, Supplier supplier, String supplierAccement) {
        SupplierEvaluationStep supplierEvaluationStep = new SupplierEvaluationStep();
        supplierEvaluationStep = initSupplierEvaluationStep(supplierEvaluationStep, tenderId, evaluationStep.getId(), supplier.getId());
        supplierEvaluationStep.setAccessment(supplierAccement);
        supplierEvaluationStep.setStepStatus(CommonEnum.COMPLETE);
        return supplierEvaluationStep;
    }

    /**
     * @Description: 保存商务评审结果
     * @author chenxw
     * @param tenderId
     * @param userId
     * @param evaluationStep
     * @param evaluationFactorResultList
     * @param expertEvaluationResultList
     * @return
     */
    @Override
    public boolean saveBusinessEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<EvaluationFactorResult> evaluationFactorResultList, List<ExpertEvaluationResult> expertEvaluationResultList) {
        boolean isSuccess = true;
        evaluationFactorResultMapper.deleteEvaluationFactorResult(tenderId, evaluationStep.getId(), userId);
        if (evaluationFactorResultMapper.insertByBatch(evaluationFactorResultList) == 0) {
            isSuccess = false;
        }
        expertEvaluationResultMapper.deleteExpertEvaluationResult(tenderId, evaluationStep.getId(), userId);
        if (expertEvaluationResultMapper.insertByBatch(expertEvaluationResultList) == 0) {
            isSuccess = false;
        }
        return updateEvaluationStatus(tenderId, evaluationStep, isSuccess);
    }

    private boolean updateEvaluationStatus(String tenderId, EvaluationStep evaluationStep, boolean isSuccess) {
        if (isSuccess && !CommonEnum.IN_PROGRESS.equals(evaluationStep.getStepStatus()) && !CommonEnum.RE_OPERATOR.equals(evaluationStep.getStepStatus())) {
            evaluationStep.setStepStatus(CommonEnum.IN_PROGRESS);
            evaluationStepMapper.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
            tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "进行中");
        }
        return isSuccess;
    }

    /**
     * @Description: 提交商务评审结果
     * @author chenxw
     * @param tenderId
     * @param userId
     * @param evaluationStep
     * @param supplierEvaluationStepList
     * @return
     */
    @Override
    public boolean submitBusinessEvaluationResult(String tenderId, String userId, EvaluationStep evaluationStep, List<SupplierEvaluationStep> supplierEvaluationStepList) {
        boolean isSuccess = true;
        updateExpertEvaluationStatus(CommonEnum.COMPLETE, tenderId, evaluationStep, userId);
        supplierEvaluationStepMapper.deleteSupplierEvaluationStep(evaluationStep.getTenderId(), evaluationStep.getId());
        if (supplierEvaluationStepService.insertByBatch(supplierEvaluationStepList) == 0) {
            isSuccess = false;
        }
        if (isSuccess) {
            evaluationStep.setStepStatus(CommonEnum.COMPLETE);
            evaluationStepMapper.updateAssignProperty(evaluationStep, new String[] { "stepStatus" });
            tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成");
        }
        return isSuccess;
    }

    /**
     * @Description: 提交评审结果
     * @author chenxw
     * @param tenderId
     * @param stepId
     * @param userId
     * @return
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean submitEvaluationStep(String tenderId, String stepId, String userId) {
        Assert.isTrue(updateExpertEvaluationStepStatus(CommonEnum.COMPLETE, new Date(), tenderId, stepId, userId), "修改专家评审进度为完成状态失败");
        EvaluationStep evaluationStep = evaluationStepMapper.selectById(stepId);
        boolean submit = false;
        switch (evaluationStep.getStepType()) {
            case EvaluationStepEnum.PRICE:
                submit = true;
                break;
        }
        if (submit) {
            evaluationStep.setStepStatus(CommonEnum.COMPLETE);
            Assert.isTrue(evaluationStepMapper.updateAssignProperty(evaluationStep, new String[]{"stepStatus"}) > 0, "修改步骤状态失败！");
            Assert.isTrue(tenderProjectMapper.updateEvaluateStatus(tenderId, evaluationStep.getStepName() + "完成") > 0, "修改项目评审状态失败！");
        }
        return true;
    }

}
