package com.gx.obe.server.management.im.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.im.entity.ChatGroup;
import com.gx.obe.server.management.im.service.ChatGroupService;
import com.gx.obe.server.management.im.vo.SaveGroupVo;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/im/chatGroup")
public class ChatGroupController extends BaseController<ChatGroupService,ChatGroup>{
	@Autowired
	public ChatGroupService chatGroupServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ChatGroupList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<ChatGroup> ChatGroupList) {
		return chatGroupServices.insertByBatch(ChatGroupList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ChatGroupList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<ChatGroup> ChatGroupList) {
		return chatGroupServices.updateByBatch(ChatGroupList);
	}

	/**
	 * @Description: 
	 * @author mazc
	 * @param userId
	 * @return 
	 */
	@GetMapping("/getGroupList")
	public List<ChatGroup> getGroupList(String userId){
		return chatGroupServices.getGroupList(userId);
	}
	
	@PostMapping("/saveGroup")
	public ChatGroup saveGroup(@RequestBody SaveGroupVo saveGroupVo) {
		return chatGroupServices.saveGroup(saveGroupVo.getCroup(), saveGroupVo.getAssignedDepartmentIdList());
	}
		 
	
}