package com.gx.obe.server.management.im.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.im.entity.ChatRecord;
import com.gx.obe.server.management.im.service.ChatRecordService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/im/chatRecord")
public class ChatRecordController extends BaseController<ChatRecordService,ChatRecord>{
	@Autowired
	public ChatRecordService ChatRecordServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ChatRecordList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<ChatRecord> ChatRecordList) {
		return ChatRecordServices.insertByBatch(ChatRecordList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ChatRecordList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<ChatRecord> ChatRecordList) {
		return ChatRecordServices.updateByBatch(ChatRecordList);
	}

	@GetMapping("/getRecordPage")
	public IPage<ChatRecord> getRecordPage(String sendId, String receiveId, int pageNo,int pageSize) {
 		 return ChatRecordServices.getRecordPage(sendId, receiveId, pageNo,pageSize);
	}

	@GetMapping("/getGroupRecordPage")
	public IPage<ChatRecord> getGroupRecordPage(String groupId, int pageNo, int pageSize) {
		 return ChatRecordServices.getGroupRecordPage(groupId,pageNo,pageSize);
	}
	
	@GetMapping("/getNoticeRecordPage")
	public IPage<ChatRecord> getNoticeRecordPage(String noticeId, int pageNo, int pageSize) {
		return ChatRecordServices.getNoticeRecordPage(noticeId,pageNo,pageSize);
	}
	
	@PostMapping("/saveOrUpdate")
	public boolean saveOrUpdate(@RequestBody ChatRecord record) {
		 return ChatRecordServices.saveOrUpdate(record);
	}
}