package com.gx.obe.server.management.im.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.im.entity.Department;
import com.gx.obe.server.management.im.service.DepartmentService;

import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@RestController
@AllArgsConstructor
@RequestMapping("/im/department")
public class DepartmentController extends BaseController<DepartmentService,Department>{
	@Autowired
	public DepartmentService departmentServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param DepartmentList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<Department> DepartmentList) {
		return departmentServices.insertByBatch(DepartmentList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param DepartmentList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<Department> DepartmentList) {
		return departmentServices.updateByBatch(DepartmentList);
	}

	/**
	 * @Description:  获得部门最大序号
	 * @author mazc
	 * @param parentId
	 * @return 
	 */
	@GetMapping("/getMaxDepartmentSortNo")
	public int getMaxDepartmentSortNo(String parentId) {
		return departmentServices.getMaxDepartmentSortNo(parentId);
	}
	
	
	/**
	 * @Description:  获得所有部门列表
	 * @author mazc
	 * @return 
	 */
	@GetMapping("/getAllDepartmentList")
	public List<Department> getAllDepartmentList(){
		return departmentServices.getAllDepartmentList();	
	}
 
	/**
	 * @Description:  获得员工所属部门
	 * @author mazc
	 * @param employeeId
	 * @return 
	 */
	@GetMapping("/getDirectAssignedDepartment")
	public List<Department> getDirectAssignedDepartment(String employeeId){
		return departmentServices.getDirectAssignedDepartment(employeeId);
	}
	
	
}