package com.gx.obe.server.management.im.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.im.entity.Employee;
import com.gx.obe.server.management.im.entity.GroupItem;
import com.gx.obe.server.management.im.service.GroupItemService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/im/groupItem")
public class GroupItemController extends BaseController<GroupItemService,GroupItem>{
	@Autowired
	public GroupItemService GroupItemServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param GroupItemList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<GroupItem> GroupItemList) {
		return GroupItemServices.insertByBatch(GroupItemList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param GroupItemList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<GroupItem> GroupItemList) {
		return GroupItemServices.updateByBatch(GroupItemList);
	}
	
	@GetMapping("/getGroupItemByGroupId")
	public List<Employee> getGroupItemByGroupId(String groupId){
		return GroupItemServices.getGroupItemByGroupId(groupId);
	}
	
	@GetMapping("/getUserIdListByGroupId")
	public List<Object> getUserIdListByGroupId(String groupId) {
		return GroupItemServices.getUserIdListByGroupId(groupId);
	}
	
	
}