package com.gx.obe.server.management.im.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.im.entity.GroupMessage;
import com.gx.obe.server.management.im.service.GroupMessageService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/im/groupMessage")
public class GroupMessageController extends BaseController<GroupMessageService,GroupMessage>{
	@Autowired
	public GroupMessageService groupMessageServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param GroupMessageList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<GroupMessage> GroupMessageList) {
		return groupMessageServices.insertByBatch(GroupMessageList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param GroupMessageList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<GroupMessage> GroupMessageList) {
		return groupMessageServices.updateByBatch(GroupMessageList);
	}

	@GetMapping("/getGruptMessageByReceiveIdlist")
	public List<Object> getGruptMessageByReceiveIdlist(String id){
		return groupMessageServices.getGruptMessageByReceiveIdlist(id);
	}
	@GetMapping("/getReceiveIdListByMessageIdAndGroupId")
	public List<Object> getReceiveIdListByMessageIdAndGroupId(String id, String groupId) {
		return groupMessageServices.getReceiveIdListByMessageIdAndGroupId(id, groupId);
	}
	@GetMapping("/deleteGroupMessageByMessageIdAndGroupIdAndReceiveId")
	public int deleteGroupMessageByMessageIdAndGroupIdAndReceiveId(String id, String groupId, String myId) {
		return groupMessageServices.deleteGroupMessageByMessageIdAndGroupIdAndReceiveId(id, groupId, myId);
	}
	
}