package com.gx.obe.server.management.im.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.im.entity.EmployeeDepartment;

import java.util.List;

/** 
 * @Description: 
 * @author mazc 
 */
@Mapper
public interface EmployeeDepartmentMapper extends BaseMapper<EmployeeDepartment> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param EmployeeDepartmentList 
	 */
	Integer updateBatchList(@Param("EmployeeDepartmentList") List<EmployeeDepartment> EmployeeDepartmentList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param EmployeeDepartmentList 
	 */
	Integer insertByBatch(@Param("EmployeeDepartmentList") List<EmployeeDepartment> EmployeeDepartmentList);

	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param EmployeeDepartment
	 * @param attributes
     */
    Integer updateAssignProperty(@Param("EmployeeDepartment")EmployeeDepartment EmployeeDepartment, @Param("attributes")String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param EmployeeDepartmentList
	 * @param attributes
     */
    Integer batchUpdateProperty(@Param("EmployeeDepartmentList")List<EmployeeDepartment> EmployeeDepartmentList, @Param("attributes")String[] attributes);

}