package com.gx.obe.server.management.im.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.im.entity.Employee;
import com.gx.obe.server.management.im.entity.GroupItem;

import java.util.List;

/** 
 * @Description: 
 * @author mazc 
 */
@Mapper
public interface GroupItemMapper extends BaseMapper<GroupItem> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param GroupItemList 
	 */
	Integer updateBatchList(@Param("GroupItemList") List<GroupItem> GroupItemList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param GroupItemList 
	 */
	Integer insertByBatch(@Param("GroupItemList") List<GroupItem> GroupItemList);

	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param GroupItem
	 * @param attributes
     */
    Integer updateAssignProperty(@Param("GroupItem")GroupItem GroupItem, @Param("attributes")String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param GroupItemList
	 * @param attributes
     */
    Integer batchUpdateProperty(@Param("GroupItemList")List<GroupItem> GroupItemList, @Param("attributes")String[] attributes);
    
    
 
	 /**
	 * @Description: 获得群组成员
	 * @author mazc
	 * @param groupId
	 * @return 
	 */
	List<Employee> getGroupItemByGroupId(@Param("groupId")String groupId);

}