package com.gx.obe.server.management.im.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.im.entity.Message;

import java.util.List;

/** 
 * @Description: 
 * @author mazc 
 */
@Mapper
public interface MessageMapper extends BaseMapper<Message> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param MessageList 
	 */
	Integer updateBatchList(@Param("MessageList") List<Message> MessageList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param MessageList 
	 */
	Integer insertByBatch(@Param("MessageList") List<Message> MessageList);

	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param Message
	 * @param attributes
     */
    Integer updateAssignProperty(@Param("Message")Message Message, @Param("attributes")String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param MessageList
	 * @param attributes
     */
    Integer batchUpdateProperty(@Param("MessageList")List<Message> MessageList, @Param("attributes")String[] attributes);

}