package com.gx.obe.server.management.im.service.impl;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.beans.factory.annotation.Autowired;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.ArrayList;
import java.util.List;

import com.gx.obe.server.common.utils.IDUtils;
import com.gx.obe.server.common.utils.StringUtils;
import com.gx.obe.server.management.im.dao.EmployeeDepartmentMapper;
import com.gx.obe.server.management.im.entity.EmployeeDepartment;
import com.gx.obe.server.management.im.service.EmployeeDepartmentService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
public class EmployeeDepartmentServiceImpl extends ServiceImpl<EmployeeDepartmentMapper, EmployeeDepartment> implements EmployeeDepartmentService {

	@Autowired
	private EmployeeDepartmentMapper employeeDepartmentMapper;
	
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param EmployeeDepartmentList 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Integer updateByBatch(List<EmployeeDepartment> EmployeeDepartmentList) {
		return employeeDepartmentMapper.updateBatchList(EmployeeDepartmentList);
	}
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param EmployeeDepartmentList 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Integer insertByBatch(List<EmployeeDepartment> EmployeeDepartmentList) {
		return employeeDepartmentMapper.insertByBatch(EmployeeDepartmentList);
	}
	
	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param EmployeeDepartment
	 * @param attributes
     */
	@Override
    public boolean updateAssignProperty(EmployeeDepartment EmployeeDepartment, String[] attributes) {
		return employeeDepartmentMapper.updateAssignProperty(EmployeeDepartment, attributes) > 0;
	}
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param EmployeeDepartmentList
	 * @param attributes
     */
	@Override
    public Integer batchUpdateProperty(List<EmployeeDepartment> EmployeeDepartmentList, String[] attributes) {
		return employeeDepartmentMapper.batchUpdateProperty(EmployeeDepartmentList, attributes);
	}
	
	/** 
	 * @Description: 批量添加或跟新
	 * @author chenxw
	 * @param EmployeeDepartmentList
	 * @param attributes
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
    public Integer batchSaveOrUpdate(List<EmployeeDepartment> EmployeeDepartmentList, String[] attributes) {
        List<EmployeeDepartment> insertEmployeeDepartmentList = new ArrayList<>();
        List<EmployeeDepartment> updateEmployeeDepartmentList = new ArrayList<>();
        for (EmployeeDepartment EmployeeDepartment : EmployeeDepartmentList) {
            if (StringUtils.isEmpty(EmployeeDepartment.getId())) {
                EmployeeDepartment.setId(IDUtils.getId());
                insertEmployeeDepartmentList.add(EmployeeDepartment);
            } else {
                updateEmployeeDepartmentList.add(EmployeeDepartment);
            }
        }
        int count = 0;
        if (insertEmployeeDepartmentList.size() > 0) {
            count += employeeDepartmentMapper.insertByBatch(insertEmployeeDepartmentList);
        }
        if (updateEmployeeDepartmentList.size() > 0) {
            count += employeeDepartmentMapper.batchUpdateProperty(updateEmployeeDepartmentList, attributes);
        }
        return count;
    }

}
