package com.gx.obe.server.management.menu.service;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.menu.entity.AuthMenuEntity;
 
 /**  
 * 
 * @author 
 * @Title: AuthMenuService
 * @Package com.gx.obe.server.management.menu.service  
 * @Description:    
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date:   2019-05-09   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
public interface AuthMenuService extends IService<AuthMenuEntity> {
	
	 /**   
	 * @Title: selectUserResourceMenuList   
	 * @Description: 查询用户菜单list
	 * @param: @param userId
	 * @param: @param roleType
	 * @param: @param useStatus
	 * @param: @return      
	 * @return: List<AuthMenuEntity>      
	 * @throws   
	 */  
	List<AuthMenuEntity> selectUserResourceMenuList(String userId, String roleType ,String useStatus);
	/**   
	 * @Title: getUserRoleMenuList   
	 * @Description: 查询用户菜单list
	 * @param: @param userId
	 * @param: @param roleType
	 * @param: @param useStatus
	 * @param: @return      
	 * @return: List<AuthMenuEntity>      
	 * @throws   
	 */  
	List<AuthMenuEntity> getUserRoleMenuList(String userId, String roleId ,String useStatus);

	/**
	 * @Description: 获得全部菜单信息(包含子菜单和父级菜单信息)
	 * @author wangxiang
	 * @param type
	 * @return 
	 */
	List<AuthMenuEntity> getAllResourceList(String type);

	/**
	 * @Description: 获得菜单的最大序号
	 * @author wangxiang
	 * @param parentId
	 * @return
	 */
	Integer getMaxResourceSortNo(String parentId, String menuType);

	/**
	 * @Description: 交换两个菜单的排序
	 * @author chenxw
	 * @param sourceId
	 * @param targetId
	 * @return 
	 */
	boolean changeResourceSortNo(String sourceId, String targetId);

	/**
	 * @Description: 查询用户权限菜单
	 * @author wangxiang
	 * @param userId
	 * @param roleType
	 * @param parentMenuId
	 * @return 
	 */
	List<AuthMenuEntity> getUserResourceList(String userId, String roleType);

	/**
	 * @Description: 根据类型获得菜单列表
	 * @author wangxiang
	 * @param menuType
	 * @return 
	 */
	List<AuthMenuEntity> getMenuListByMenuType(String menuType);

	/**
	 * @Description: 菜单编号是否唯一
	 * @author wangxiang
	 * @param menuId
	 * @param menuCode
	 * @return 
	 */
	boolean isUniqueMenuCode(String menuId, String menuCode);

	/**
	 * @Description: 根据类型获得菜单列表
	 * @author wangxiang
	 * @param menuType
	 * @return 
	 */
	List<AuthMenuEntity> getMenuListByMenuCode(String menuCode);

	/**
	 * @Description: 获得菜单下的功能集
	 * @author wangxiang
	 * @param menuId
	 * @return 
	 */
	Map<String, String> getMenuFunctionMap(String menuId);
	
	
    AuthMenuEntity saveOrUpdateNoEmptyReturn(AuthMenuEntity menu);
    
    /**
     * @Description: 
     * @author chenxw
     * @param list
     * @param attributes
     * @return 
     */
    boolean batchUpdateProperty(List<AuthMenuEntity> menuList, String[] attributes);
    
    boolean updateAssignProperty(AuthMenuEntity menu);

    AuthMenuEntity getMenuByMenuCode(String menuCode);
    
    
    Integer deleteByMenuId(String menuId);
}

