package com.gx.obe.server.management.negotiation.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.management.negotiation.dao.NegotiationResultMapper;
import com.gx.obe.server.management.negotiation.entity.NegotiationResult;
import com.gx.obe.server.management.negotiation.service.NegotiationResultService;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
@Transactional
public class NegotiationResultServiceImpl extends ServiceImpl<NegotiationResultMapper, NegotiationResult> implements NegotiationResultService {

	@Autowired
	private NegotiationResultMapper negotiationResultMapper;
	
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeNegotiationResultList 
	 */
	 @Override
	 @Transactional(rollbackFor = Exception.class)
	public Integer updateByBatch (List<NegotiationResult> ObeNegotiationResultList){
		return negotiationResultMapper.updateBatchList(ObeNegotiationResultList);
	}
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeNegotiationResultList 
	 */
	 @Override
	 @Transactional(rollbackFor = Exception.class)
	public Integer insertByBatch (List<NegotiationResult> ObeNegotiationResultList){
		return negotiationResultMapper.insertByBatch(ObeNegotiationResultList);
	}
	
	/** 
	 * @Description: 删除所有的谈判结果
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	@Override
	public int deleteStepByTenderId(String tenderId) {
		QueryWrapper<NegotiationResult> queryWrapper = new QueryWrapper<NegotiationResult>();
		queryWrapper.lambda().eq(NegotiationResult::getTenderId, tenderId);
		return negotiationResultMapper.delete(queryWrapper);
	}
}
