package com.gx.obe.server.management.other.dao;

import java.util.Date;
import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.other.entity.SignatureUser;
/** 
 * @Description: 
 * @author mazc 
 */
 @Mapper
public interface SignatureUserMapper extends BaseMapper<SignatureUser> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeSignatureUserList 
	 */
	Integer updateBatchList (@Param("ObeSignatureUserList") List<SignatureUser> ObeSignatureUserList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeSignatureUserList 
	 */
	Integer insertByBatch (@Param("ObeSignatureUserList")List<SignatureUser> ObeSignatureUserList);

	/**
	 * @Description: 指定字段修改
	 * @author chenxw
	 * @param ObeSignatureUser
	 * @param attributes
	 */
	Integer updateAssignProperty(@Param("ObeSignatureUser")SignatureUser ObeSignatureUser, @Param("attributes")String[] attributes);

	/**
	 * @Description: 批量指定字段修改
	 * @author chenxw
	 * @param ObeSignatureUserList
	 * @param attributes
	 */
	Integer batchUpdateProperty(@Param("ObeSignatureUserList")List<SignatureUser> ObeSignatureUserList, @Param("attributes")String[] attributes);

	 /**
	 * @Description: 获得当前用户需要签章的报表
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @return 
	 */
	List<SignatureUser> getUserSignatureFileList(@Param("tenderId")String tenderId, @Param("userId")String userId);
	
	
	 /**
	 * @Description: 获得当前用户需要签章的报表
	 * @author mazc
	 * @param signatureId
	 * @param userId
	 * @return 
	 */
	SignatureUser getSignatureUserById(@Param("id")String id);
	
	
	 /**
	 * @Description: 修改用户签章状态
	 * @author mazc
	 * @param id
	 * @param signatureType
	 * @param signatureTime
	 * @return 
	 */
	Integer updateSignatureUser(@Param("id")String id, @Param("signatureType")String signatureType, @Param("signatureTime")Date signatureTime);
	
	/**
	 * @Description: 通过用户名修改用户签章状态
	 * @author guoyr
	 * @param id
	 * @param userName
	 * @param signatureType
	 * @return 
	 */
	Integer updateSignatureTypeByUserName(@Param("signatureId")String signatureId, @Param("userName")String userName, @Param("signatureType")String signatureType, @Param("signatureTime")Date signatureTime);

}