package com.gx.obe.server.management.other.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.management.other.dao.TaxVatitemMapper;
import com.gx.obe.server.management.other.entity.TaxVATItem;
import com.gx.obe.server.management.other.service.TaxVatitemService;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
@Transactional
public class TaxVatitemServiceImpl extends ServiceImpl<TaxVatitemMapper, TaxVATItem> implements TaxVatitemService {

	@Autowired
	private TaxVatitemMapper taxVatitemMapper;
	
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeVatitemList 
	 */
	 @Override
	 @Transactional(rollbackFor = Exception.class)
	public Integer updateByBatch (List<TaxVATItem> ObeVatitemList){
		return taxVatitemMapper.updateBatchList(ObeVatitemList);
	}
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeVatitemList 
	 */
	 @Override
	 @Transactional(rollbackFor = Exception.class)
	public Integer insertByBatch (List<TaxVATItem> ObeVatitemList){
		return taxVatitemMapper.insertByBatch(ObeVatitemList);
	}
	

}
