package com.gx.obe.server.management.project.dao;

import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gx.obe.server.management.project.entity.TenderProject;
import com.gx.obe.server.management.vo.TenderPackPriceFactorVo;
import com.gx.obe.server.management.vo.TenderProjectVo;

/**
 * 
 * @author
 * @Title: TenderProject
 * @Package com.gx.obe.server.management.user.entity
 * @Description: ObeTenderProjectMapper 接口
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date: 2019-04-29
 * @version V1.0
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved.
 * 
 */
@Mapper
public interface TenderProjectMapper extends BaseMapper<TenderProject> {
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeTenderProjectList 
	 */
	Integer updateBatchList (@Param("ObeTenderProjectList")List<TenderProject> ObeTenderProjectList);
	
	/**
 	 * @Description: 批量指定字段修改
 	 * @author chenxw
 	 * @param tenderProjectList
 	 * @param attributes
 	 */
 	Integer batchUpdateProperty(List<TenderProject> tenderProjectList, String[] attributes);
 	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeTenderProjectList 
	 */
	Integer insertByBatch (@Param("ObeTenderProjectList")List<TenderProject> ObeTenderProjectList);
	
	
	/**
	 * @Description: 按分页查询评标项目
	 * @author mazc
	 * @param page
	 * @param user
	 * @param useSatus
	 * @param searchKey
	 * @return 
	 */
	IPage<TenderProjectVo> selectEvaluationProjectPage(Page<TenderProjectVo> page ,@Param("userId")String userId, @Param("roleType")String roleType, 
												 @Param("useSatus")String useSatus,@Param("searchKey")String searchKey);
	
	/**
	 * @Description: 按分页查询评标项目的分包
	 * @author mazc
	 * @param page
	 * @param userId
	 * @param projectId
	 * @param useSatus
	 * @return 
	 */
	IPage<TenderProjectVo> getExpertEvaluationTenderPackPageList(Page<TenderProjectVo> page,@Param("userId")String userId, 
											     @Param("projectId")String projectId,@Param("evaluatoinStatus")String evaluatoinStatus);
	
	/**
	 * @Description: 获得招标项目分页列表
	 * @author guoyr
	 * @param page
	 * @param userId
	 * @param userType
	 * @param openingStatus
	 * @param searchKey
	 * @param startTime
	 * @param endTime
	 * @return 
	 */
	IPage<TenderProjectVo> getTenderProjectPageList(
	            Page<TenderProjectVo> page,
	            @Param("userId") String userId,
	            @Param("userType") String userType,
	            @Param("queryOpeningComplateCount") boolean queryOpeningComplateCount, 
	            @Param("openingStatus") String openingStatus, 
	            @Param("queryEvaluationComplateCount") boolean queryEvaluationComplateCount, 
	            @Param("evaluationStatus") String evaluationStatus, 
	            @Param("searchKey") String searchKey,
	            @Param("startTime") Date startTime,
	            @Param("endTime") Date endTime
			);
	/**
	 * @Description: 获取开标项目的标段分页列表
	 * @author guoyr
	 * @param page
	 * @param parentId
	 * @param userType
	 * @param openingStatus
	 * @param searchKey
	 * @param startTime
	 * @param endTime
	 * @return 
	 */
	IPage<TenderProjectVo> getTenderPackPageList(
			Page<TenderProjectVo> page,
			@Param("parentId") String parentId,
			@Param("userType") String userType,
			@Param("userId") String userId,
			@Param("openingStatus") String openingStatus,
			@Param("evaluationStatus") String evaluationStatus, 
			@Param("searchKey") String searchKey,
			@Param("startTime") Date startTime,
			@Param("endTime") Date endTime
			);

	/**
	 * @Description: 按分页查询监督人监督项目
	 * @author mazc
	 * @param page
	 * @param userId
	 * @param useSatus
	 * @param searchKey
	 * @return 
	 */
	IPage<TenderProjectVo> selectSuperviseProjectPage(
			 Page<TenderProjectVo> page,
	            @Param("userId") String userId,
	            @Param("queryOpeningComplateCount") boolean queryOpeningComplateCount, 
	            @Param("openingStatus") String openingStatus, 
	            @Param("queryEvaluationComplateCount") boolean queryEvaluationComplateCount, 
	            @Param("evaluationStatus") String evaluationStatus, 
	            @Param("searchKey") String searchKey,
	            @Param("startTime") Date startTime,
	            @Param("endTime") Date endTime
			);
	
	/**
	 * @Description: 分页通过id查询项目id
	 * @author mazc
	 * @param page
	 * @param tenderId
	 * @return 
	 */
	IPage<TenderProject> selectTenderProjectPack(Page<TenderProject> page, @Param("parentId") String parentId);
	
	
	/**
	 * @Description: 获得可唱标的包件
	 * @author mazc
	 * @param page
	 * @param tenderId
	 * @return 
	 */
	IPage<TenderProject> findSignBidTenderPackagePageList(Page<TenderProject> page, @Param("parentId") String parentId);
	

	/**
	 * @Description:  获得分包项目
	 * @author mazc
	 * @param page
	 * @param parentId
	 * @return 
	 */
	IPage<TenderProjectVo> selectSubPackagePage(Page<TenderProjectVo> page, @Param("parentId") String parentId);

	/**
	 * @Description: 
	 * @author mazc
	 * @param id
	 * @param useStatus
	 * @param tenderNO
	 * @param phaseType
	 * @param parentId
	 * @return 
	 */
	Integer selectUniqueTedderProjectCount(@Param("id") String id, @Param("useStatus") String useStatus,
			@Param("tenderNO") String tenderNO, @Param("phaseType") String phaseType,
			@Param("parentId") String parentId);

	/**
	 * @Description: 通过父级id查找
	 * @author mazc
	 * @param parentId
	 * @return 
	 */
	List<String> getTenderIdList(@Param("parentId") String parentId);
	
	/**
	 * @Description: 验证项目是否已经进入指定的评审环节
	 * @author mazc
	 * @param tenderId
	 * @param stepType
	 * @return 
	 */
	Integer isInEvaluation(@Param("tenderId")String tenderId, @Param("stepType")String stepType);

	/**
	 * @Description: 获取标段价格指标信息
	 * @author mazc
	 * @param tenderParentId
	 * @param auditType
	 * @return 
	 */
	List<TenderPackPriceFactorVo> selectTenderPackPriceFactor(@Param("tenderParentId")String tenderParentId,@Param("auditType")String auditType);
	
	
	/**
	 * @Description: 通过tenderParentId 查询项目信息
	 * @author mazc
	 * @param tenderParentId
	 * @return 
	 */
	List<TenderProject> findSubPackageList(@Param("tenderParentId")String tenderParentId);
	
	/**
	 * @Description: 修改项目的进度状态
	 * @author mazc
	 * @param tenderId
	 * @param status
	 * @return 
	 */
	Integer updateEvaluateStatus(@Param("tenderId")String tenderId, @Param("status")String status);
	
	
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param userId
	 * @param searchKey
	 * @param macName
	 * @return 
	 */
	List<TenderProject> selectExpertTenderProjectList(@Param("userId") String userId,@Param("searchKey")String searchKey, @Param("macName") String macName);
	
	
	/**
	 * @Description: 修改开标状态
	 * @author mazc
	 * @param tenderId
	 * @param parentId
	 * @param bidOpeningStatus
	 * @return 
	 */
	Integer updateBidopeningStatus(@Param("tenderId")String tenderId, @Param("parentId")String parentId, @Param("bidOpeningStatus")String bidOpeningStatus);
	
	
	
	/**
	 * @Description: 查询包件组装的开标信息
	 * @author mazc
	 * @param projectId
	 * @param isParentProject
	 * @return 
	 */
	List<Map<String, Object>> selectTenderPackOpeningInfoList(@Param("projectId")String projectId,@Param("isParentProject") boolean isParentProject, @Param("bidopeningStage") String bidopeningStage);
	
	
	/**
	 * @Description: 获得分包项目
	 * @author mazc
	 * @param parentId
	 * @return 
	 */
	List<TenderProject> selectSubPackageList(@Param("parentId") String parentId);
	
	
	/**
	 * @Description: 获得项目或标包的开标信息
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	TenderProject selectTenderProjectBidOpeningInfo(@Param("tenderId")String tenderId);
	
	/**
	 * @Description: 获得包件的开标信息
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	List<TenderProject> selectgetTenderPackBidOpeningInfoList(@Param("tenderId")String tenderId);
	
	/**
	 * @Description: 获得最新获取投标信息状态
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	String getLatestBidinfo(@Param("tenderId")String tenderId);
	/**
	 * @Description: 获取开标状态
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	String getBidOpeningStatus(@Param("tenderId")String tenderId);
	/**
	 * @Description: 获取评标结束状态
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	String getComplateStatus(@Param("tenderId")String tenderId);
	
	/**
	 * @Description:  根据项目tenderNo和父ID，获得项目ID。
	 * @author mazc
	 * @param tenderNo
	 * @param parentId
	 * @return 
	 */
	List<String> queryTenderIdListByTenderNoAndparentId(@Param("tenderNo")String tenderNo, @Param("parentId")String parentId) ;
	

	 /**
	 * @Description: 获取（查询）项目列表
	 * @author mazc
	 * @param searchKey
	 * @param userId
	 * @return 
	 */
	List<Map<String,Object>> queryTenderProjectIdsList(@Param("searchKey")String searchKey, @Param("userId") String userId);
	
	
	
	 /**
	 * @Description: 
	 * @author mazc
	 * @param tenderIds
	 * @return 
	 */
	List<TenderProject> getTenderProjectList(@Param("idList")List<String> idList);
	
	
	
	 /**
	 * @Description: 
	 * @author mazc
	 * @param projectId
	 * @param withoutTenderId
	 * @return 
	 */
	List<Map<String, Object>> getTenderPackEvaluationInfoList( @Param("projectId") String projectId, @Param("withoutTenderId") String withoutTenderId);
	
	
	/**
	 * @Description: 获得可生成报表的包件信息
	 * @author mazc
	 * @param projectId
	 * @param withoutTenderId
	 * @return 
	 */
	List<Map<String, Object>> getReportTenderPackInfoList(@Param("projectId")String projectId, @Param("withoutTenderId") String withoutTenderId);
	
	
	
	/**
	 * @Description: 获得当前项目下所有标段专家信息
	 * @author mazc
	 * @param projectId
	 * @param withoutTenderId
	 * @return 
	 */
	List<Map<String, Object>> getTenderPackExpertInfoList(@Param("projectId")String projectId,  @Param("withoutTenderId")String withoutTenderId);
	
	
	List<TenderProject> getTenderProjectByExpert();
	
	Integer updateServerContent(@Param("serverId")String serverId, @Param("serverAccount")String serverAccount, @Param("serverPassword")String serverPassword,@Param("parentId") String parentId);

	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param ObeTenderProject
     */
    Integer updateAssignProperty (@Param("ObeTenderProject")TenderProject ObeTenderProject, @Param("attributes")String[] attributes);
    
    /**
	 * @Description: 验证项目是否已经完成指定阶段的开标
	 * @param tenderId
	 * @param bidopeningStage
	 * @return
	 */
	Integer isComplateProjectOpeningByStage(@Param("tenderId")String tenderId, @Param("bidopeningStage")String bidopeningStage);

	/**
	 * @param tenderId
	 * @return
	 */
	Integer deleteDetailByTenderId(@Param("tenderId") String tenderId);

	/**
	 * @Description: 获取评标结束状态
	 * @author mazc
	 * @param tenderId
	 * @return
	 */
	String getUploadEvalResultStatus(@Param("tenderId")String tenderId);

    String getTenderId(@Param("tenderNo")String tenderNo, @Param("stageId")String stageId, @Param("tenderNonumber")String tenderNonumber);
}