package com.gx.obe.server.management.software.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.software.entity.ObeSoftware;
import com.gx.obe.server.management.software.service.ObeSoftwareService;
import com.gx.obe.server.management.vo.UpdateAssignPropertyVo;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "软件管理")
@RestController
@AllArgsConstructor
@RequestMapping("/software")
public class ObeSoftwareController extends BaseController<ObeSoftwareService,ObeSoftware>{
	@Autowired
	public ObeSoftwareService ObeSoftwareServices;
	
	@GetMapping("/getSoftwareList")
	public List<ObeSoftware>  getSoftwarePageList(String status){
 		return ObeSoftwareServices.getSoftwareList(status);
	}
	
	@GetMapping("/getSoftwareByCode")
	public ObeSoftware getSoftwareByCode(String softwareCode){
		return ObeSoftwareServices.getSoftwareByCode(softwareCode);
	}
	
	@PostMapping("/createSoftware")
	public Boolean createSoftware(@RequestBody ObeSoftware obeOtherSoftware) {
		return ObeSoftwareServices.createSoftware(obeOtherSoftware);
	}
	
	
	@PostMapping("/deletSoftware")
	public boolean deletSoftware(@RequestBody ObeSoftware otherSoftware) {
		return ObeSoftwareServices.deletSoftware(otherSoftware);
	}
	
	@PostMapping("/updateAssignProperty") 
	public boolean updateAssignProperty(@RequestBody UpdateAssignPropertyVo<ObeSoftware> updateAssignPropertyVo){
		ObeSoftware software = updateAssignPropertyVo.getEntity();
		String[] attributes = updateAssignPropertyVo.getAttributes();
		return ObeSoftwareServices.updateAssignProperty(software, attributes);
	} 
}