package com.gx.obe.server.management.struct_new.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.struct_new.entity.ObeBidderBasicInfo;
import com.gx.obe.server.management.struct_new.service.ObeBidderBasicInfoService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/obeBidderBasicInfo")
public class ObeBidderBasicInfoController extends BaseController<ObeBidderBasicInfoService, ObeBidderBasicInfo> {

    @Autowired
    public ObeBidderBasicInfoService ObeBidderBasicInfoServices;

    /**
     * @param ObeBidderBasicInfoList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObeBidderBasicInfo> ObeBidderBasicInfoList) {
        return ObeBidderBasicInfoServices.insertByBatch(ObeBidderBasicInfoList);
    }

    /**
     * @param ObeBidderBasicInfoList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObeBidderBasicInfo> ObeBidderBasicInfoList) {
        return ObeBidderBasicInfoServices.updateByBatch(ObeBidderBasicInfoList);
    }

    /**
     * @param tenderId
     * @param modelDataId
     * @return
     * @Description: 获取投标人基本情况列表
     * @author chenxw
     */
    @GetMapping("/getBidderBasicInfoList")
    public List<ObeBidderBasicInfo> getBidderBasicInfoList(String tenderId, String modelDataId) {
        return ObeBidderBasicInfoServices.getBidderBasicInfoList(tenderId, modelDataId);
    }

}