package com.gx.obe.server.management.struct_new.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.struct_new.entity.ObeFinance;
import com.gx.obe.server.management.struct_new.service.ObeFinanceService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/obeFinance")
public class ObeFinanceController extends BaseController<ObeFinanceService, ObeFinance> {

    @Autowired
    public ObeFinanceService ObeFinanceServices;

    /**
     * @param ObeFinanceList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObeFinance> ObeFinanceList) {
        return ObeFinanceServices.insertByBatch(ObeFinanceList);
    }

    /**
     * @param ObeFinanceList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObeFinance> ObeFinanceList) {
        return ObeFinanceServices.updateByBatch(ObeFinanceList);
    }

    /**
     * @param tenderId
     * @param modelDataId
     * @return
     * @Description: 获取财务状况列表
     * @author chenxw
     */
    @GetMapping("/getFinanceList")
    public List<ObeFinance> getFinanceList(String tenderId, String modelDataId) {
        return ObeFinanceServices.getFinanceList(tenderId, modelDataId);
    }

}