package com.gx.obe.server.management.struct_new.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.struct_new.entity.ObeModelData;
import com.gx.obe.server.management.struct_new.service.ObeModelDataService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/obeModelData")
public class ObeModelDataController extends BaseController<ObeModelDataService, ObeModelData> {

    @Autowired
    public ObeModelDataService ObeModelDataServices;

    /**
     * @param ObeModelDataList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObeModelData> ObeModelDataList) {
        return ObeModelDataServices.insertByBatch(ObeModelDataList);
    }

    /**
     * @param ObeModelDataList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObeModelData> ObeModelDataList) {
        return ObeModelDataServices.updateByBatch(ObeModelDataList);
    }

    /**
     * @param tenderId
     * @param supplierId
     * @param relChapterType
     * @param dataCode
     * @return
     * @Description: 获取对象结构化数据
     * @author chenxw
     */
    @GetMapping("/getModelData")
    public ObeModelData getModelData(String tenderId, String supplierId, String relChapterType, String dataCode) {
        return ObeModelDataServices.getModelData(tenderId, supplierId, relChapterType, dataCode);
    }

}