package com.gx.obe.server.management.struct_new.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.struct_new.entity.ObePerformance;
import com.gx.obe.server.management.struct_new.service.ObePerformanceService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/obePerformance")
public class ObePerformanceController extends BaseController<ObePerformanceService, ObePerformance> {

    @Autowired
    public ObePerformanceService ObePerformanceServices;

    /**
     * @param ObePerformanceList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObePerformance> ObePerformanceList) {
        return ObePerformanceServices.insertByBatch(ObePerformanceList);
    }

    /**
     * @param ObePerformanceList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObePerformance> ObePerformanceList) {
        return ObePerformanceServices.updateByBatch(ObePerformanceList);
    }

    /**
     * @param tenderId
     * @param modelDataId
     * @return
     * @Description: 获取业绩列表
     * @author chenxw
     */
    @GetMapping("/getPerformanceList")
    public List<ObePerformance> getPerformanceList(String tenderId, String modelDataId, String statue) {
        return ObePerformanceServices.getPerformanceList(tenderId, modelDataId, statue);
    }

}