package com.gx.obe.server.management.struct_new.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.struct_new.entity.ObeProjectLeader;
import com.gx.obe.server.management.struct_new.service.ObeProjectLeaderService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/obeProjectLeader")
public class ObeProjectLeaderController extends BaseController<ObeProjectLeaderService, ObeProjectLeader> {

    @Autowired
    public ObeProjectLeaderService ObeProjectLeaderServices;

    /**
     * @param ObeProjectLeaderList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObeProjectLeader> ObeProjectLeaderList) {
        return ObeProjectLeaderServices.insertByBatch(ObeProjectLeaderList);
    }

    /**
     * @param ObeProjectLeaderList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObeProjectLeader> ObeProjectLeaderList) {
        return ObeProjectLeaderServices.updateByBatch(ObeProjectLeaderList);
    }

    /**
     * @param tenderId
     * @param modelDataId
     * @return
     * @Description: 获取项目负责人列表
     * @author chenxw
     */
    @GetMapping("/getProjectLeaderList")
    public List<ObeProjectLeader> getProjectLeaderList(String tenderId, String modelDataId) {
        return ObeProjectLeaderServices.getProjectLeaderList(tenderId, modelDataId);
    }

}