package com.gx.obe.server.management.struct_new.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.struct_new.entity.ObeModelData;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeModelDataMapper extends BaseMapper<ObeModelData> {

    /**
     * @param ObeModelDataList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeModelDataList") List<ObeModelData> ObeModelDataList);

    /**
     * @param ObeModelDataList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeModelDataList") List<ObeModelData> ObeModelDataList);

    /**
     * @param ObeModelData
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeModelData") ObeModelData ObeModelData, @Param("attributes") String[] attributes);

    /**
     * @param ObeModelDataList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeModelDataList") List<ObeModelData> ObeModelDataList, @Param("attributes") String[] attributes);

}