package com.gx.obe.server.management.struct_new.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author mazc
 * @Description:
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("obe_performance")
public class ObePerformance extends Model<ObePerformance> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId("ID")
    private String id;
    /**
     * 项目ID
     */
    @TableField("TENDER_ID")
    private String tenderId;
    /**
     * 模型数据ID
     */
    @TableField("MODEL_DATA_ID")
    private String modelDataId;
    /**
     * 采购单位
     */
    @TableField("PURCHASING_UNIT")
    private String purchasingUnit;
    /**
     * 供货单位
     */
    @TableField("PARTNER")
    private String partner;
    /**
     * 项目名称
     */
    @TableField("PROJECT_NAME")
    private String projectName;
    /**
     * 签订日期
     */
    @TableField("SINGNING_DATE")
    private String singningDate;
    /**
     * 结束日期
     */
    @TableField("END_TIME")
    private String endTime;
    /**
     * 合同金额（单位：元）
     */
    @TableField("SINGNING_TOTAL")
    private String singningTotal;
    /**
     * 项目经理姓名
     */
    @TableField("PURCHASER")
    private String purchaser;
    /**
     * 代表联系电话
     */
    @TableField("PURCHASER_PHONE")
    private String purchaserPhone;
    /**
     * 业绩状态（00：进行中；01：已完成）
     */
    @TableField("STATUS")
    private String status;
    /**
     * 企业名称
     */
    @TableField("SUPPLIER_NAME")
    private String supplierName;
    /**
     * 项目所在地
     */
    @TableField("PROJECT_ADDRESS")
    private String projectAddress;
    /**
     * 发包人名称
     */
    @TableField("BUYER_NAME")
    private String buyerName;
    /**
     * 发包人地址
     */
    @TableField("BUYER_ADDRESS")
    private String buyerAddress;
    /**
     * 发包人电话
     */
    @TableField("BUYER_PHONE_NUMBER")
    private String buyerPhoneNumber;
    /**
     * 开工日期
     */
    @TableField("START_TIME")
    private String startTime;
    /**
     * 承担的工作
     */
    @TableField("WORK_UNDERTAKEN")
    private String workUndertaken;
    /**
     * 工程质量
     */
    @TableField("PROJECT_QUANTITY")
    private String projectQuantity;
    /**
     * 项目经理
     */
    @TableField("PROJECT_MANAGER")
    private String projectManager;
    /**
     * 技术负责人
     */
    @TableField("TECHNICAL_DIRECTOR")
    private String technicalDirector;
    /**
     * 总监理工程师
     */
    @TableField("CHIEF_SUPERVISION_ENGINEER")
    private String chiefSupervisionEngineer;
    /**
     * 总监理工程师电话
     */
    @TableField("CSE_PHONE_NUMBER")
    private String csePhoneNumber;
    /**
     * 项目描述
     */
    @TableField("PROJECT_DESC")
    private String projectDesc;
    /**
     * 调试范围及内容
     */
    @TableField("PROJECT_RANGE_AND_CONTENT")
    private String projectRangeAndContent;
    /**
     * 调试机构人数高峰
     */
    @TableField("SUPPLIER_WORKER_COUNTMAX")
    private String supplierWorkerCountmax;
    /**
     * 调试机构人数平均
     */
    @TableField("SUPPLIER_WORKER_COUNTAVE")
    private String supplierWorkerCountave;
    /**
     * 工程评定情况
     */
    @TableField("PROJECT_DEVICE_RESULT")
    private String projectDeviceResult;
    /**
     * 项目单位联系人
     */
    @TableField("BUYER_LINKMAN")
    private String buyerLinkman;
    /**
     * 是否附证明文件
     */
    @TableField("IS_HAVR_ACCESSORY")
    private String isHavrAccessory;
    /**
     * 是否为华能系统的项目
     */
    @TableField("IS_OUR_COMPANY_PROJECT")
    private String isOurCompanyProject;
    /**
     * 服务范围
     */
    @TableField("SERVICE_SCOPE")
    private String serviceScope;
    /**
     * 设备名称
     */
    @TableField("DEVICE_NAME")
    private String deviceName;
    /**
     * 型号和规格
     */
    @TableField("DEVICETYPE_SPECIFICATION")
    private String devicetypeSpecification;
    /**
     * 总容量
     */
    @TableField("TOTAL_CAPACITY")
    private String totalCapacity;
    /**
     * 台数
     */
    @TableField("NUMBER")
    private String number;
    /**
     * 合同时间
     */
    @TableField("CONTRACT_TIME")
    private String contractTime;
    /**
     * 投运时间
     */
    @TableField("COMMISSIONING_TIME")
    private String commissioningTime;
    /**
     * 备注
     */
    @TableField("MEMO")
    private String memo;
    /**
     * 建设规模
     */
    @TableField("PROJECT_SCALE")
    private String projectScale;
    /**
     * 专业人员人数
     */
    @TableField("PROFESSIONAL_NUMBER")
    private String professionalNumber;
    /**
     * 专业人员人月数
     */
    @TableField("PROFESSIONAL_WORKLOAD")
    private String professionalWorkload;
    /**
     * 合作公司提供人员月数
     */
    @TableField("PARTNER_PROFESSIONAL_WORKLOAD")
    private String partnerProfessionalWorkload;
    /**
     * 监理范围及内容
     */
    @TableField("SUPERVISION_CCONTENT")
    private String supervisionCcontent;
    /**
     * 监理效果
     */
    @TableField("SUPERVISION_RESULT")
    private String supervisionResult;
    /**
     * 关键人员姓名专业及职务
     */
    @TableField("KEY_STAFF_PROFESSIONAL_AND_DUTY")
    private String keyStaffProfessionalAndDuty;
    /**
     * 实际服务说明
     */
    @TableField("SERVICE_DESC")
    private String serviceDesc;
    /**
     * 履约日期
     */
    @TableField("EXECUTION_DATE")
    private String executionDate;
    /**
     * 规模类型
     */
    @TableField("PROJECT_SCALE_AND_TYPE")
    private String projectScaleAndType;
    /**
     * 设计阶段
     */
    @TableField("DESIGN_STAGE")
    private String designStage;
    /**
     * 设计范围
     */
    @TableField("DESIGN_RANGE")
    private String designRange;
    /**
     * 合作方式
     */
    @TableField("COOPERATION_WAY")
    private String cooperationWay;
    /**
     * 合同履行获奖情况/合同履行情况
     */
    @TableField("CONTRACT_EXECUTE_CONDITION")
    private String contractExecuteCondition;

}