package com.gx.obe.server.management.struct_new.enums;

import com.gx.obe.server.common.utils.EnumUtils;

import java.util.Map;
import java.util.Optional;
import java.util.function.Function;

public enum PerformanceStatus {
	/**
	 * 进行中
	 */
	PROGRESS("00", "进行中"),
	/**
	 * 已完成
	 */
	COMPLETED("01", "已投产");
	
	public static Map<String, PerformanceStatus> MAP = EnumUtils.toMap(values(), PerformanceStatus::getKey);

	public static Function<String, String> keyToValueFun = t -> Optional.ofNullable(t).map(MAP::get).map(PerformanceStatus::getName).orElse("未知状态");

	private String key;
	private String name;
	
	PerformanceStatus(String key, String name) {
		this.key = key;
		this.name = name;
	}
	
	public String getKey() {
		return key;
	}
	
	public String getName() {
		return name;
	}
	
}