package com.gx.obe.server.management.struct_new.handler;

import lombok.Getter;

import java.util.Optional;
import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@Getter
public class RelChapterTypeHandler {

    private final String relChapterType;

    private final String mark;

    private final boolean hasMark;

    private static final Set<String> SET = Stream.of("00", "01", "02").collect(Collectors.toSet());

    public RelChapterTypeHandler(String relChapterType) {
        Optional<String> mark = SET.stream().map("_"::concat).filter(relChapterType::endsWith).findAny();
        this.hasMark = mark.isPresent();
        if (this.hasMark) {
            this.mark = mark.get().substring(1);
            this.relChapterType = relChapterType.substring(0, relChapterType.length() - mark.get().length());
        } else {
            this.mark = null;
            this.relChapterType = relChapterType;
        }
    }

}
