package com.gx.obe.server.management.struct_new.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.struct_new.entity.ObeTemplateDataItem;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
public interface ObeTemplateDataItemService extends IService<ObeTemplateDataItem> {

    /**
     * @param ObeTemplateDataItemList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeTemplateDataItem> ObeTemplateDataItemList);

    /**
     * @param ObeTemplateDataItemList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeTemplateDataItem> ObeTemplateDataItemList);

    /**
     * @param ObeTemplateDataItem
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeTemplateDataItem ObeTemplateDataItem, String[] attributes);

    /**
     * @param ObeTemplateDataItemList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeTemplateDataItem> ObeTemplateDataItemList, String[] attributes);

    /**
     * @param ObeTemplateDataItemList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeTemplateDataItem> ObeTemplateDataItemList, String[] attributes);

    /**
     * @param tenderId
     * @param supplierId
     * @param factorCode
     * @return
     * @Description: 获取小范本表单列表
     * @author chenxw
     */
    List<ObeTemplateDataItem> getTemplateDataItemList(String tenderId, String supplierId, String factorCode);

    /**
     * @param tenderId
     * @param supplierId
     * @param contentId
     * @return
     * @Description: 获取小范本表单列表
     * @author chenxw
     */
    List<ObeTemplateDataItem> getListByContentId(String tenderId, String supplierId, String contentId);
}



