package com.gx.obe.server.management.supplier.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.supplier.entity.AreaSupplier;
import com.gx.obe.server.management.supplier.service.AreaSupplierService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/areaSupplier")
public class AreaSupplierController extends BaseController<AreaSupplierService,AreaSupplier>{
	@Autowired
	public AreaSupplierService areaSupplierServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param AreaSupplierList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<AreaSupplier> AreaSupplierList) {
		return areaSupplierServices.insertByBatch(AreaSupplierList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param AreaSupplierList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<AreaSupplier> AreaSupplierList) {
		return areaSupplierServices.updateByBatch(AreaSupplierList);
	}
	
	@GetMapping("/hasSupplier")
	public boolean hasSupplier(String areaSupplierName, String supplierType) {
		return areaSupplierServices.hasSupplier(areaSupplierName, supplierType);
	}
	
	@GetMapping("/getAreaSupplierListByName")
	public List<AreaSupplier> getAreaSupplierListByName(){
		return areaSupplierServices.getAreaSupplierListByName();
	}
	
	@PostMapping("/saveDownLoadAreaSupplier")
	public String saveDownLoadAreaSupplier(@RequestBody AreaSupplier areaSupplier){
		return areaSupplierServices.saveDownLoadAreaSupplier(areaSupplier);
	}
}