package com.gx.obe.server.management.supplier.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.supplier.entity.SupplierEvaluationStep;
import com.gx.obe.server.management.supplier.service.SupplierEvaluationStepService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/supplierEvaluationStep")
public class SupplierEvaluationStepController extends BaseController<SupplierEvaluationStepService,SupplierEvaluationStep>{
	@Autowired
	public SupplierEvaluationStepService SupplierEvaluationStepServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeSupplierEvaluationStepList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<SupplierEvaluationStep> ObeSupplierEvaluationStepList) {
		return SupplierEvaluationStepServices.insertByBatch(ObeSupplierEvaluationStepList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeSupplierEvaluationStepList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<SupplierEvaluationStep> ObeSupplierEvaluationStepList) {
		return SupplierEvaluationStepServices.updateByBatch(ObeSupplierEvaluationStepList);
	}
	
	/**
	 * @Description: 获得投标人的评标步骤
	 * @author wangxiang
	 * @param tenderId
	 * @param supplierId
	 * @param stepId
	 * @return
	 */
	@GetMapping("/getSupplierEvaluationStep")
	public SupplierEvaluationStep getSupplierEvaluationStep(String tenderId, String supplierId, String stepId) {
		QueryWrapper<SupplierEvaluationStep> wrapper = new QueryWrapper<SupplierEvaluationStep>();
		wrapper.lambda().eq(SupplierEvaluationStep::getTenderId, tenderId)
						.eq(SupplierEvaluationStep::getSupplierId, supplierId)
						.eq(SupplierEvaluationStep::getStepId, stepId);
		
		return SupplierEvaluationStepServices.getOne(wrapper);
	}
	
	@GetMapping("/getSupplierEvaluationStepByTenderId")
	public List<SupplierEvaluationStep> getSupplierEvaluationStepByTenderId(String tenderId){ 
		return SupplierEvaluationStepServices.getSupplierEvaluationStepByTenderId(tenderId);
	}
	@GetMapping("/getSupplierEvaluationStepByTenderIdAndSupplierId")
	public List<SupplierEvaluationStep> getSupplierEvaluationStepByTenderIdAndSupplierId(String tenderId,String supplierId){ 
		return SupplierEvaluationStepServices.getSupplierEvaluationStepByTenderIdAndSupplierId(tenderId, supplierId);
	}
	@GetMapping("/getSupplierEvaluationStepBySupplierIdAndStepId")
	public SupplierEvaluationStep getSupplierEvaluationStepBySupplierIdAndStepId(String supplierId,String stepId){ 
		return SupplierEvaluationStepServices.getSupplierEvaluationStepBySupplierIdAndStepId(supplierId, stepId);
	}
	
	
	@GetMapping("/getSupplierEvaluationStepByTenderIdAndStepId")
	public List<SupplierEvaluationStep> getSupplierEvaluationStepByTenderIdAndStepId(String tenderId,String StepId){ 
		return SupplierEvaluationStepServices.getSupplierEvaluationStepByTenderIdAndStepId(tenderId, StepId);
		
	}	
	
}