package com.gx.obe.server.management.supplier.entity;

import java.io.Serializable;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
/** 
 * @Description: 
 * @author mazc 
 */

@TableName("obe_supplier_evaluation_result")
public class SupplierEvaluationResult extends Model<SupplierEvaluationResult> {
	private static final long serialVersionUID=1L;

    /**
     * 投标人评标结果表主键
     */
            @TableId("EVALUATION_RESULT_ID")
                private String id;
    /**
     * 投标人外键
     */
    @TableField("SUPPLIER_ID")
        private String supplierId;
    /**
     * 项目外键
     */
    @TableField("TENDER_ID")
        private String tenderId;
    /**
     * 评标意见
     */
    @TableField("EVALUATION_OPINION")
        private String evaluationOpinion;
    /**
     * 招标文件要求
     */
    @TableField("BIDDING_REQUEST")
        private String biddingRequest;
    /**
     * 申请编辑供应商评审意见用户Id
     */
    @TableField("APPLY_USER_ID")
        private String applyUserId;
    /**
     * 供应商评审意见编辑者
     */
    @TableField("OPINION_EDITOR")
        private String opinionEditor;
    /**
     * 投标人评审得分
     */
    @TableField("EVALUATION_SCORE")
        private BigDecimal evaluationScore;
    /**
     * 投标人评审最终得分
     */
    @TableField("EVALUATION_FINAL_SCORE")
        private BigDecimal evaluationFinalScore;
    /**
     * 投标人评定结果
     */
    @TableField("ACCESSMENT")
        private String accessment;
    /**
     * 排序
     */
    @TableField("SORT_NO")
        private Integer sortNo;
    /**
     * 限中标推荐排序
     */
    @TableField("WIN_BID_SORT_NO")
        private Integer winBidSortNo;
    /**
     * 推荐结果
     */
    @TableField("RECOMMEND")
        private String recommend;
    /**
     * 首备选类型01首选;02备选
     */
    @TableField("CHOICE_TYPE")
        private String choiceType;
    /**
     * 限中标推荐结果
     */
    @TableField("WIN_BID_RECOMMEND")
        private String winBidRecommend;
    /**
     * 价格得分
     */
    @TableField("PRICE_SCORE")
        private BigDecimal priceScore;
    /**
     * 价格得分(加权重)
     */
    @TableField("PRICE_FINAL_SCORE")
        private BigDecimal priceFinalScore;
    @TableField("VETO_TYPE")
    private String vetoType;


 
    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getSupplierId(){
        return supplierId;
        }

        public void setSupplierId(String supplierId) {
        this.supplierId = supplierId;
        }

    public String getTenderId(){
        return tenderId;
        }

        public void setTenderId(String tenderId) {
        this.tenderId = tenderId;
        }

    public String getEvaluationOpinion(){
        return evaluationOpinion;
        }

        public void setEvaluationOpinion(String evaluationOpinion) {
        this.evaluationOpinion = evaluationOpinion;
        }

    public String getBiddingRequest(){
        return biddingRequest;
        }

        public void setBiddingRequest(String biddingRequest) {
        this.biddingRequest = biddingRequest;
        }

    public String getApplyUserId(){
        return applyUserId;
        }

        public void setApplyUserId(String applyUserId) {
        this.applyUserId = applyUserId;
        }

    public String getOpinionEditor(){
        return opinionEditor;
        }

        public void setOpinionEditor(String opinionEditor) {
        this.opinionEditor = opinionEditor;
        }

    public BigDecimal getEvaluationScore(){
        return evaluationScore;
        }

        public void setEvaluationScore(BigDecimal evaluationScore) {
        this.evaluationScore = evaluationScore;
        }

    public BigDecimal getEvaluationFinalScore(){
        return evaluationFinalScore;
        }

        public void setEvaluationFinalScore(BigDecimal evaluationFinalScore) {
        this.evaluationFinalScore = evaluationFinalScore;
        }

    public String getAccessment(){
        return accessment;
        }

        public void setAccessment(String accessment) {
        this.accessment = accessment;
        }

    public Integer getSortNo(){
        return sortNo;
        }

        public void setSortNo(Integer sortNo) {
        this.sortNo = sortNo;
        }

    public Integer getWinBidSortNo(){
        return winBidSortNo;
        }

        public void setWinBidSortNo(Integer winBidSortNo) {
        this.winBidSortNo = winBidSortNo;
        }

    public String getRecommend(){
        return recommend;
        }

        public void setRecommend(String recommend) {
        this.recommend = recommend;
        }

    public String getChoiceType(){
        return choiceType;
        }

        public void setChoiceType(String choiceType) {
        this.choiceType = choiceType;
        }

    public String getWinBidRecommend(){
        return winBidRecommend;
        }

        public void setWinBidRecommend(String winBidRecommend) {
        this.winBidRecommend = winBidRecommend;
        }

    public BigDecimal getPriceScore(){
        return priceScore;
        }

        public void setPriceScore(BigDecimal priceScore) {
        this.priceScore = priceScore;
        }

    public BigDecimal getPriceFinalScore(){
        return priceFinalScore;
        }

        public void setPriceFinalScore(BigDecimal priceFinalScore) {
        this.priceFinalScore = priceFinalScore;
        }

    public String getVetoType() {
			return vetoType;
		}

		public void setVetoType(String vetoType) {
			this.vetoType = vetoType;
		}

	public static final String EVALUATION_RESULT_ID ="EVALUATION_RESULT_ID";

    public static final String SUPPLIER_ID ="SUPPLIER_ID";

    public static final String TENDER_ID ="TENDER_ID";

    public static final String EVALUATION_OPINION ="EVALUATION_OPINION";

    public static final String BIDDING_REQUEST ="BIDDING_REQUEST";

    public static final String APPLY_USER_ID ="APPLY_USER_ID";

    public static final String OPINION_EDITOR ="OPINION_EDITOR";

    public static final String EVALUATION_SCORE ="EVALUATION_SCORE";

    public static final String EVALUATION_FINAL_SCORE ="EVALUATION_FINAL_SCORE";

    public static final String ACCESSMENT ="ACCESSMENT";

    public static final String SORT_NO ="SORT_NO";

    public static final String WIN_BID_SORT_NO ="WIN_BID_SORT_NO";

    public static final String RECOMMEND ="RECOMMEND";

    public static final String CHOICE_TYPE ="CHOICE_TYPE";

    public static final String WIN_BID_RECOMMEND ="WIN_BID_RECOMMEND";

    public static final String PRICE_SCORE ="PRICE_SCORE";

    public static final String PRICE_FINAL_SCORE ="PRICE_FINAL_SCORE";
    public static final String VETO_TYPE ="VETO_TYPE";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {//evaluationResultId
    return "SupplierEvaluationResult{" +
            ", id=" + id +
            ", supplierId=" + supplierId +
            ", tenderId=" + tenderId +
            ", evaluationOpinion=" + evaluationOpinion +
            ", biddingRequest=" + biddingRequest +
            ", applyUserId=" + applyUserId +
            ", opinionEditor=" + opinionEditor +
            ", evaluationScore=" + evaluationScore +
            ", evaluationFinalScore=" + evaluationFinalScore +
            ", accessment=" + accessment +
            ", sortNo=" + sortNo +
            ", winBidSortNo=" + winBidSortNo +
            ", recommend=" + recommend +
            ", choiceType=" + choiceType +
            ", winBidRecommend=" + winBidRecommend +
            ", priceScore=" + priceScore +
            ", priceFinalScore=" + priceFinalScore +
    "}";
    }
    }
