package com.gx.obe.server.management.supplier.entity;

import java.io.Serializable;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
/** 
 * @Description: 
 * @author mazc 
 */

@TableName("obe_supplier_evaluation_step")
public class SupplierEvaluationStep extends Model<SupplierEvaluationStep> {
	private static final long serialVersionUID=1L;

    /**
     * 投标人评标步骤主键
     */
            @TableId("SUPPLIER_STEP_ID")
                private String id;
    /**
     * 投标人外键
     */
    @TableField("SUPPLIER_ID")
        private String supplierId;
    /**
     * 项目外键
     */
    @TableField("TENDER_ID")
        private String tenderId;
    /**
     * 步骤外键
     */
    @TableField("STEP_ID")
        private String stepId;
    /**
     * 投标人评审意见
     */
    @TableField("SUPPLIER_OPINION")
        private String supplierOpinion;
    /**
     * 投标人当前评标步骤的评标标得分
     */
    @TableField("EVALUATION_SCORE")
        private BigDecimal evaluationScore;
    /**
     * 投标人当前评标步骤的最终得分
     */
    @TableField("EVALUATION_FINAL_SCORE")
        private BigDecimal evaluationFinalScore;
    /**
     * 投标人当前评标结论
     */
    @TableField("ACCESSMENT")
        private String accessment;
    /**
     * 进度状态
     */
    @TableField("STEP_STATUS")
        private String stepStatus;
    /**
     * 排名
     */
    @TableField("SORT_NO")
        private Integer sortNo;


 

    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getSupplierId(){
        return supplierId;
        }

        public void setSupplierId(String supplierId) {
        this.supplierId = supplierId;
        }

    public String getTenderId(){
        return tenderId;
        }

        public void setTenderId(String tenderId) {
        this.tenderId = tenderId;
        }

    public String getStepId(){
        return stepId;
        }

        public void setStepId(String stepId) {
        this.stepId = stepId;
        }

    public String getSupplierOpinion(){
        return supplierOpinion;
        }

        public void setSupplierOpinion(String supplierOpinion) {
        this.supplierOpinion = supplierOpinion;
        }

    public BigDecimal getEvaluationScore(){
        return evaluationScore;
        }

        public void setEvaluationScore(BigDecimal evaluationScore) {
        this.evaluationScore = evaluationScore;
        }

    public BigDecimal getEvaluationFinalScore(){
        return evaluationFinalScore;
        }

        public void setEvaluationFinalScore(BigDecimal evaluationFinalScore) {
        this.evaluationFinalScore = evaluationFinalScore;
        }

    public String getAccessment(){
        return accessment;
        }

        public void setAccessment(String accessment) {
        this.accessment = accessment;
        }

    public String getStepStatus(){
        return stepStatus;
        }

        public void setStepStatus(String stepStatus) {
        this.stepStatus = stepStatus;
        }

    public Integer getSortNo(){
        return sortNo;
        }

        public void setSortNo(Integer sortNo) {
        this.sortNo = sortNo;
        }

    public static final String SUPPLIER_STEP_ID ="SUPPLIER_STEP_ID";

    public static final String SUPPLIER_ID ="SUPPLIER_ID";

    public static final String TENDER_ID ="TENDER_ID";

    public static final String STEP_ID ="STEP_ID";

    public static final String SUPPLIER_OPINION ="SUPPLIER_OPINION";

    public static final String EVALUATION_SCORE ="EVALUATION_SCORE";

    public static final String EVALUATION_FINAL_SCORE ="EVALUATION_FINAL_SCORE";

    public static final String ACCESSMENT ="ACCESSMENT";

    public static final String STEP_STATUS ="STEP_STATUS";

    public static final String SORT_NO ="SORT_NO";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {//supplierStepId
    return "SupplierEvaluationStep{" +
            ", id=" + id +
            ", supplierId=" + supplierId +
            ", tenderId=" + tenderId +
            ", stepId=" + stepId +
            ", supplierOpinion=" + supplierOpinion +
            ", evaluationScore=" + evaluationScore +
            ", evaluationFinalScore=" + evaluationFinalScore +
            ", accessment=" + accessment +
            ", stepStatus=" + stepStatus +
            ", sortNo=" + sortNo +
    "}";
    }
    }
