package com.gx.obe.server.management.supplier.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.supplier.entity.AreaSupplier;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface AreaSupplierService extends IService<AreaSupplier> {
 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param AreaSupplierList 
	 */
 	Integer updateByBatch (List<AreaSupplier> AreaSupplierList);
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param AreaSupplierList 
	 */
	Integer insertByBatch (List<AreaSupplier> AreaSupplierList);
	
	
	
	/**
	 * @Description: 判断区内企业是否存在
	 * @author mazc
	 * @param areaSupplierName
	 * @param supplierType
	 * @return 
	 */
	boolean hasSupplier(String areaSupplierName, String supplierType);
	
	
	 /**
	 * @Description: 通过名字获取区内企业
	 * @author mazc
	 * @return 
	 */
	List<AreaSupplier> getAreaSupplierListByName();
	
	
	/**
	 * @Description: 保存下载区内企业信息
	 * @author mazc
	 * @param areaSupplier
	 * @return 
	 */
	String saveDownLoadAreaSupplier(AreaSupplier areaSupplier);
}



