package com.gx.obe.server.management.supplier.service;

import java.util.List;

import com.gx.obe.server.management.evaluation.entity.BidPriceResult;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.supplier.entity.SupplierOpeningResult;

/**
 * @Description:
 * @author mazc
 */
public interface SupplierOpeningResultService extends IService<SupplierOpeningResult> {
    
    /**
     * @Description: 批量插入
     * @author chenxw
     * @param ObeSupplierOpeningResultList
     * @return
     */
    int insertByBatch(@Param("ObeSupplierOpeningResultList") List<SupplierOpeningResult> ObeSupplierOpeningResultList);
    
    /**
     * @Description: 批量指定字段修改
     * @author mazc
     * @param strings
     * @param arg0
     * @param arg1
     * @return
     */
    int batchUpdateProperty(List<SupplierOpeningResult> supplierOpeningResultList, String[] attributes);
    
    /**
     * @Description: 指定字段修改
     * @author chenxw
     * @param supplierOpeningResult
     * @param attributes
     * @return 
     */
    boolean updateAssignProperty(SupplierOpeningResult supplierOpeningResult, String[] attributes);
    
    /**
     * @Description: 批量更新或插入
     * @author mazc
     * @param supplierList
     * @param attributes
     * @return
     */
    Integer batchSaveOrUpdate(List<SupplierOpeningResult> supplierList, String[] attributes);
    
    /**
     * @Description: 修改供应商的总价
     * @author guoyr
     * @param tenderId
     * @param bidPrice
     * @param evalPrice
     */
    Integer updateSupplierSumPrice(String tenderId, boolean bidPrice, boolean evalPrice);
    
    /**
     * @Description: 修改供应商的总价
     * @author mazc
     * @param tenderId
     * @param supplierId
     * @param bidPrice
     * @param evalPrice
     */
    Integer updateSupplierSumPrice(String tenderId, String supplierId, boolean bidPrice, boolean evalPrice);


    Integer updateSupplierPrice(BidPriceResult ObeBidPriceResult, String[] attributes);
    
    /**
     * @Description: 获取投标人开标结果
     * @author wangxiang
     * @param tenderId
     * @param supplierId
     * @return
     */
    SupplierOpeningResult getSupplierOpeningResult(String tenderId, String supplierId);
    
    /**
     * @Description: 获得开标结果主键
     * @author wangxiang
     * @param tenderId
     * @param supplierId
     * @return
     */
    String getSupplierOpeningResultId(String tenderId, String supplierId);
    
    SupplierOpeningResult saveOrUpdateNoEmptyReturn(SupplierOpeningResult supplierOpeningResult);
    
    List<SupplierOpeningResult> getSupplierOpeningResultListByTenderId(String tenderId);
    
    List<SupplierOpeningResult> getSupplierOpeningResultListByTenderIdAndBidOpeningStatus(String tenderId, String bidOpeningStatus);

    /**
     * @Description: 汇总并更新修正投标报价原因
     * @param tenderId
     * @param supplierId
     * @return
     */
    boolean updateSumModifyReason(String tenderId, String supplierId);
}
