package com.gx.obe.server.management.table.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.table.entity.ObeBidPriceTableValue;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
public interface ObeBidPriceTableValueService extends IService<ObeBidPriceTableValue> {

    /**
     * @param ObeBidPriceTableValueList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeBidPriceTableValue> ObeBidPriceTableValueList);

    /**
     * @param ObeBidPriceTableValueList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeBidPriceTableValue> ObeBidPriceTableValueList);

    /**
     * @param ObeBidPriceTableValue
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeBidPriceTableValue ObeBidPriceTableValue, String[] attributes);

    /**
     * @param ObeBidPriceTableValueList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeBidPriceTableValue> ObeBidPriceTableValueList, String[] attributes);

    /**
     * @param ObeBidPriceTableValueList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeBidPriceTableValue> ObeBidPriceTableValueList, String[] attributes);

    /**
     * @param priceTableId
     * @return
     * @Description: 根据报价表id获取
     * @author chenxw
     */
    List<ObeBidPriceTableValue> getByPriceTableId(String priceTableId);

}



