package com.gx.obe.server.management.user.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.vo.RequestBodyEntity;
import com.gx.obe.server.management.user.entity.AuthRoleEntity;
import com.gx.obe.server.management.user.entity.AuthUserRoleEntity;
import com.gx.obe.server.management.user.service.AuthUserRoleService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;

 /**  
 * 
 * @author 
 * @Title: AuthUserRoleController  
 * @Package com.gx.obe.server.management.user.controllers   
 * @Description:   
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date:   2019-04-29   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
@Api(tags = "用户角色管理")
@RestController
@AllArgsConstructor
@RequestMapping("/authUserRole")
public class AuthUserRoleController {
	
	@Autowired
	private AuthUserRoleService authUserRoleService;
	
	@PostMapping("/batchSave")
	public int batchCreateSave(@RequestBody List<AuthUserRoleEntity> ROLE_LIST) {	
		return authUserRoleService.batchCreateSave(ROLE_LIST);
	}

	@GetMapping("/initUserRole")
	public int initUserRole(String userId, String roleCode,String createUserId){
		return authUserRoleService.initUserRole(userId, roleCode, createUserId);
	} 
	
	/**
	 * @Description: 获得用户拥有的角色Id
	 * @author mazc
	 * @param userId
	 * @return 
	 */
	@GetMapping("/getUserRoleIdList")
	public List<String> getUserRoleIdList(String userId){
		return authUserRoleService.getUserRoleIdList(userId);
	}
	
	/**
	 * @Description: 为用户授权
	 * @author mazc
	 * @param requestBodyEntity
	 * @return 
	 */
	@PostMapping("/authorizedRoleForUser")
	public boolean authorizedRoleForUser(@RequestBody RequestBodyEntity<AuthRoleEntity> requestBodyEntity){
		String userId = (String) requestBodyEntity.getParam("userId");
		String curUserIs =(String) requestBodyEntity.getParam("curUserIs");
		List<AuthRoleEntity> roleList = requestBodyEntity.getEntityList();
		return authUserRoleService.authorizedRoleForUser(userId, roleList, curUserIs);
	}
	
}