package com.gx.obe.server.management.user.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.user.entity.AuthLoginRecordEntity;

 /**  
 * 
 * @author 
 * @Title: AuthLoginRecordEntity
 * @Package com.gx.obe.server.management.user.entity  
 * @Description:   AuthLoginRecordMapper 接口
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date:   2019-05-08   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
 @Mapper
public interface AuthLoginRecordMapper extends BaseMapper<AuthLoginRecordEntity> {
	 
	 
	 /**
	 * @Description: 根据项目id获取项目经理登录信息
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	AuthLoginRecordEntity getLoginRecordByTenderId(@Param("tenderId")String tenderId);
	
	void logout(@Param("account")String account, @Param("sysType")String sysType, @Param("loginRecordId")String loginRecordId);
	
	
	/**
	 * @Description: 获得评标室已登录的专家记录
	 * @author mazc
	 * @param evaluationRoomId
	 * @return 
	 */
	List<AuthLoginRecordEntity> getLoginRecordByEvalBidRoomId(@Param("evaluationRoomId")String evaluationRoomId);
	
	/**
	 * @Description:  是否已被注销
	 * @author mazc
	 * @param account
	 * @param sysType
	 * @param loginRecordId
	 * @return 
	 */
	Integer isLogout(@Param("account")String account,  @Param("sysType")String sysType ,@Param("loginRecordId") String loginRecordId);

}