package com.gx.obe.server.management.user.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.user.entity.AuthLoginRecordEntity;
 
 /**  
 * 
 * @author 
 * @Title: AuthLoginRecordService
 * @Package com.gx.obe.server.management.user.service  
 * @Description:    
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date:   2019-05-08   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
public interface AuthLoginRecordService extends IService<AuthLoginRecordEntity> {
	
	void deleteAccountByLoginInfo(String userAccount , String loginSysType);
	
	int insert(AuthLoginRecordEntity authLoginRecordEntity);
	
	/**
	 * @Description: 根据项目id获取项目经理登录信息
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	AuthLoginRecordEntity getLoginRecordByTenderId(String tenderId);
	
	/**
	 * @Description: 退出登录
	 * @author mazc
	 * @param account
	 * @param sysType
	 * @param loginRecordId 
	 */
	void logout(String account, String sysType, String loginRecordId,String applyUserId);
	
	
	/**
 	 * @Description: 获得评标室已登录的专家记录
 	 * @author mazc
 	 * @param evaluationRoomId
 	 * @return 
 	 */
 	List<AuthLoginRecordEntity> getLoginRecordByEvalBidRoomId(String evaluationRoomId);
 	
	/**
	 * @Description: 获得评标室已登录的专家记录
	 * @author mazc
	 * @param evaluationRoomId
	 * @return 
	 */
	List<AuthLoginRecordEntity> getLoginRecordAllList();
	
	/**
	 * @Description:  是否已被注销
	 * @author mazc
	 * @param account
	 * @param sysType
	 * @param loginRecordId
	 * @return 
	 */
	boolean isLogout(String account, String sysType ,String loginRecordId);
}

